/*	MiscTDScrollView.m

	Copyright 1996 Uwe Hoffmann.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

	Version 2 (August 1996)
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

#import "MiscTDScrollView.h"
#import "MiscTreeDiagramView.h"

#define CLAMP(a,x,y) (MAX((x), MIN((y), (a))))

@implementation MiscTDScrollView

- (void)zoom:sender
{
        NSString *title;
        float scale;
        
        title = [[sender selectedCell] title];
        if([title isEqualToString:@"Fit"])
            [[self documentView] zoomToFit:sender];
        else if([title isEqualToString:@"Set..."]){
                [zoomText selectText:self];
                [zoomPanel makeKeyAndOrderFront:self];
                [NSApp runModalForWindow:zoomPanel];
                [zoomPanel close];
                scale = CLAMP([zoomText intValue],10,1600);
                [[self documentView] zoomToFactor:scale / 100.0 andUpdate:sender];
        } else 
        	[[self documentView] zoomToFactor:[title intValue] / 100.0];
}

- (void)stopZoomPanel:(id)sender
{
	[NSApp stopModal];    
}

- (NSPopUpButton *)zoomButton
{
	return (NSPopUpButton *)zoomButton;
}

- (void)tile
{
	NSRect zoomButtonRect, hRect;
	NSScroller *hScroller = [self horizontalScroller];

	[super tile];
	zoomButtonRect = [zoomButton frame];
	hRect = [hScroller frame];
	if(hRect.size.width - zoomButtonRect.size.width > 72){
		NSDivideRect(hRect,&zoomButtonRect,&hRect,zoomButtonRect.size.width,NSMaxXEdge);
		[hScroller setFrame:hRect];
		zoomButtonRect.origin.y += 1;
		zoomButtonRect.size.height -= 2;
		[zoomButton setFrame:zoomButtonRect];
	} else {
            	zoomButtonRect.origin.x = -1000;
                zoomButtonRect.origin.y = -1000;
		[zoomButton setFrame:zoomButtonRect];
        }
}		

- (void)awakeFromNib
{
	[self addSubview:zoomButton];
        [self tile];
}

@end

