/*	MiscTDVPrivate.h

	Copyright 1996 Uwe Hoffmann.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

	Version 2 (August 1996)
*/

#import "MiscTreeDiagramView.h"

@interface MiscTreeDiagramView(PrivateMethods)

- (BOOL)_internalResizeAndPosTree:(MiscDiagramTree *)aTree force:(BOOL)aBOOL;
- (void)_internalInit;
- (void)_internalUpdateCanvasPos:(float)xPos :(float)yPos;
- (void)_internalDrawTree:(MiscDiagramTree *)tree inRect:(NSRect)r;
- (BOOL)_internalCopyToPasteboard:(NSPasteboard *)pb;
- (BOOL)_internalPasteFromPasteboard:(NSPasteboard *)pb;
+ (void)_internalConvert:(NSData *)data toPostscriptPasteboard:(NSPasteboard *)pb;
+ (void)_internalConvert:(NSData *)data toAsciiPasteboard:(NSPasteboard *)pb;
- (void)_internalResize:(MiscDiagramTree *)node event:(NSEvent *)event control:(int)aInt;
- (void)_internalRearange:(MiscDiagramTree *)node event:(NSEvent *)event;
- (void)_internalStartLabelEditingFor:(MiscDiagramTree *)node event:(NSEvent *)event :(BOOL)mouseDown;
- (void)_internalLabelEditingFrameChanged:(NSNotification *)notification;
- (void)_internalKeyNavigate:(MiscDiagramTree *)node direction:(unichar)aChar;
- (void)_internalFillBuffer;
- (void)_internalComposite:(NSRect)r fromBufferBy:(int)op;

@end
