/*========================= MiscCartesianCoord.h ============================*/
/* MiscCartesianCoord class contains and supports values representing
   locations in a Cartesian coordinate system

   DMA Release 0.8, Copyright @1993 by Genesis Project, Ltd. All Rights
   Reserved. For further information on terms and conditions see
		the MiscKit license.

HISTORY
25-Feb-93  Dale Amon at GPL
	   Created.
*/

#import <Foundation/Foundation.h>
#import <MiscFoundation/MiscMathCoord.h>

/* ordering of coordinates in storage */
#define MISC_X_COORD		0
#define MISC_Y_COORD		1
#define MISC_Z_COORD		2

@interface MiscCartesianCoord:MiscMathCoord
{

}

- setCoordx: (double)  x y: (double)  y z: (double)  z;
- coordx:    (double*) x y: (double*) y z: (double*) z;

- (double) xCoord;
- (double) yCoord;
- (double) zCoord;

@end
