/*=========================== MiscMathCoord.m ===============================*/
/* MiscMathCoord is an abstract superclass that supports creation of common
   mathematical coordinate systems.

   DMA Release 0.8, Copyright @1993 by Genesis Project, Ltd. All Rights
   Reserved. For further information on terms and conditions see
		the MiscKit license.

HISTORY
21-Mar-93  Dale Amon at GPL
	   Created.
*/

#import "MiscMathCoord.h"
#import "MiscMathCoordConverter.h"
#import "_MiscError.h"

@implementation MiscMathCoord

/*===========================================================================*/
/* Initialization methods */
/*===========================================================================*/
/* DESIGNATED INITIALIZER */

-initDescription: (NSString *) txt constants: anObject
 {return 
	[super initDescription: txt
		     converter: [MiscMathCoordConverter new]
		     constants: anObject];
 }


/*---------------------------------------------------------------------------*/
/* Block the designated initializer of our parent class */

-initDescription: (NSString *) txt
       converter: (id <MiscCoordConverterServer>) aConverter
       constants: anObject
{	MISC_ERROR_BAIL;
	return self;
 }


@end
