/*  Class to act as a cover for Internet addresses.
 *
 *  Copyright (c) 1996 Aleksey Sudakov <zander@cnext.crec.mipt.ru>.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement. Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version 1.0 BETA (16 December 1995)
 */

#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#import <sys/types.h>
#import <netinet/in.h>

@interface MiscINETAddress:NSObject <NSCopying, NSCoding>
{
	struct in_addr address;
	NSString *hostname;
}

+ localAddress;
+ addressFromCStringHostname:(const char *)name;
+ addressFromHostname:(NSString *)name;

- init;
- initWithCoder:(NSCoder *)coder;
- (void)encodeWithCoder:(NSCoder *)coder;

- initFromCStringHostname:(const char *)name;
- initTo:(struct in_addr)addr;

- copy;
- copyWithZone:(NSZone*)zone;

- (struct in_addr)address;
- (NSString *)hostname;
- (NSString *)stringAddress;
- (char *)cStringAddress;

@end
//
//	TODO: get rid of - free
//