/*  Abstract class to act as a cover for sockets.
 *
 *  Copyright (c) 1996 Aleksey Sudakov <zander@cnext.crec.mipt.ru>.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement. Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version 1.0 BETA (16 December 1995)
 */

#import <Foundation/NSObject.h>
#import <sys/socket.h>

enum {	/* Values for type parameter */
	MiscSOCK_RAW, MiscSOCK_DGRAM, MiscSOCK_STREAM
};

@interface MiscSocket:NSObject <NSCopying, NSCoding>
{
	int sock;
	int domain;
	int type;
}

- init;
- initWithCoder:(NSCoder *)coder;
- (void)encodeWithCoder:(NSCoder *)coder;

- initDomain:(int)aDomain type:(int)aType;
- close;

- copy;
- copyWithZone:(NSZone *)zone;

- (BOOL)isClosed;
- (int)domain;
- (int)socket;
- (int)type;

@end

//
//	TODO:
//