/*	MiscNotificationCenter.h

	Copyright 1995 Christopher J. Kane.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

	Version 1 (1 February 1995)
	    - Hidden object functionality added
*/

#import <Foundation/NSNotification.h>

@interface MiscNotificationCenter : NSNotificationCenter
{
    id _hiddenObjectsWithNil;
    id _hiddenObjectsWithProxies;
}

/* Support registration of objects which are "masked" from notifications */
- (void)addHiddenObject:(id)anObject withProxy:(id)aProxy;
- (void)removeHiddenObject:(id)anObject;

@end
