/*	MiscNumberSkipList.m

	Copyright 1996 Uwe Hoffmann.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

	Version 2 (August 1996)
*/

#import <Foundation/Foundation.h>

#import "MiscNumberSkipList.h"

@implementation MiscNumberSkipList

- (NSComparisonResult)compareNode:(MiscSkipListNode *)p withObject:anObject
{
	if(!p)
		return NSOrderedDescending;
	return [(NSNumber *)p->nodeObject compare:(NSNumber *)anObject];
}	

- (void)checkArgument:anObject
{
	if(!anObject)
		[NSException raise:NSInvalidArgumentException format:@"Argument is nil"];
	if(![anObject isKindOfClass:[NSNumber class]])
		[NSException raise:NSInvalidArgumentException format:@"Argument is not a NSNumber"];
	return;
}

@end
