/*	MiscRandomLevelProvider.m

	Copyright 1996 Uwe Hoffmann.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

	Version 2 (August 1996)
*/

#import <Foundation/Foundation.h>

#import "MiscRandomLevelProvider.h"
#import "Miscskiplist.h"

@implementation MiscRandomLevelProvider

- init
{
	long r = MISC_SKIPLIST_PB;
	
	randomBits = rand();
	randomShift = 0;
	while(r >>= 1)
		randomShift++;
	randomsLeft = MISC_SKIPLIST_RANDSIZEINBITS / randomShift;
	return self;
}

- (int)randomLevel
{
	int newLevel;
	long b;
 
	newLevel = 1;
	do {
		b = randomBits & MISC_SKIPLIST_RANDMASK;
		if(!b)
			newLevel++;
		randomBits >>= randomShift;
		if(--randomsLeft == 0){
			randomBits = rand();
			randomsLeft = MISC_SKIPLIST_RANDSIZEINBITS / randomShift;
		}
	} while(!b);
	return (newLevel > MISC_SKIPLIST_MAXLEVELS ? MISC_SKIPLIST_MAXLEVELS : newLevel);		
}

@end
