/*	MiscStringSkipList.m

	Copyright 1996 Uwe Hoffmann.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

	Version 2 (August 1996)
*/

#import <Foundation/Foundation.h>

#import "MiscStringSkipList.h"

@implementation MiscStringSkipList

- init
{
	self = [super init];
	options = 0;
	range.location = 0;
	range.length = 0;
	compareMode = 1;
	return self;
}

- initOptions:(unsigned)mask
{
	self = [super init];
	options = mask;
	range.location = 0;
	range.length = 0;
	compareMode = 2;
	return self;
}

- initOptions:(unsigned)mask range:(NSRange)aRange
{
	self = [super init];
	options = mask;
	range = aRange;
	compareMode = 3;
	return self;
}

- (NSComparisonResult)compareNode:(MiscSkipListNode *)p withObject:anObject
{
	NSComparisonResult result = NSOrderedDescending;
	
	if(!p)
		return NSOrderedDescending;
	switch(compareMode){
		case 1:
			result = [(NSString *)p->nodeObject compare:(NSString *)anObject];
			break;
		case 2:
			result = [(NSString *)p->nodeObject compare:(NSString *)anObject options:options];
			break;
		case 3:
			result = [(NSString *)p->nodeObject compare:(NSString *)anObject options:options range:range];
			break;
		default:
			break;
	}
	return result;
}	

- (void)checkArgument:anObject
{
	if(!anObject)
		[NSException raise:NSInvalidArgumentException format:@"Argument is nil"];
	if(![anObject isKindOfClass:[NSString class]])
		[NSException raise:NSInvalidArgumentException format:@"Argument is not a NSString"];
	return;
}

@end
