/*	Miscskiplist.h

	Copyright 1996 Uwe Hoffmann.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

	Version 2 (August 1996)
*/

#import <Foundation/Foundation.h>

#define MISC_SKIPLIST_P			0.25
#define MISC_SKIPLIST_PB		4
#define MISC_SKIPLIST_MAXLEVELS		16
#define MISC_SKIPLIST_RANDSIZEINBITS	(sizeof(long) * 8)
#define MISC_SKIPLIST_RANDMASK		3

typedef struct _MiscSkipListNode {
	id nodeObject;
	struct _MiscSkipListNode **nodeForwards;
} MiscSkipListNode;

MiscSkipListNode *miscAllocSkipListNode(NSZone *zone, int nrLevels, id object);
void miscFreeSkipListNode(NSZone *zone, MiscSkipListNode *aNode);
void miscCutSkipListNode(MiscSkipListNode *aNode, int nrLevels);