/*	Miscskiplist.m

	Copyright 1996 Uwe Hoffmann.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

	Version 2 (August 1996)
*/


#import "Miscskiplist.h"

MiscSkipListNode *miscAllocSkipListNode(NSZone *zone, int nrLevels, id object)
{
	MiscSkipListNode *aNode;
	int i;
	
	aNode = (MiscSkipListNode *)NSZoneMalloc(zone,sizeof(MiscSkipListNode));
	aNode->nodeForwards = (MiscSkipListNode **)NSZoneMalloc(zone,sizeof(MiscSkipListNode *) * nrLevels);
	aNode->nodeObject = object;
	for(i = 0;i < nrLevels;i++)
		aNode->nodeForwards[i] = NULL;
	return aNode;
}
	
void miscFreeSkipListNode(NSZone *zone,MiscSkipListNode *aNode)
{
	NSZoneFree(zone,aNode->nodeForwards);
	NSZoneFree(zone,aNode);
	return;
}

void miscCutSkipListNode(MiscSkipListNode *aNode, int nrLevels)
{
	int i;
	
	for(i = 0;i < nrLevels;i++)
		aNode->nodeForwards[i] = NULL;
	return;
}
