
//  Donated by Henry Krempel <krempel@chezhank.com>


#import "NSDictionary_WriteCopy.h"
#import <Foundation/Foundation.h>

@implementation NSDictionary(WriteCopy)

- deepMutableCopyWithZone:(NSZone *)z;
{
	int count = [self count];
	NSMutableDictionary *out = [[[NSMutableDictionary allocWithZone:z]
		initWithCapacity:count] autorelease];
	if (count)
	{
		id keyEnumerator, objectEnumerator;
		id key, value;
		keyEnumerator = [self keyEnumerator];
		objectEnumerator = [self objectEnumerator];
		while ((key = [keyEnumerator nextObject]) && 
			(value = [objectEnumerator nextObject]))
		{
			id newValue = nil;
			if ([value isKindOfClass:[NSDictionary class]])
				newValue = [value deepMutableCopyWithZone:z];
			else if ([value respondsToSelector:@selector(deepMutableCopyWithZone:)])
				newValue = [value deepMutableCopyWithZone:z];
			else if ([value respondsToSelector:@selector(mutableCopyWithZone:)])
				newValue = [value mutableCopyWithZone:z];
			else
				newValue = value;
			[out setObject:newValue forKey:key];
		}
	}
	return out;
}
	
- deepMutableCopy;
{
	return [self deepMutableCopyWithZone:[self zone]];
}

@end

@implementation NSArray(WriteCopy)

- deepMutableCopyWithZone:(NSZone *)z;
{
	int count = [self count];
	NSMutableArray *out = [[[NSMutableArray allocWithZone:z]
		initWithCapacity:count] autorelease];
	if (count)
	{
		NSEnumerator *objectEnumerator;
		id value;
		objectEnumerator = [self objectEnumerator];
		while ((value = [objectEnumerator nextObject]))
		{
			id newValue = nil;
			if ([value isKindOfClass:[NSArray class]])
				newValue = [value deepMutableCopyWithZone:z];
			else if ([value respondsToSelector:@selector(deepMutableCopyWithZone:)])
				newValue = [value deepMutableCopyWithZone:z];
			else if ([value respondsToSelector:@selector(mutableCopyWithZone:)])
				newValue = [value mutableCopyWithZone:z];
			else
				newValue = value;
			[out addObject:newValue];
		}
	}
	return out;
}
	
- deepMutableCopy;
{
	return [self deepMutableCopyWithZone:[self zone]];
}

@end