/*
   MiscArrowButtonInspector.h
   PROGRAMMER:	Todd Thomas
   CREATED:		Dec 30, 1993
*/

#import <InterfaceBuilder/IBInspector.h>

#define IBOutlet


@interface MiscArrowButtonInspector : IBInspector
{
    IBOutlet NSMatrix* optionMatrix;	/*" Bordered, transparent, etc. "*/
    IBOutlet NSFormCell* tagField;	    /*" The button's tag. "*/
    IBOutlet NSFormCell* titleField;	/*" Title field "*/
    IBOutlet NSFormCell* altTitleField; /*" altTitle field "*/
    IBOutlet NSFormCell* soundField;	/*" Button's sound "*/
    IBOutlet NSMatrix* alignMatrix;		/*" Button's current alignment "*/
}

/*" Initialization/deallocation "*/
- (id) init;

/*" Display update "*/
- (void) revert: sender;

/*" Actions "*/
- (void) optionsChanged: sender;
- (void) tagChanged: sender;
- (void) titleChanged: sender;
- (void) altTitleChanged: sender;
- (void) soundChanged: sender;
- (void) alignmentChanged: sender;

/*" Overridden "*/
- (BOOL) wantsButtons;

@end
