
/*
   MiscGaugeViewInspector.h
*/

#import <InterfaceBuilder/IBInspector.h>

#define IBOutlet


@interface MiscGaugeViewInspector : IBInspector
{
    IBOutlet NSForm* attribsForm;			// Form with all the gauge's attributes.
    IBOutlet NSColorWell* gaugeColorWell;
    IBOutlet NSColorWell* textColorWell;
    IBOutlet NSForm* valueForm;				// Form with min, max and current value.
	IBOutlet NSMatrix* sliderMatrix;	   	// Matrix of sliders to match the attribsForm.
	IBOutlet NSTextField* titleField;	 	// Textfield containing the gauge's title.
	IBOutlet NSMatrix* titlePositionMatrix;	// Matrix of 2 buttons for title position.
}

- (id) init;

- (void) attribChanged:(id)sender;
- (void) sliderChanged:(id)sender;

- (void) backgroundColorChanged:(id)sender;
- (void) gaugeColorChanged:(id)sender;
- (void) textColorChanged:(id)sender;
- (void) valueChanged:(id)sender;

- (void) titleFieldChanged:(id)sender;
- (void) titlePositionChanged:(id)sender;

- (void) revert:(id)sender;
- (BOOL) wantsButtons;

@end


@interface MiscGaugeViewInspector (NibInitialization)

- (void) awakeFromNib;

@end

