//
// Time-stamp: <94/11/26 18:02:33 stephan>
//
//	MiscClassDecoder.h -- an Object subclass that is able to analyze
//	the definition of an Objective-C class.
//	
//		Written by Stephan Wacker <stephan@rodion.muc.de>
//		Copyright (c) 1994 by Stephan Wacker.
//		Version 1.0  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


// Change this version number whenever you modify any instance variables!
//
#define K_MiscClassDecoderVersion	2


// Define the archived fields:
//
#define K_MiscClassDecoderRWformat_V1	"@@"
#define K_MiscClassDecoderRWvars_V1	&classNameField, &text


#import <AppKit/AppKit.h>


@interface MiscClassDecoder : NSObject <NSCoding>
{
    id		classNameField;
    id		text;
    NSMutableString* string;
    
    int		indent;		// indent depth in characters
    BOOL	bol;		// beginning of line

    int		lineCount;
}

- (void)analyze:sender;
- (void)list:sender;

- (void)analyzeClass:(NSString *)className;

@end	// MiscClassDecoder
