
/*
**	MiscSwitchView.h 
**	Copyright (C) 1995  David Slotnick 
*/

// NeXT Headers

// System Headers

// ThirdParty Headers

// Other Headers

// Superclass Headers
#import <AppKit/NSBox.h>

// Forward Class Declarations
@class NSMutableArray;
@class NSView;

// Public Constants
extern int MiscSwitchViewNoViewVisible;



@interface MiscSwitchView:NSBox
{
@private
   NSMutableArray* 		_views;			/*" Array of views to be switched. "*/
	id					_delegate;		/*" Delegate. "*/
}

/*" Accessor methods "*/
- (void) setViews:(NSMutableArray*)views;
- (NSMutableArray*) views;
- (void) setDelegate:(id)delegate;
- (id) delegate;

/*" Initialization / deallocation "*/
- (id) initWithFrame:(NSRect)frameRect;
- (void) dealloc;

/*" Manipulating subviews "*/
- (void) addView;
- (void) insertViewAtIndex:(int)index; 
- (void) displayViewAtIndex:(int)index;
- (void) deleteViewAtIndex:(int)index;
- (int) viewCount;
- (NSView*) viewAtIndex:(int)index;

/*" Obtaining indexes "*/
- (int) firstIndex;
- (int) lastIndex;
- (int) indexBefore:(int)index;
- (int) indexAfter:(int)index;
- (int) indexOfVisibleView;
- (BOOL) isIndexValid:(int)index;

/*" Contol interoperability "*/
- (void) takeIntValueFrom:(id)sender;
- (void) takeStringValueFrom:(id)sender;
- (void) takeFloatValueFrom:(id)sender;
- (void) takeDoubleValueFrom:(id)sender;
- (void) takeTagValueFrom:(id)sender;
- (void) takeSelectedTagValueFrom:(id)sender;

/*" Archiving "*/
- (id) initWithCoder:(NSCoder*)coder;
- (void) encodeWithCoder:(NSCoder*)coder;

// Added to fix IB bug [dls 4/30/96].
- (void) resetObjectHierarchy;
// End added [dls 4/30/96].

@end


/*" Switch View Delegate Methods "*/

@protocol MiscSwitchViewDelegates
- (BOOL) switchView:(MiscSwitchView*)sender willInsertViewAtIndex:(int)index;
- (void) switchView:(MiscSwitchView*)sender didInsertViewAtIndex:(int)index;
	
- (BOOL) switchView:(MiscSwitchView*)sender willDeleteViewAtIndex:(int)index;
- (void) switchView:(MiscSwitchView*)sender didDeleteViewAtIndex:(int)index;
	
- (BOOL) switchView:(MiscSwitchView*)sender willDisplayViewAtIndex:(int)index;
- (void) switchView:(MiscSwitchView*)sender didDisplayViewAtIndex:(int)index;

- (BOOL) switchViewWillAddView:(MiscSwitchView*)sender;
- (void) switchViewDidAddView:(MiscSwitchView*)sender;
@end
