
/*
**	MiscSwitchViewInspector.h 
**	Copyright (C) 1995  David Slotnick 
*/

// NeXT Headers

// System Headers

// ThirdParty Headers

// Other Headers

// Superclass Headers
#import <InterfaceBuilder/IBInspector.h>

// Forward Class Declarations
@class NSTextField;
@class MiscSwitchView;


@interface MiscSwitchViewInspector:IBInspector
{
#ifdef IB_OUTLETS
    id 	currentViewTF;		/*" Bogus outlet for IB. "*/
    id 	viewCountTF;		/*" Bogus outlet for IB. "*/
#endif

@private
    NSTextField*	_currentViewTF;		/*" Indicates the currently 
                                            displayed view index. "*/
    NSTextField*	_viewCountTF;	    /*" Indicates the number of subviews
                                            managed by the MiscSwitchView. "*/
    
}

/*" Accessor methods "*/
- (void) setCurrentViewTF:(NSTextField*)currentViewTF;
- (NSTextField*) currentViewTF;
- (void) setViewCountTF:(NSTextField*)viewCountTF;
- (NSTextField*) viewCountTF;

/*" Derived accessors "*/
- (MiscSwitchView*) switchView;

/*" Initialization / deallocation "*/
- (id) init;
- (void) dealloc;

/*" Adding and deleting subviews "*/
- (void) addView:(id)sender;
- (void) insertView:(id)sender;
- (void) deleteView:(id)sender;
- (void) setCurrentView:(id)sender;
- (void) nextView:(id)sender;
- (void) previousView:(id)sender;

/*" IBInspector methods "*/
- (void) revert:(id)sender;
- (BOOL) wantsButtons;

@end