
/*
**	MiscSwitchViewPalette.m 
**	Copyright (C) 1995  David Slotnick 
*/

// RCS identification information
static char *rcsID = "$Id: MiscSwitchViewPalette.m,v 1.1 1996/08/06 03:37:01 slotnick Exp $";
static void __AvoidCompilerWarning(void) {if(!rcsID)__AvoidCompilerWarning();}

// NeXTSTEP Headers
#import <InterfaceBuilder/InterfaceBuilder.h>

// System Headers

// Third Party Headers

// Other Headers
#import "MiscSwitchView.h"

// Class Headers
#import "MiscSwitchViewPalette.h"

// Private Constants

// Private Macros

// Module variables (static variables)



@implementation MiscSwitchViewPalette

/*"
   The MiscSwitchViewPalette's #finishInstantiate method associates the switch view image (the view superimposed with a switch, not the cool black swirl icon)  with the switch view instance in the InterfaceBuilder palette window.
"*/


//-------------------------------------------------------------------
// 	Accessor methods
//-------------------------------------------------------------------

- (void) setSwitchView:(MiscSwitchView*)switchView
/*"
   Sets the switch view to switchView.
"*/
{
    [_switchView autorelease];
    _switchView = [switchView retain];
}

- (MiscSwitchView*) switchView
/*" 
    Returns the switch view.
"*/
{
    return _switchView;
}

- (void) setSwitchViewImage:(NSImageView*)switchViewImage
/*" 
    Sets the switch view image to switchViewImage.
"*/
{
    [_switchViewImage autorelease];
    _switchViewImage = [switchViewImage retain];
}

- (NSImageView*) switchViewImage
/*"
   Returns the switch view image.
"*/
{
    return _switchViewImage;
}


//-------------------------------------------------------------------
// 	Initialization / deallocation
//-------------------------------------------------------------------

- (void) dealloc
/*"
   Standard deallocator.
"*/
{
    [_switchView autorelease];
    [_switchViewImage autorelease];

    [super dealloc];
}

//-------------------------------------------------------------------
// 	IBPalette methods
//-------------------------------------------------------------------

- (void) finishInstantiate
/*"
    Associates the MiscSwitchView object with its image in the IB palette.
"*/
{
    [self associateObject:[self switchView]
                   ofType:IBViewPboardType
                 withView:[self switchViewImage]];
}

@end
