
/*
**	MiscSwitchView_IBSupport.m 
**	Copyright (C) 1995  David Slotnick 
*/

// RCS identification information
static char *rcsID = "$Id: MiscSwitchView_IBSupport.m,v 1.1 1996/08/06 03:37:03 slotnick Exp $";
static void __AvoidCompilerWarning(void) {if(!rcsID)__AvoidCompilerWarning();}

// NeXTSTEP Headers
#import <InterfaceBuilder/InterfaceBuilder.h>

// System Headers

// Third Party Headers

// Other Headers

// Class Headers
#import "MiscSwitchView_IBSupport.h"

// Private Constants

// Private Macros

// Module variables (static variables)



@implementation MiscSwitchView (IBSupport)

/*"
   This category contains IB-specific support methods.  
"*/


//-------------------------------------------------------------------
// 	Accessing the inspector class name
//-------------------------------------------------------------------

- (NSString *) inspectorClassName
/*"
   Returns the IB inspector class for the MiscSwitchView, or the inspector for the NSBox class if the alternate key is depressed.  This allows you to inspect a MiscSwitchView with the NSBox inspector by alt-clicking the switch view in IB.
"*/
{
	NSEvent*	event = [[NSApplication sharedApplication] currentEvent];
    NSString*	inspectorClassName = @"MiscSwitchViewInspector";

    if ([event modifierFlags] & NSAlternateKeyMask) {
        inspectorClassName = @"IBBoxInspector";
	}

    return inspectorClassName;
}

@end
