//=============================================================================
//
//		Copyright (C) 1995,1996 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//
//=============================================================================
//-----------------------------------------------------------------------------
// DirWindow.h
//
//		Manages window which displays directory listing.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id$
// $Log$
//-----------------------------------------------------------------------------
#import <Foundation/NSObject.h>
#import "DirArray.h"

@class MiscTableScroll, NSButton, NSTextField, NSWindow;

enum
	{
	ICON_SLOT,
	NAME_SLOT,
	SIZE_SLOT,
	MODIFIED_SLOT,
	PERMS_SLOT,
	OWNER_SLOT,
	GROUP_SLOT,
	HARDLINKS_SLOT,
	SOFTLINK_SLOT,
	MESSAGE_SLOT
	};
#define MAX_SLOT (MESSAGE_SLOT + 1)


@interface DirWindow:NSObject
	{
	MiscTableScroll*	scroll;
	NSWindow*			window;
	NSButton*			autoSortSwitch;
	NSButton*			cdButton;
	NSButton*			hiddenFilesSwitch;
	NSButton*			highlightSwitch;
	NSButton*			updateButton;
	NSTextField*		countField;
	NSString*			path;
	BOOL				autoSort;
	BOOL				showHidden;
	BOOL				highlightDirs;
	DirArray*			dir_array;
	id					lazy_row[ MAX_SLOT ];
	}

+ (void) launchDir:(NSString*)dirname;

@end
