#ifndef __MiscBorderView_h
#define __MiscBorderView_h
//=============================================================================
//
//		Copyright (C) 1995, 1996 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscBorderView.h
//
//		View class for the row/column borders on a MiscTableView.
//		Supports resizing, dragging.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscBorderView.h,v 1.5 96/05/07 09:36:24 sunshine Exp $
// $Log:		MiscBorderView.h,v $
//	Revision 1.5  96/05/07	09:36:24  sunshine
//	Ditched -reflectSelection; replaced with -selectionChanged.
//	
//	Revision 1.4  96/05/07	02:11:25  sunshine
//	-frameHeight now returns MiscPixels instead of NXCoord.
//	
//	Revision 1.3  96/04/30	05:38:17  sunshine
//	Ported to OpenStep 4.0 for Mach PR2.
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <AppKit/NSView.h>
}
#import <misckit/MiscTableTypes.h>

enum MiscBorderViewType { MISC_COL_BORDER_VIEW, MISC_ROW_BORDER_VIEW };

class MiscSparseSet;
class MiscTableBorder;

@class MiscBorderCell, MiscMouseTracker, MiscTableScroll, MiscTableView;

@interface MiscBorderView : NSView
	{
	MiscTableScroll*	scroll;
	MiscTableBorder*	info;
	MiscBorderCell*		theCell;
	MiscMouseTracker*	tracker;
	MiscSparseSet*		oldSel;
	BOOL isHorz;
	}

- initWithFrame: (NSRect) frameRect
	 scroll: (MiscTableScroll*) scroll
	   info: (MiscTableBorder*) info
	   type: (MiscBorderViewType) type;
- (void) dealloc;

- (MiscPixels) frameHeight;
- (void) adjustSize;
- (void) setSelectionMode: (MiscSelectionMode)mode;
- (void) selectionChanged;
- (void) drawSlot:(MiscCoord_V)x;

@end

#endif // __MiscBorderView_h
