#ifndef __MiscTableFocus_h
#define __MiscTableFocus_h
//=============================================================================
//
//		Copyright (C) 1995, 1996 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscTableFocus.h
//
//		Blinking "cursor" for showing keyboard focus in TableView.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscTableFocus.h,v 1.3 96/05/07 02:15:23 sunshine Exp $
// $Log:		MiscTableFocus.h,v $
//	Revision 1.3  96/05/07	02:15:23  sunshine
//	-initOwner: renamed to -initWithOwner:.
//	
//	Revision 1.2  96/04/30	05:38:59  sunshine
//	Ported to OpenStep 4.0 for Mach PR2.
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <Foundation/NSObject.h>
#import <Foundation/NSGeometry.h>
}

@class NSTimer, NSView;

@interface MiscTableFocus : NSObject
	{
	NSView*		owner;
	NSRect		frame;
	BOOL		state;
	NSTimer*	timer;
	}

- (id) initWithOwner:(NSView*)owner;
- (void) dealloc;
- (void) setFrame:(NSRect)frame;
- (BOOL) isShowingFocus;
- (void) startFocus;
- (void) stopFocus;

@end

#endif // __MiscTableFocus_h
