#ifndef __MiscTableScrollInspector_h
#define __MiscTableScrollInspector_h
//=============================================================================
//
//		Copyright (C) 1995, 1996 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscTableScrollInspector.h
//
//		Interface Builder inspector for MiscTableScroll.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscTableScrollInspector.h,v 1.4 96/04/30 05:39:09 sunshine Exp $
// $Log:		MiscTableScrollInspector.h,v $
//	Revision 1.4  96/04/30	05:39:09  sunshine
//	Ported to OpenStep 4.0 for Mach PR2.
//	
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <InterfaceBuilder/InterfaceBuilder.h>
}
#import <misckit/MiscTableTypes.h>

@class NSButton, NSColorWell, NSMatrix, NSScrollView, NSTextField;
class MiscTableBorder;

@interface MiscTableScrollInspector : IBInspector
	{
	NSButton*			autosizeSwitch;
	NSButton*			autoSortSwitch;
	NSPopUpButton*		borderPopUp;
	NSPopUpButton*		cellClassPopUp;
	NSButton*			constrainMaxSwitch;
	NSButton*			constrainMinSwitch;
	NSButton*			deleteButton;
	NSButton*			downButton;
	NSButton*			draggableSwitch;
	NSButton*			enabledSwitch;
	NSButton*			expandToDataSwitch;
	NSButton*			lazySwitch;
	NSPopUpButton*		modePopUp;
	NSButton*			sizableSwitch;
	NSPopUpButton*		sortTypePopUp;
	NSPopUpButton*		sortDirectionPopUp;
	NSPopUpButton*		titleModePopUp;
	NSButton*			titlesSwitch;
	NSButton*			upButton;
	NSButton*			userSizeableSwitch;
	NSMatrix*			slotScroll;
	NSTextField*		sizeField;
	NSTextField*		sizeMaxField;
	NSTextField*		sizeMinField;
	NSTextField*		titleField;
	NSTextField*		uniformSizeField;
	NSColorWell*		colorText;
	NSColorWell*		colorTextH;
	NSColorWell*		colorBack;
	NSColorWell*		colorBackH;
	int					slot;			// Currently selected slot, or -1.
	int					num_slots;		// Total number of columns.
	MiscBorderType		border_type;
	MiscTableBorder*	border;
	BOOL				dirty;
	}

- init;
- (void) ok:sender;
- (void) revert:sender;

@end

#endif	// __MiscTableScrollInspector_h
