
/*
   MiscAppManager.h
   Authors: Todd Thomas and Dave Slotnick
   
   $Id:$
*/

#import <Foundation/NSObject.h>

// Forward Declarations
@class NSString;
@class NSNotification;


@interface MiscAppManager : NSObject
{
@private
	Class _infoWindowManagerClass;	/*" Info window manager class to use "*/
}

/*" Initialization/deallocation "*/
- (id) init;

/*" Getting the application version "*/
- (NSString*) appVersion; 

/*" Info by class "*/
- (Class) infoWindowManagerClass;
- (void) setInfoWindowManagerClass:(Class)newInfoWindowManagerClass;

/*" Info by bundle "*/
- (NSString*) infoBundleName;

/*" Showing info "*/
- (void) showInfoPanel:(id)sender;

@end


/*
   Any headers from here on are protected and should only be used by
   subclasses. They should be considered more volitile than the
   public API.
*/


@interface MiscAppManager (Protected)

/*" Termination hook "*/
- (BOOL) _shouldAllowTermination;

/*" Defaults "*/
- (void) _registerApplicationDefaults;

/*" Saving and restoring application state between sessions "*/
- (void) _saveApplicationState;
- (void) _restoreApplicationState;

/*" Searching for the info bundle "*/
- (NSBundle*) _findInfoBundle;

@end


@interface MiscAppManager (ApplicationDelegate)

- (void) applicationWillFinishLaunching:(NSNotification *)notification;
- (void) applicationDidFinishLaunching:(NSNotification *)notification;
- (BOOL) applicationShouldTerminate:(id)sender;

@end

