
/*
 	MiscInfoWindowManager.h
	Author:		Todd Thomas <tthomas@thoughtport.com>
	Created:	May 24, 1996
	Copyright:	Copyright 1996, Todd Thomas

 	$Id:$
*/

// Superclass Header
#import "MiscWindowManager.h"

// Forward class declarations
@class NSTextField;


@interface MiscInfoWindowManager : MiscWindowManager
{
#if IB_PARSING_HACK
    id applicationNameTF;
    id versionTF;
    id copyrightTF;
#endif

@private
    NSTextField* _applicationNameTF;
    NSTextField* _versionTF;
    NSTextField* _copyrightTF;
}

/*" Class initialization "*/
+ (void) initialize;

/*" Our info manager "*/
+ (MiscInfoWindowManager*) defaultInfoWindowManager;

/*" Our info nib manager class "*/
+ (Class) infoNibManagerClass;
+ (void) setInfoNibManagerClass:(Class)newInfoNibManagerClass;

/*" Initialization/deallocation "*/
- (void) dealloc;

/*" Accessor methods "*/
- (NSTextField*) applicationNameTF;
- (void) setApplicationNameTF:(NSTextField*)newTextField;
- (NSTextField*) versionTF;
- (void) setVersionTF:(NSTextField*)newTextField;
- (NSTextField*) copyrightTF;
- (void) setCopyrightTF:(NSTextField*)newTextField;

/*" Updating our fields "*/
- (void) updateInfo;

/*" Extensions "*/
- (void) makeKeyConditionallyAndOrderFront:(id)sender;

@end
