
/*
   MiscInspectorMediator.h
   Created May 5, 1996
*/

#import <Foundation/NSObject.h>

// Forward class declarations
@class NSNotification;
@class MiscController;
@class MiscInspectorManager;


@interface MiscInspectorMediator : NSObject
{
#if 0
    id controllerToInspect;
#endif
    
@private
    MiscController* _controllerToInspect;
}

/*" Initialization/deallocation "*/
- (void) dealloc;

/*" Outlet usually "*/
- (MiscController*) controllerToInspect;
- (void) setControllerToInspect:(MiscController*)controller;

/*" Our inspector "*/
- (MiscInspectorManager*) inspectorManager;

/*" Window manager notification "*/
- (void) windowManagerWillRelease:(NSNotification*)notification;

@end


/*
   Protected methods
*/


@interface MiscInspectorMediator (Protected)

/*" Notifications "*/
- (void) controllerWindowWillClose:(NSNotification*)notification;
- (void) controllerWindowDidBecomeMain:(NSNotification*)notification;
- (void) controllerWindowDidResignKey:(NSNotification*)notification;
- (void) controllerWindowDidResignMain:(NSNotification*)notification;

/*" Inspector communication "*/
- (void) _startInspectingIfPossible;
- (void) _stopInspecting;

/*" Notificatin setup "*/
- (void) _registerControllerWindowNotifications;
- (void) _unregisterControllerWindowNotifications;
- (void) _registerWindowManagerNotifications;
- (void) _unregisterWindowManagerNotifications;

/*" Nib initialization "*/
- (void) awakeFromNib;

@end

