
/* MiscInspectorNibManager.m created by todd on Mon 06-May-1996 */

#import <AppKit/AppKit.h>
#import "MiscInspectorManager.h"
#import "MiscInspectorNibManager.h"

// Private Constants
#define MiscInspectorNibFilenameDefault @"Inspector.nib"


@implementation MiscInspectorNibManager

/*"
	MiscInspectorNibManager only adds a little functionality to our 
	superclass. By default the nib we try to load is called Inspector.nib.
	There's also a convenience method #inspectorManager which just returns
	our inspector manager. This class is used internally by 
	MiscInspectorManager to load itself. It shouldn't be used anywhere 
	else in the app. 
"*/

- (NSString*) nibFilename
/*"
	Returns "Inspector.nib". If you want to rename your inspector nib to 
	something else just override this method in your subclass.
"*/
{
    return MiscInspectorNibFilenameDefault;
}

- (MiscInspectorManager*) inspectorManager
/*"
	Returns our inspector controller manager or nil if we don't have one.
"*/
{
    return (MiscInspectorManager*)[self windowManagerOfClass:
        [MiscInspectorManager class]];
}

@end
