//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <appkit/appkit.h>
#import <misckit/misckit.h>

@interface CounterView:View
{
    id	beatsPerMeasure;
    id	beatsPerMinute;
    id	measuresPerMinute;
    id	secondsElapsed;
	MiscStopwatch *counter;
	int beatsCounted;
	id clearButton;
	id startButton;
	id stopButton;
	id tapButton;
	BOOL running;
}

- initFrame:(const NXRect *)frm;
- drawSelf:(NXRect *)rects :(int)rectCount;
- keyDown:(NXEvent *)myevent;
- mouseDown:(NXEvent *)event;
- reset;
- clear:sender;
- start:sender;
- stop:sender;
- tap:sender;
- (MiscStopwatch *)counter;
- enableButtons:(BOOL)cb :(BOOL)sb :(BOOL)sb2 :(BOOL)tb;
- (BOOL)acceptsFirstMouse;
- (BOOL)acceptsFirstResponder;

@end
