/***************************************************************
  CATEGORY:			MiscDragView (Delegate)
 
  	These are methods for use with delegation. The _methods 
	are the ones that actually dispatch the message if there
	is a delegate.
	 
 * Copyright (C) 1995 Robert Todd Thomas
 * Use is governed by the MiscKit license
 ***************************************************************/
 
#import <AppKit/AppKit.h>
#import <misckit/MiscDragView.h>

@interface MiscDragView (Delegate)

- delegate;
- (void)setDelegate:(id)aDelegate;

- _sourceDragInitiated: sender;
- _sourceDragFinished: (BOOL)successful;
- _destinationDragInitiated: sender;
- _destinationDragFinished: (BOOL)successful;

@end

