{\rtf0\ansi{\fonttbl\f0\fmodern Courier;\f1\fswiss Helvetica;\f2\fmodern Ohlfs;}
\paperw11760
\paperh7800
\margl120
\margr120
\pard\tx540\tx1140\tx1680\tx2300\tx3340\tx3920\tx4500\tx5040\tx9200\tx11520\f0\b0\i0\ulnone\fs24\fc0\cf0 /***************************************************************\
  CATEGORY:			MiscDragView (Delegate)\
 * Copyright (C) 1995 Robert Todd Thomas\
 * Use is governed by the MiscKit license\
 \
	See the header for more information on this category.\
 ***************************************************************/\
\
#import <AppKit/AppKit.h>\
#import "MiscDragView-BackwardCompat.h"\
#import "MiscDragView-Delegate.h"\
\
\

\f1\b @implementation MiscDragView (Delegate)
\f0\b0 \
 \

\f1\b - delegate
\f0\b0 \
\{\
    return delegate;\
\}\
\
\
\
// The delegate will only be sent messages that it can respond to.\
\

\f1\b - setDelegate: (id)theDelegate
\f0\b0 \
\{\
    delegate = theDelegate;\
	if ([delegate respondsToSelector:@selector(image)])\
		[self setImage:[delegate image]];\
	if ([delegate respondsToSelector:@selector(acceptingImage)])\
		[self setAcceptingImage:[delegate acceptingImage]];\
	[self initDragTypes];\
	return self;\
\}\
\
\
\
// Sent from "mouseDown" just before the dragging starts to take place\
\

\f1\b - _sourceDragInitiated: sender
\f0\b0 \
\{\
	// here for backward compatibility, please use new delegate\
	// methods\
	if ([delegate respondsToSelector:@selector(sourceDragInitiated:)])\
		[delegate sourceDragInitiated: sender];\
	\
	// newly renamed delegate methods\
		if ([delegate respondsToSelector:@selector(didInitiateSourceDrag:)])\
		[delegate didInitiateSourceDrag: sender];\
\
	return self;\
\}\
\
\
\
// Sent when "draggedImage: endedAt: screenPoint: deposited:" is given \
// control and success is whether the image was deposited in another\
// view somewhere.\
\

\f1\b - _sourceDragFinished: (BOOL)successful
\f0\b0 \
\{\
	// here for backward compatibility, please use new delegate\
	// methods\
	if ([delegate respondsToSelector:@selector(sourceDragFinished:)])\
		[delegate sourceDragFinished: successful];\
\
	// new delegate method\
	if ([delegate respondsToSelector:@selector(didFinishSourceDrag:)])\
		[delegate didFinishSourceDrag: successful];\
\
	return self;\
\}\
\
\
\
// Sent when "draggingEntered:" is given control.\
\

\f1\b - _destinationDragInitiated: sender
\f0\b0 \
\{\
	// here for backward compatibility, please use new delegate\
	// methods\
	if ([delegate respondsToSelector:@selector(destinationDragInitiated:)])\
		[delegate destinationDragInitiated: sender];\
	\
	// new delegate method\
	if ([delegate respondsToSelector:@selector(didInitiateDestinationDrag:)])\
		[delegate didInitiateDestinationDrag: sender];\
	\
	return self;\
\}\
\
\
\
// Sent when "concludeDragOperation:" is given control\
\

\f1\b - _destinationDragFinished: (BOOL)successful
\f0\b0 \
\{\
	// here for backward compatibility, please use new delegate\
	// methods\
    if ([delegate respondsToSelector:@selector(destinationDragFinished:)])\
		[delegate destinationDragFinished: successful];\
\
	// new delegate method\
    if ([delegate respondsToSelector:@selector(didFinishDestinationDrag:)])\
		[delegate didFinishDestinationDrag: successful];\
\
	return self;\
\}\
\

\f1\b @end
\f0\b0 \
\

}
