//		Written by Todd Thomas Copyright (c) 1995 by Todd Thomas.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

/**********************************************************************
  CLASS:			MyNXBrowserCell
  
  Simply adds the ability of each cell to know what MiscFile they are
  representing. Therefore in the browser when a cell is clicked on, you
  can immediately lookup it's children (if any) or anything else you 
  need to know about.
  
  See MyController.m (BrowserDelegate) -browser:fillMatrix:inColumn:
  
 ***********************************************************************/
#import <appkit/appkit.h>


@interface MyNXBrowserCell : NXBrowserCell
{
	id  miscFile;		// points to the MiscFile that the cell represents
}

- init;
- setFile: aFile;
- file;

@end
