//		Written by Todd Thomas Copyright (c) 1994 by Todd Thomas.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


#import <objc/Object.h>


@interface MainWinController:Object
{
	id  infoPanel;				// outlet to the info panel
    id	extensionTextfield;		// IB - extension to search for multiple files
    id	dirToSearch;			// IB - the directory search will take place in 
    id	fileToSearchFor;		// IB - used for single file searches
    id	optionsMatrix;			// IB - recursive and/or follow symLinks
    id	scrollView;				// IB - where matched filenames are shown
    id	updator;				// IB - just displays whether a search is going
	id  popup;					// IB - the popup which manipulates swapview
	id  swapView;				// IB - outlet to MiscSwapViewByPopup
	id  timerField;				// IB - where the search time is shown
//	id  fileSearch;				// object that will accomplish the search
}

- init;
- free;
- beginSearch:sender;
- setDirectoryToSearch:sender;
- writeResults: result;

- showInfoPanel: sender;

@end



@interface MainWinController (Initialization)

- awakeFromNib;

@end



@interface MainWinController (MiscFileSearchingDelegate)

- (BOOL)addFile: (MiscFile *) theFile;

@end


