//=============================================================================
//
//		Copyright (C) 1995,1996 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//
//=============================================================================
//-----------------------------------------------------------------------------
// Defaults.h
//
//		Simplified interface to NeXT defaults system.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id$
// $Log$
//-----------------------------------------------------------------------------

#import <objc/Object.h>
#import <appkit/graphics.h>
@class Font;

@interface Defaults : Object

+ (void) set:(char const*)def str:	(char const*)s;
+ (void) set:(char const*)def int:	(int)i;
+ (void) set:(char const*)def float:(float)f;
+ (void) set:(char const*)def color:(NXColor)c;
+ (void) set:(char const*)def bool: (BOOL)b;
+ (void) set:(char const*)def font: (Font*)f;
+ (void) set:(char const*)def size: (NXSize)s;
+ (void) set:(char const*)def point:(NXPoint)p;
+ (void) set:(char const*)def rect: (NXRect)r;

+ (char const*) getStr:	 (char const*)def fallback:(char const*)s;
+ (int)			getInt:	 (char const*)def fallback:(int)i;
+ (int)			getInt:	 (char const*)def fallback:(int)i min:(int)n;
+ (int)			getInt:	 (char const*)def fallback:(int)i min:(int)n max:(int)x;
+ (float)		getFloat:(char const*)def fallback:(float)f;
+ (NXColor)		getColor:(char const*)def fallback:(NXColor)c;
+ (BOOL)		getBool: (char const*)def fallback:(BOOL)b;
+ (Font*)		getFont: (char const*)def fallback:(Font*)f;
+ (NXSize)		getSize: (char const*)def fallback:(NXSize)s;
+ (NXPoint)		getPoint:(char const*)def fallback:(NXPoint)p;
+ (NXRect)		getRect: (char const*)def fallback:(NXRect)r;

@end
