#ifndef __NameCache_h
#define __NameCache_h
//=============================================================================
//
//		Copyright (C) 1995,1996 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//
//=============================================================================
//-----------------------------------------------------------------------------
// NameCache.h
//
//		Data structure and routines for caching user names and group names.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id$
// $Log$
//-----------------------------------------------------------------------------

#import <appkit/appkit.h>

@interface NameCache : Object
	{
	HashTable* table;
	};
- (char const*) lookup:(int)ident;
@end


@interface OwnerCache : NameCache		// user name (owner) cache.
+ commonInstance;
@end

@interface GroupCache : NameCache		// group name cache.
+ commonInstance;
@end

#endif // __NameCache_h
