/*============================= Controller.h ================================*/
/* Class controls a demo panel. The panel shows one geographic coordinate
   in World Coordinates and various local UTM grid systems. It allows up to
   10 such points to be selected and edited.

HISTORY
7-Feb-93  Dale Amon at GPL
	  Created
*/

#import <appkit/appkit.h>

#define	LATITUDE_DEGREES	0
#define	LATITUDE_MINUTES	1
#define	LATITUDE_SECONDS	2

#define LONGITUDE_DEGREES	3
#define LONGITUDE_MINUTES	4
#define LONGITUDE_SECONDS	5

#define	EASTING			0
#define NORTHING		1

#define	METERS_DIGITS		8
#define METER_FRACTION_DIGITS	3

#define	VERSION_ID		1

@interface Controller:Object
{
    id	igCoord;
    id	igInput;
    id	igOldCoord;
    id	igOldInput;
    id	ukngCoord;
    id	ukngInput;
    id	ukz30Coord;
    id	ukz30Input;
    id	ukz31Coord;
    id	ukz31Input;
    id	worldCoord;
    id	worldInput;
    id  index;

    const char *autoLaunch;
}

- indexChanged: sender;
- worldChanged: sender;
- ukngChanged:  sender;
- ukz30Changed: sender;
- ukz31Changed: sender;
- igChanged:    sender;
- igOldChanged: sender;

@end
