/*
 *  Copyright (c) 1993 Christopher J. Kane.  All rights reserved.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement.  Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version: 1.1 (22 October 1993)
 */

#import "SBApp.h"
#import <misckit/MiscFindPanel.h>

@implementation SBApp

- orderFrontInfoPanel:sender
{
  [self loadNibSection:"Info.nib" owner:self withNames:NO];
  [infoPanel makeKeyAndOrderFront:self];
  return self;
}

// make the Timer instance (instantiated in SearchBench.nib) the
// "first conformer", so that timing can be done; this method is
// called when the find panel is first brought to the screen or used.
- (Class)MiscFindPanelClassWasLoaded:(Class)theClass
{
  [theClass setFirstConformer:timerObj];
  return theClass;
}

@end
