//
//  Controller.h -- SplitViewExample controller
//
//  Written by Dwight Everhart
//  Copyright (c) 1996 by Dwight D. Everhart.  All rights reserved.
//  Version 1.1; February 5, 1996
//
//      This notice may not be removed from this source code.
//
//  This object is included in the MiscKit by permission from the author
//  and its use is governed by the MiscKit license, found in the file
//  "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//  for a list of all applicable permissions and restrictions.
//

#import <objc/Object.h>
#import <dpsclient/event.h>

@interface Controller: Object

{
   id vertSplitView;
   id upperHorizSplitView;
   id lowerHorizSplitView;
   id topLeftView;
   id topRightView;
   id bottomLeftView;
   id bottomRightView;
}

- awakeFromNib;

/* MiscSplitView delegate methods: */
- splitView: sender getMinY: (NXCoord *) minY maxY: (NXCoord *) maxY
  ofSubviewAt: (int) offset;
- splitView: sender getMinX: (NXCoord *) minX maxX: (NXCoord *) maxX
  ofSubviewAt: (int) offset;

@end

