//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		Modified by Aleksey Sudakov <zander@cnext.crec.mipt.ru>
//		* Dec. 12, 1995 *	Improved scalling for better quality 
//				*.eps, *.tiff generation
//
//		This notice may not be removed from this source code.
//
//	This program is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <appkit/appkit.h>
#import "TreeButton.h"

@interface TreeView:View
{
	id currentButton;
	id lineList;
	id priorButton;
	id selectedField;
	id treeRoot;

	NXCoord currScale;
	NXCoord origWidth;
	NXCoord origHeight;
}

- attachTree:aTree;
- buildTreeFromNode:aNode bottom:(double)ybot
		top:(double)ytop atX:(double)xpos parent:(NXPoint *)pos;
- displayBut:but;
- displayButByName:sender;
- drawSelf:(NXRect *)rects :(int)rectCount;  	// standard rendering method
- getButByName:(const char*)name;
- initFrame:(const NXRect *)frameRect;
- scale:sender;
- setCurrentButton:but;
- setCurrButtonByName:sender;

@end

/* Color Dragging */

@interface TreeView(Drag)

- registerForDragging;
- (NXDragOperation)draggingEntered:(id <NXDraggingInfo>)sender;
- (BOOL)prepareForDragOperation:(id <NXDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NXDraggingInfo>)sender;
- concludeDragOperation:(id <NXDraggingInfo>)sender;

@end
