//		Written by Todd Thomas Copyright (c) 1995 by Todd Thomas.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

// Controller
// Responsible for non-UI components of code. Makes use of the MiscUser and
// MiscUserGroup classes to lookup the information requested.

// This object is included in the MiscKit by permission from the author
// and its use is governed by the MiscKit license, found in the file
// "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
// for a list of all applicable permissions and restrictions.

#import <appkit/appkit.h>


@interface Controller:Object
{
    id	uiMgr;			// Connection to the UI.
	id  displayList;	// List to be displayed in the browser.
}

- init;
- free;

- loadAllUsers;
- loadAllGroups;

- (BOOL)lookupGid: (int)gid;
- (BOOL)lookupGroupName: (const char *)gname;
- (BOOL)lookupUid: (int)uid;
- (BOOL)lookupUsername: (const char *)uname;

@end


@interface Controller (BrowserDelegate)

- (int)browser:sender fillMatrix:matrix inColumn:(int)column;

@end

