//		Written by Todd Thomas Copyright (c) 1995 by Todd Thomas.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

// UIMgr
// Controls the UI portion of the main window.

// This object is included in the MiscKit by permission from the author
// and its use is governed by the MiscKit license, found in the file
// "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
// for a list of all applicable permissions and restrictions.

#import <appkit/appkit.h>


@interface UIMgr : Object
{
    id	browser;			// IB outlet to the browser.
    id	groupMatrix;		// IB outlet to matrix of textfields for gr. info.
    id	status;				// IB outlet to the textfield status line.
    id	userMatrix;			// IB outlet to matrix of textfields for user info.
	id  controller;			// Outlet to controller class.
	BOOL  reloadBrowser;	// Should we load the browser?
}

- init;

- allUsersClicked:sender;
- allGroupsClicked:sender;

- gidEntered:sender;
- groupEntered:sender;
- uidEntered:sender;
- usernameEntered:sender;

- (const char *)username;
- setUsername: (const char *)uname;
- setUid: (int)uid;
- setFullName: (const char *)fname;
- setHomeDirectory: (const char *)homeDir;
- setShell: (const char *)shell;
- clearUserInfo;

- (const char *)groupName;
- setGroupName: (const char *)gname;
- setGid: (int)gid;
- clearGroupInfo;

- setStatusLine: (const char *)string;
- clearStatusLine;

@end


@interface UIMgr (BrowserTarget)

- userSelected: sender;
- groupSelected: sender;

@end


@interface UIMgr (NibInitialization)

- awakeFromNib;

@end

