//
//	MOString.h -- this is a compatability header
//		Written by Don Yacktman Copyright (c) 1995 by Don Yacktman.
//

#import <AppKit/AppKit.h>

#ifndef MOSTRINGCOMPAT_H
#define MOSTRINGCOMPAT_H

#define MOString MiscString

#endif MOSTRINGCOMPAT_H


// Note that MiscStrings cannot be uniqued, and cannot be set using
// the noCopy:shouldFree: paradigm.  The compatibiliy methods basically
// ignore requests made along these lines, and simply keep everything
// as a mutable C string.  This is less efficient, but shouldn't cause
// any real problems except in cases where you make a string unique
// as a way to prevent modification--a MiscString will still be
// modified.  Since it is bad practice to allow a non-mutable string
// to be sent mutating messages anyway, I don't consider this a bug
// on the MiscKit side.  Note that when the MiscKit moves on top of
// NeXT's Foundation Kit, these semantics change again since there
// will be mutable and non-mutable strings, amongst other things...

// The MiscString version of this method is true for objects of different
// classes as long as they have the same -stringValue, which is different
// from the MOString semantics of this method.
// - (BOOL)isEqual:anObj;


// The following MOString methods are already defined by the
// MiscString--but they take different argument types!  As such,
// you will have to change the calls yourself to keep things
// working right.  The proper method names for the MiscString
// counterparts are given to aid you in the transition.

// - cat:stringObject;
// should be changed to
// - concatenate:stringObject;

// - insert:stringObject at:(int)position;
// should be changed to
// - insertString:stringObject at:(int)position;
