//
//	MiscAbstraction.h -- A root object for classes without instances. 
//		Written by Michael T. H. Scott Copyright 1995 by Michael T. H. Scott.
//				Version 1.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <objc/objc.h>
#import <objc/objc-class.h>

@class Protocol;

@interface MiscAbstraction

+ (void)initialize;
+ (NSString *)name;
+ class;
+ superclass;
+ (BOOL)conformsToProtocol:(Protocol *)aProtocol;
+ poseAsClass:aClassObject;

@end

@interface MiscAbstraction ( DynamicLoading )

+ finishLoading: (struct mach_header *)header;
+ startUnloading;

@end
