/*

File MiscAnnouncer.h

Copyright (C) 1994 by H. Scott Roy

		H. Scott Roy
		2573 Stowe Ct.
		Northbrook, IL  60062-8103
		iconkit@cs.stanford.edu

For your editing convenience, this file is best viewed using an editor that automatically wraps long lines, in a fixed point font at 80 columns, with tabs every 4 spaces.

*/


/* ========================================================================== */


/*

The MiscAnnouncer class is a public version of the IKAnnouncer class found in IconKit.  It provides a simple way to conform to the MiscDependency protocol.  A MiscAnnouncer lets one send announcements to notify users and listeners of changes to an object.

There are two ways to incorporate a MiscAnnouncer in a new class: one can either inherit from it directly, or else keep a MiscAnnouncer as an instance variable and forward all the MiscDependency messages.

*/

#import <Foundation/NSObject.h>

#import "MiscDependency.h"


/* ========================================================================== */


@interface MiscAnnouncer : NSObject <MiscDependency>
{
	id
		owner,
		usersAndListeners;
	
	int
		numUsers;
	
	BOOL
		sendAnnouncements;
}


- initOwner: theOwner;
- (void)dealloc;
- usersAndListeners;
- (int) numUsers;
- (BOOL) sendAnnouncements;
- setSendAnnouncements: (BOOL) flag;

- announce: (SEL) theMessage;
- announce: (SEL) theMessage  with: theArgument;
- (BOOL) poll: (SEL) theMessage;
- (BOOL) poll: (SEL) theMessage  with: theArgument;


	// -- MiscDependency methods

- addUser: who;
- addListener: who;
- removeUser: who;
- removeListener: who;

@end
