//
//	MiscBackWindow.h -- Full-screen window for background or covering all
//		Written by Dale Amon, copyright 1994 by Genesis Project, Ltd.
//				Version 0.8.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

/*=============================== BackWindow.m ==============================*/
/* Class that impliments a full screen window with no title bars or other
   ornamentation visible. It can be set to a user selectable tier and will
   notify a delegate when it changes it's tier.

HISTORY
17-Feb-93  Dale Amon at GPL
	   Created. Based loosely on Backspace demo code.
*/

#define MISC_SAVERTIER 		(50)
#define MISC_BACKGROUNDTIER		(-100)

#define	MISC_BACKWIN_VERSION_ID	0.8

#ifdef MiscBackWindowCompat
#define SAVERTIER 		(50)
#define BACKGROUNDTIER		(-100)
#define	BACKWIN_VERSION_ID	0.8
#define	BackWindow MiscBackWindow
#endif MiscBackWindowCompat

@interface MiscBackWindow:NSWindow
{
	int	currentTier;
}

+ (void)initialize;

+ (NSRect)frameRectForContentRect:(NSRect)cRect styleMask:(int)aStyle;
+ (NSRect)contentRectForFrameRect:(NSRect)fRect styleMask:(int)aStyle;
+ (float)minFrameWidthWithTitle:(NSString *)aTitle styleMask:(unsigned int)aStyle;

- init;
- (void)setDelegate:(id)anObject;

- setWindowTier: (int) tier;
- makeFrontdrop:sender;
- makeBackdrop:sender;
- windowDidChangeTierTo:(int)aTier;

- (void)encodeWithCoder:(NSCoder *)aCoder;
- (id)initWithCoder:(NSCoder *)aDecoder;
#error ArchiverConversion: put the contents of your 'awake' method at the end of your 'initWithCoder:' method instead
- awake;

@end
