//
// MiscDictionary.h -- HashTable subclass set up for unique string to
//			object key/value pairs.  Access via HashTable methods.
//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <objc/HashTable.h>

@interface MiscDictionary : HashTable
{

}

// Note:  keys are all expected to be MiscStrings!

- init;
- initCapacity:(int)aCap; // designated initializer -- USE THIS OR -init ONLY!
- (BOOL)isKey:(const void *)aKey;
- (void *)valueForKey:(const void *)aKey;
- (void *)insertKey:(const void *)aKey value:(void *)aValue;
- (void *)removeKey:(const void *)aKey;
- (BOOL)nextState:(NXHashState *)aState key:(const void **)aKey 
	value:(void **)aValue;

@end