/************************************************************************
  CATEGORY:			MiscFile (Creation)
  PROGRAMMER:		Todd Thomas, Copyright 1994, 1995.
  BEGAN:			December 22, 1994
  LAST CHANGED:		January 25, 1995
  CHANGES:			-
  VERSION:			0.2
  DECLARED IN:		<misckit/MiscFile.h>
  
  Adds the ability to create another instance of a MiscFile from another.
  These methods all return an instance of MiscFile unless there was an
  error (then they return nil). You are responsible for freeing the
  instance returned. And if nil is returned you can always use the
  -errorCode method to find out why.

  This object is included in the MiscKit by permission from the author
  and its use is governed by the MiscKit license, found in the file
  "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
  for a list of all applicable permissions and restrictions.
  
 *************************************************************************/


@interface MiscFile (Creation)

// The first method will always overwrite newPath if it already existed.
- (MiscFile *)createCopyNamed: (const char *)newPath;
- (MiscFile *)createCopyNamed: (const char *)newPath overwrite: (BOOL)kill;

- (MiscFile *)createSymbolicLinkNamed: (const char *)newLink;
- (MiscFile *)createHardLinkNamed: (const char *)newLink;

- (MiscFile *)symbolicLinkSource;

@end


