/************************************************************************
  CATEGORY:			MiscFile (Modification)
  PROGRAMMER:		Todd Thomas, Copyright 1994, 1995.
  BEGAN:			December 22, 1994
  LAST CHANGED:		January 25, 1995
  CHANGES:			-
  VERSION:			0.2
  DECLARED IN:		<misckit/MiscFile.h>

  Adds the ability to change the file characteristic of the MiscFile.
  This includes filename changes, permission changes, etc.  This category 
  uses lower level calls declared in the Unix category.

  This object is included in the MiscKit by permission from the author
  and its use is governed by the MiscKit license, found in the file
  "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
  for a list of all applicable permissions and restrictions.
         
 *************************************************************************/


@interface MiscFile (Modification)
// Resets owner/group/other to what you give in perms.
- (int)setPermissions: (int)perms for: (int)who;

// Adds permissions given while leaving the rest alone.
- (int)addPermissions: (int)perms for: (int)who;

// Removes permissions given while leaving the rest alone.
- (int)removePermissions: (int)perms for: (int)who;

// There should also be some change owner and change group methods
// included here... they will be added, hopefully using the 
// MiscUser and MiscUserGroup classes.

@end

