/*
 *  Copyright (c) 1993 Christopher J. Kane.  All rights reserved.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement.  Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version: 1.1 (22 October 1993)
 */

#import <AppKit/AppKit.h>

@interface MiscFindPanel:NSPanel
{
  NSTextField *findTextField;
  NSTextField *replaceTextField;
  NSTextField *messageTextField;
  NSButton    *ignoreCaseButton;
  NSButton    *regExprButton;
  NSMatrix    *scopeMatrix;
  NSBox       *_replBox;
}

+ setFindPbEnabled:(BOOL)aBool;
+ setFirstConformer:aConformer;
+ setReplacementEnabled:(BOOL)aBool;
+ sharedInstance;

- enterSelection:sender;
- findBackward:sender;
- findForward:sender;
- jumpToSelection:sender;
- replace:sender;
- replaceAll:sender;
- replaceAndFind:sender;

- (NSTextField *)findTextField;
- (NSButton *)ignoreCaseButton;
- (NSTextField *)messageTextField;
- (NSButton *)regExprButton;
- (NSTextField *)replaceTextField;
- (NSMatrix *)scopeMatrix;

@end
