/*
 *  Copyright (c) 1993 Christopher J. Kane.  All rights reserved.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement.  Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version: 1.1 (22 October 1993)
 */

#import <AppKit/AppKit.h>
#import "MiscFindPanel.h"

@interface NSApplication (MiscFindPanelClass)

- (Class)MiscFindPanelClass;
- (BOOL)isMiscFindPanelClassLoaded;
- (MiscFindPanel *)findPanel;
- (BOOL)isFindPanelLoaded;

- enterSelection:sender;
- findNext:sender;
- findPrevious:sender;
- jumpToSelection:sender;
- orderFrontFindPanel:sender;

@end

@interface NSObject (MiscFindPanelClassDelegateMethods)

- (Class)MiscFindPanelClassWasLoaded:(Class)theClass;
- findPanelWillLoad:(Class)theClass;
- (MiscFindPanel *)findPanelDidLoad:(MiscFindPanel *)thePanel;

@end
