/*  Class to act as a cover for Internet addresses.
 *
 *  Copyright (c) 1994 Christopher J. Kane.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement. Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version 1.0 BETA (20 April 1994)
 */

#import <Foundation/NSObject.h>
#import <sys/types.h>
#import <netinet/in.h>

@interface MiscINETAddress:NSObject
{
	struct in_addr address;
	char *hostname;
}

+ localAddress;

- init;
- initFromName:(const char *)name;
- initTo:(struct in_addr)addr;

- (struct in_addr)address;
- (char *)hostname;
- (char *)stringAddress;

@end
