//
//	MiscInfo.h -- a class to sit underneath an Info panel
//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

// This object uses a NXStringTable to hold all the localizeable things
// that we would want to have.  It's expected that you connect up a
// string table in the .nib for this object.
//
// Here is a list of the keys that you can and should put in the table:
//	Version			- string to represent version number on info panel
//	VersionDate		- string to represent date of current version (info panel)
//
// In the future, if the string table isn't in the .nib file, we'll try
// to load it from the right .lproj directory.  Right now, that won't happen.
// However, if a string table is not found, then the InfoController's
// string table will be used instead.
//

@interface MiscInfo : NSObject
{
    id	strings;			// localized strings -- see docs for what's needed
	id	controller;			// MiscInfoController instance

    id	infoPanel;			// the window we order front
	id  niftyView;			// animated view inside of an info panel
	id  versionText;		// textfield to display app version number
	id  versionDateText;	// textfield to display app version date
	id  regText;			// textfield to display registered serial num
}

- init;
- setController:sender;
- niftyView;
- (const char *)versionString;
- (const char *)versionDateString;
- updateSerialNumber;
- infoPanel;
- info:sender;

@end
