//
//	MiscInfoController.h -- a class to handle the guts under an Info menu
//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.2.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

// This object uses a NXStringTable to hold all the localizeable things
// that we would want to have.  It's expected that you connect up a
// string table in the .nib for this object.
//
// Here is a list of the keys that you can and should put in the table:
//
//	AuthorEMail		- e-mail address to whom feedback should be sent
//	AuthorName		- Appelation used to address person feedback goes to
//	MailMessage		- Text of email message to send feedback to; should have
//						a %s at the start to address the feedback recipient
//						and a second %s in the body to bring out the name
//						of the application.

@interface MiscInfoController : NSObject
{
    id	strings;		// localized strings -- see docs as to what's needed
    id	info;
    id	orderForm;
    id	registration;	// basic registration panel
    MiscString *_licenseFileName;	// path to License.rtfd from x.app/Help
    MiscString *_releaseNotesFileName;	// path to release notes
}

- info;
- orderForm;
- registration;
- info:sender;
- orderForm:sender;
- registration:sender;
- releaseNotes:sender;
- license:sender;
- suggestion:sender;
- hideOrShowMenus:sender;

// To change the filenames used to open the Help panel to specific pages
- (MiscString *)licenseFile;
- (MiscString *)releaseNotesFile;
- setLicenseFile:(MiscString *)aPath;
- setReleaseNotesFile:(MiscString *)aPath;

- init;
- (void)dealloc;

@end
