//
//	MiscLinkedListNode.h -- internal class used by MiscLinkedList
//		Written by Sean Luke Copyright (c) 1993, 1994 by Sean Luke.
//		Additional methods and editing by Don Yacktman.
//				Version 0.9.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

@interface MiscLinkedListNode:NSObject <NSCoding>

/* 	This is the object for nodes inserted in the 
	generic linked list and all subclasses thereof.
	The Linked list is really a doubly-linked list,
	so the node has pointers to the next and previous
	nodes!
*/	


{
	id the_object;				// id of object the node holds.  Inits to nil.
	id the_next_node;			// pointer to the next node in the list
	id the_previous_node;		// poitner to the previous node in the list
}

- initObject: this_object;	   	// initializes node with object
								// automatically.  Cannot verify
								// that object is not null!
								
- freeObject;					// frees the object we point to.  -free doesn't
- getObject;
- setObject: this_object;		// returns the new object

- getNext;
- setNext: this_node;			// returns the new object

- getPrevious;
- setPrevious: this_node;		// returns the new object

- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
