//
//	MiscLockFile.h -- a generic class to simplify keeping an atomic lock file
//		Written by Don Yacktman Copyright (c) 1993 by Don Yacktman.
//				Version 1.1.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

@interface MiscLockFile:NSObject <NSCoding>
{
	BOOL haveLock;
	id lockFileName;
}

- init;

- fileName;
- setFileName:aString;
- lock;
- unlock;
- (BOOL)hasLock;

- copyWithZone:(NSZone *)zone;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

- (void)dealloc;

@end


// This will go away in MiscKit 2.x.x, so change your code now!
@interface MiscLockFile(BackCompat)

- (BOOL)haveLock; // don't use this!  Use -hasLock!!!

@end
