//
//	MiscMailApp.h -- an API to NeXT's Mail.app
//		Modified by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.1.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <misckit/MiscString.h>
#import <misckit/MiscMailSpeaker.h>
#import <Foundation/NSObject.h>

#define MISC_MAILAPP [MiscMailApp localMailer]
#define MISC_NO_MAIL_WINDOW -1

@interface MiscMailApp:NSObject
{
	MiscString *hostName;
	MiscMailSpeaker *theSpeaker;
	int currentWindow;
	BOOL noclutter, _initted;
}

+ (MiscMailApp *)localMailer;
+ (MiscMailApp *)mailerForHostNamed:aHost;

- hostname;
- (BOOL)noclutter;
- setNoclutter:(BOOL)flag;

- sendMailTo:to subject:subject body:body;
- sendMailTo:to subject:subject body:body cc:cc andDeliver:(BOOL)flag;

- openWindow;
- openWindow:sender;
- setTo:sender;
- setSubject:sender;
- setCc:sender;
- setBody:sender;
- deliver;
- deliver:sender;

@end