//
//	MiscMergeProtocols.h -- special interfaces for the MiscMergeKit
//		Written by Don Yacktman Copyright (c) 1995 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


typedef enum _MISC_Merge_Cond_Op {
		MISC_MCO_NONE = 0,
		MISC_MCO_EQUAL,
		MISC_MCO_NOTEQUAL,
		MISC_MCO_LESSTHANOREQUAL,
		MISC_MCO_GREATERTHANOREQUAL,
		MISC_MCO_LESSTHAN,
		MISC_MCO_GREATERTHAN
} MISC_Merge_Cond_Op;

// This is used by the engine to talk to the driver
@protocol MiscMergeDriver

// Advance merge loop and return the next dictionary, nil if no more left
- advanceMergeLoop;

// grabs the current merge dictionary
- currentDictionary;

@end


// Any MiscMergeCommand that wants to have a conditional evaluated needs
// to implement this protocol for the MiscMergeCommand class object.  The
// two values are what should be tested, with value1 being the left value.
// The operator chooses what type of comparison should be evaluated.
@protocol MiscMergeCondCallback

- value1;
- value2;
- (MISC_Merge_Cond_Op)operator;

@end

