//
//	MiscMergeTemplate.h -- a data container and parser for merge templates
//		Written by Don Yacktman Copyright (c) 1995 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


#import <AppKit/AppKit.h>

@interface MiscMergeTemplate : NSObject
{
	List *commands;
}

+ (char)startFieldDelimiter;
+ (char)endFieldDelimiter;
+ setFieldDelimitersStart:(char)aChar1 end:(char)aChar2;
+ getClassForCommand:(MiscString *)aCommand;

/*" Initializing a MiscTemplate "*/
- init; // designated initializer
- initWithString:(MiscString *)aString;
- initWithContentsOfFile:(NSString *)aFile;
- initFromFileNamed:(MiscString *)aFileName;

/*" Loading the template "*/
- parseFromString:(MiscString *)aString;
- parseFromFile:(MiscFile *)aFile;
- parseFromFileNamed:(MiscString *)aFileName;

/*" Accessing parsed template "*/
- commands;
- commandAt:(unsigned)index;

@end
