//
//	MiscProtocols.h -- various protocols used by the foundation classes
//		Written by Doug McClure Copyright (c) 1994 by Doug McClure.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <objc/objc.h>	// definition of BOOL

@protocol MiscCompare

- (int)compare:anObject;
- (int)compare:anObject ignoreCase:(BOOL)flag;
- (int)compare:anObject length:(unsigned long)length;
- (int)compare:anObject length:(unsigned long)length ignoreCase:(BOOL)flag;
- (int)compareLiteral:(const char *)literal;
- (int)compareLiteral:(const char *)literal ignoreCase:(BOOL)flag;
- (int)compareLiteral:(const char *)literal length:(unsigned long)length;
- (int)compareLiteral:(const char *)literal length:(unsigned long)length ignoreCase:(BOOL)flag;

@end


@protocol MiscEndCompare

- (int)endCompare:anObject;
- (int)endCompare:anObject ignoreCase:(BOOL)flag;
- (int)endCompare:anObject length:(unsigned long)length;
- (int)endCompare:anObject length:(unsigned long)length ignoreCase:(BOOL)flag;
- (int)endCompareLiteral:(const char *)literal;
- (int)endCompareLiteral:(const char *)literal ignoreCase:(BOOL)flag;
- (int)endCompareLiteral:(const char *)literal length:(unsigned long)length;
- (int)endCompareLiteral:(const char *)literal length:(unsigned long)length ignoreCase:(BOOL)flag;

@end


@protocol MiscListCursorPositioning

- (unsigned int)currentPosition;
- setFirstObject;
- setLastObject;
- setNextObject;
- setPreviousObject;
- setTo:(unsigned int)aPosition;

@end


@protocol MiscStorageCursorPositioning

- (unsigned int)currentPosition;
- (void *)setFirstElement;
- (void *)setLastElement;
- (void *)setNextElement;
- (void *)setPreviousElement;
- (void *)setTo:(unsigned int)aPosition;

@end
