
#import <misckit/misckit.h>

@interface MiscRecordParser:NSObject
{
	BOOL firstLineIsKeys, useWhites;
	char fieldDelimiter, recordDelimiter;
	List *parsedRecords, *keyNames;
}

- loadFromFileNamed:(MiscString *)aFileName;
- loadFromString:(MiscString *)aString;

- (List *)records;

- setKeyNames:(List *)keys;
- (List *)keyNames;

- setFirstLineIsKeys:(BOOL)aFlag;
- (BOOL)firstLineIsKeys;

- setRecordDelimiter:(char)aChar;
- (char)recordDelimiter;

- setFieldDelimiter:(char)aChar;
- (char)fieldDelimiter;

- (BOOL)delimitByWhitespace;
- setDelimitByWhitespace:(char)aChar;

- freeLastParse;

// These may be overridden, but should not be called directly:
- (MiscDictionary *)_buildDictionaryForFields:(List *)fieldList;
- (List *)_breakIntoRecordsAndFields:(MiscString *)aString;

@end
