/*========================= MiscRemoteApplication.h ========================*/
//		Written by Dale Amon, copyright 1994 by Genesis Project, Ltd.
//				Version 0.8.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

/* Class for running and setting up communications with remote applications.

HISTORY
25-Aug-93  Dale Amon at GPL
	   Created.
*/

#import <Foundation/NSDistantObject.h>	/* setProtocolForProxy */

#define	MISC_REMOTEAPPLICATION_VERSION_ID	0.8

@interface MiscRemoteApplication:NSObject 
{
    const char*	portName;
    const char* appName;
    const char*	appPath;

    id		proxy;
    id		connection;
    id		protocol;

    id		delegate;
    int		retryCount;
    int		retrySeconds;

    BOOL	debug;
}

+ (void)initialize;
+ (BOOL) debug;
+ setDebug:	(BOOL) flg;
+ (BOOL)setPath:(NSString *)newpath;

- (void)dealloc;
- initAppName: (const char*) app portName: (const char*) port;

- (void)run;
- connection;
- unconnect;
- delegate;
- protocol;
- (void)setDelegate:(id)anObject;
- setProtocol:	aProtocol;
- (int) retryInterval;
- setRetryInterval: (int) n;
- (int) retries;
- setRetries:	(int) n;

- (void)encodeWithCoder:(NSCoder *)aCoder;
- (id)initWithCoder:(NSCoder *)aDecoder;

@end

