//
//	MiscRemoteSubprocess.h -- a Obj-C wrapper around "rsh"
//		Originally written by Drew Davidson
//		Copyright (c) 1994 by Drew Davidson.
//		Modified by Don Yacktman for inclusion into the MiscKit.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

/*----------------------------------------------------------------------------
	$Source$

	REVISIONS
	$Log$
----------------------------------------------------------------------------*/
#import <misckit/MiscSubprocess.h>

@interface MiscRemoteSubprocess : MiscSubprocess
{	/*
	 * Other instance variables
	 */
	id			host;
	int		remoteExitCode;
}

+ (const char *)thisHost;

/*
 * Sets the host on which the command will run.  Setting the
 * host name is allowed only if the subprocess is not running.
 */
- setHost:(const char *)aString;
- (NSString *)host;

- execute:(const char *)aString onHost:(const char *)hostname;

@end
