//
//	MiscRuntimeExtensions.h -- an object category to extend the runtime
//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <Foundation/NSObject.h>

@interface NSObject(MiscRuntimeExtensions)

+ (int)instanceSize;
- (int)instanceSize;
- (int)sizeOf;
- becomeClass:aClass;
- _becomeClass:aClass; // no checking!  Be very careful!!!
- (int)compare:anObject;

// Turn on the visual alerts and then unrecognized messages will bring
// up an alert panel instead of just writing something to the console.
// We'll probably add other alerts that get turned on and off by this
// flag in the future, too...
+ setMiscVisualAlerts:(BOOL)aFlag;
+ (BOOL)miscVisualAlerts;
- doesNotRecognizeSelector:(SEL)aSelector;

// I named these methods this way instead of -forward... because we aren't
// passing a message on (forwarding) we are initiating a message...
- dispatchToDelegate:aDelegate message:(SEL)message;
- dispatchToDelegate:aDelegate message:(SEL)message with:anObject;

@end
