//	MiscSavePanel.h -- A save panel that allows appending.
//
//	Written by Peter Langston and Copyright (c) 1994 by Peter S. Langston.
//				Version 1.1.  All rights reserved.
//	Thanks to David Griffiths <dave@prim.demon.co.uk> for the
//	pointer to the _validateNames:checkBrowser: method.
//
//	This notice may not be removed from this source code.

#import <AppKit/NSSavePanel.h>

@interface MiscSavePanel:NSSavePanel
{
	BOOL	appendOK;	// is append allowed?
	BOOL	appMode;	// was append chosen?
}

+ alloc;			// returns nil

+ allocWithZone:(NSZone *)zone;	// returns nil

+ newContent:(NSRect)contentRect style:(int)aStyle backing:(int)bufferingType buttonMask:(int)mask defer:(BOOL)flag;

- (BOOL)_validateNames:(char *)name checkBrowser:(BOOL)check;
				// overriding internal method in SavePanel

- allowAppend:(BOOL)ok;		// ok=YES allows the append choice
				// ok=NO makes MiscSavePanel act like SavePanel

- (BOOL)appending;		// is an append required?
				// YES => append chosen, NO => replace

- (void)dealloc;				// returns self

- init;				// returns nil

@end
