//
//	MiscScreenColor.h -- a class for color "tints"  (to specify a halftone)
//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <misckit/MiscColor.h>

@interface MiscScreenColor:MiscColor <NSCoding>
{
	NSPoint theLocation;
	id theView;
}

+ (BOOL)canInitWithPasteboard:(NSPasteboard *)pasteboard;
- setFromPasteBoard:(NSPasteboard *)pasteboard;
- writeToPasteBoard:(NSPasteboard *)pasteboard;

- initColor:(NSColor *)color;
- initColorFromPixel:(NSPoint *)location;
- initColorFromPixel:(NSPoint *)location inView:view;

- (NSColor *)actualColor;
- (NSPoint)location;
- view;
- setView:aView;
- setLocation:(NSPoint *)location;
- updateColor;

- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

- (const char *)getInspectorClassName;
- (NSImage *)getIBImage;

@end