//
//	Hugh Ashton - hugh@furuike.twics.com - Feb 95
// Copyright under the terms and conditions of the MiscKit
//				Version 1.1.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//
// This object allows a search to take place in more than one Text object
// simultaneously.  It also allows searching without having to press the 
// Return key after each search string.
//
// It is inited with the initWithField:anObject andTarget:anotherObject
// method, where anObject is Text (not a TextField) and anotherObject is
// a List of Text objects.
//
// Added dynamic sizing to the original[Start|End] arrays, minor tweaks
//		-- Don Yacktman 4/13/95
//


#import <AppKit/AppKit.h>

#define MISC_SEARCHER_MAX_TARGETS 10
// 10 seems enough for reasonable use, but you can alter this to more if 
// you need.


@interface MiscSearcher:NSObject
{
	id		theTarget;
	id		theSearcher;
	id		theList;
	int		*originalStart;
	int		*originalEnd;
	BOOL	areWeSearching;
}

- initWithField:anObject andList:anotherObject;
#error NSObjectConversion:  'forward:' has been replaced by forwardInvocation: which has different calling semantics.  Convert by hand.
- forward:sender;
- setTheList:anObject;
- setTheField:anObject;
- theList;
- theField;

@end
