//
//	MiscSelectionMatrix -- a class to make the Matrix more functional
//		Written by Georg Tuparev Copyright (c) 1994 by Georg Tuparev, 
// 		EMBL & Academia Naturalis, Heidelberg, Germany.
//				Version 0.5 beta  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//		This is a free object!  Contact the author for the latest version.
//		Georg Tuparev, EMBL / BioComputing, Meyerhofstr. 1, 
//			D-69117 Heidelberg, Germany
//			Phone: +49 - 6221 - 387528
//			Fax:   +49 - 6221 - 387517
//		e-mail:  Tuparev@EMBL-Heidelberg.de
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

@interface MiscSelectionMatrix:NSMatrix
{
	List *selectionOrder;
}
+ (void)initialize;

- initWithFrame:(NSRect)frm mode:(int)aMode prototype:cellId numberOfRows:(int)rowsHigh numberOfColumns:(int)colsWide;
- initWithFrame:(NSRect)frm mode:(int)aMode cellClass:factoryId numberOfRows:(int)rowsHigh numberOfColumns:(int)colsWide;
- copyWithZone:(NSZone *)zone;
- (void)dealloc;

/* This methods are still not ready.
- setReorderActionEnabled:(BOOL)aFlag;
- (BOOL)reorderActionEnabled;
*/

// New selection methods
- addSelectionForCell:aCell;
- addSelectionAt:(int)row :(int)col;
- addSelectionForRow:(int)row;
- addSelectionForColumn:(int)col;
- addSelectionForCellWithTag:(int)aTag;

- deselectCell:aCell;
- deselectCellAt:(int)row :(int)col;
- deselectRow:(int)row;
- deselectColumn:(int)col;
- deselectCellWithTag:(int)aTag;
- getOrderedSelectedCells:(List *)aList;

// end of new methods

- (void)mouseDown:(NSEvent *)theEvent;

- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
