/*  Abstract class to act as a cover for sockets.
 *
 *  Copyright (c) 1994 Christopher J. Kane.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement. Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version 1.0 BETA (20 April 1994)
 */

#import <Foundation/NSObject.h>
#import <sys/socket.h>

enum {	/* Values for type parameter */
	MiscSOCK_RAW, MiscSOCK_DGRAM, MiscSOCK_STREAM
};

@interface MiscSocket:NSObject
{
	int sock;
	int domain;
	int type;
}

- init;
- initDomain:(int)aDomain type:(int)aType;
- (void)close;
- copyWithZone:(NSZone *)zone;
- (void)dealloc;

- (BOOL)isClosed;
- (NSString *)domain;
- (int)socket;
- (int)type;

@end
