//
//	MiscSortedStorage.h -- a MiscStorage which keeps the elements sorted
//		Written by Doug McClure Copyright (c) 1994 by Doug McClure.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>
#import <misckit/MiscProtocols.h>
#import <misckit/MiscStorage.h>

#ifndef Misc_ASCENDING
#define Misc_ASCENDING	1
#define Misc_DESCENDING	(-1)
#endif

@interface MiscSortedStorage : MiscStorage
{
  BOOL ignoreCase;
  int sortOrder;

@private
  BOOL sorted;
  BOOL sortEnabled;
}

/* Access instance variables methods */

- (BOOL)sorted;
- (BOOL)sortEnabled;
- (int)sortOrder;

/* Setting instance variables methods */

- setSortEnabled:(BOOL)sort;
- setSortOrder:(int)order;

/* New accessing, inserting, sorting methods */

- (int)compare:(void *)elementA to:(void *)elementB caseCheck:(BOOL)flag;
- insertElementBySort:(void *)anElement;
- (void *)lastElement;
- sort;

@end
