//
//	MiscStopwatch.h -- a generic class to time things (measure)
//		Written by Don Yacktman Copyright (c) 1993 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <misckit/MiscTime.h>
#import <sys/time.h>

@interface MiscStopwatch:MiscTime
{
	BOOL paused;
	struct timeval startTime;
}

- init;

- setRelative:(BOOL)t;

- clearTiming:sender;
- startTiming:sender;
- continueTiming:sender;
- pauseTiming:sender;
- calcElapsedTime:sender;

- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
