//
//	MiscStringArray.h -- a generic class to store lists of strings
//		Originally written by Drew Davidson
//		Copyright (c) 1994 by Drew Davidson.
//		Modified and extended by Don Yacktman for inclusion into the MiscKit.
//				Version 1.4.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

/*----------------------------------------------------------------------------
	$Source$

	REVISIONS
	$Log$
----------------------------------------------------------------------------*/
# import <Foundation/NSObject.h>

@class List;

# define MISC_NOT_IN_ARRAY		0xffffffff

@interface MiscStringArray : NSObject
{	/*
	 * Other instance variables
	 */
	List			*strings;
	const char		**stringArray;
	BOOL			uniqued;
}

+ (void)initialize;

- (BOOL)uniqued;
- setUniqued:(BOOL)yn;

- strings;
- addString:(const char *)aString;
- removeString:(const char *)aString;
- insertString:(const char *)aString at:(unsigned int)index;

/* add aStringObj to the array -- note that the array takes OWNERSHIP
   of aStringObj and WILL FREE IT when emptied or freed!!!
 */
- addStringObject:(MiscString *) aStringObj; // -bbum

- (unsigned int)stringCount;
- (unsigned int)count;	// same thing as above
- (const char **)stringArray;
- (const char *)stringAt:(unsigned int)index;
- (unsigned int)indexOfString:(const char *)aString;
- empty; // -bbum
- sort; // -bbum

// AppKit support

// Browser delegate code from Steve Hayman, taken from code by Jeff Martin
- (void)browser:(NSBrowser *)sender createRowsForColumn:(int)column inMatrix:(NSMatrix *)matrix;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
