//
//	MiscStringRegex.h -- add regular expressions to the MiscString class
//		Written by Carl Lindberg Copyright (c) 1994 by Carl Lindberg.
//				Version 1.95.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <misckit/regexpr.h> 

@interface MiscString(Regex)

- (int)grep:(const char *)regex;
- (int)grep:(const char *)regex caseSensitive:(BOOL)sense;
- (int)grep:(const char *)regex occurrenceNum:(int)n;
- (int)grep:(const char *)regex occurrenceNum:(int)n caseSensitive:(BOOL)sense;
- (int)grep:(const char *)regex before:(id)b middle:(id)m after:(id)a;
- (int)grep:(const char *)regex caseSensitive:(BOOL)sense before:(id)b middle:(id)m after:(id)a;
- (int)grep:(const char *)regex occurrenceNum:(int)n before:(id)b middle:(id)m after:(id)a;
- (int)grep:(const char *)regex occurrenceNum:(int)n caseSensitive:(BOOL)sense before:(id)b middle:(id)m after:(id)a;

- (int)numOfRegex:(const char *)regex;
- (int)numOfRegex:(const char *)regex caseSensitive:(BOOL)sense;

- (int)replaceEveryOccurrenceOfRegex:(const char *)regex with:(const char *)aString;
- (int)replaceEveryOccurrenceOfRegex:(const char *)regex with:(const char *)aString caseSensitive:(BOOL)sense;
- (int)replaceEveryOccurrenceOfRegex:(const char *)regex withChar:(char)aChar;
- (int)replaceEveryOccurrenceOfRegex:(const char *)regex withChar:(char)aChar caseSensitive:(BOOL)sense;
- (int)replaceEveryOccurrenceOfRegex:(const char *)regex withString:(id)sender;
- (int)replaceEveryOccurrenceOfRegex:(const char *)regex withString:(id)sender caseSensitive:(BOOL)sense;

- (int)spotOfRegex:(const char *)regex;
- (int)spotOfRegex:(const char *)regex caseSensitive:(BOOL)sense;
- (int)spotOfRegex:(const char *)regex occurrenceNum:(int)n;
- (int)spotOfRegex:(const char *)regex occurrenceNum:(int)n caseSensitive:(BOOL)sense;
- (int)spotOfRegex:(const char *)regex length:(int *)matchlen;
- (int)spotOfRegex:(const char *)regex caseSensitive:(BOOL)sense length:(int *)matchlen;
- (int)spotOfRegex:(const char *)regex occurrenceNum:(int)n length:(int *)matchlen;
- (int)spotOfRegex:(const char *)regex occurrenceNum:(int)n caseSensitive:(BOOL)sense length:(int *)matchlen;

- (int)rspotOfRegex:(const char *)regex;
- (int)rspotOfRegex:(const char *)regex caseSensitive:(BOOL)sense;
- (int)rspotOfRegex:(const char *)regex occurrenceNum:(int)n;
- (int)rspotOfRegex:(const char *)regex occurrenceNum:(int)n caseSensitive:(BOOL)sense;
- (int)rspotOfRegex:(const char *)regex length:(int *)matchlen;
- (int)rspotOfRegex:(const char *)regex caseSensitive:(BOOL)sense length:(int *)matchlen;
- (int)rspotOfRegex:(const char *)regex occurrenceNum:(int)n length:(int *)matchlen;
- (int)rspotOfRegex:(const char *)regex occurrenceNum:(int)n caseSensitive:(BOOL)sense length:(int *)matchlen;

- replaceRegex:(const char *)regex with:(const char *)aString;
- replaceRegex:(const char *)regex with:(const char *)aString caseSensitive:(BOOL)sense;
- replaceRegex:(const char *)regex with:(const char *)aString occurrenceNum:(int)n;
- replaceRegex:(const char *)regex with:(const char *)aString occurrenceNum:(int)n caseSensitive:(BOOL)sense;
- replaceRegex:(const char *)regex withChar:(char)aChar;
- replaceRegex:(const char *)regex withChar:(char)aChar caseSensitive:(BOOL)sense;
- replaceRegex:(const char *)regex withChar:(char)aChar occurrenceNum:(int)n;
- replaceRegex:(const char *)regex withChar:(char)aChar occurrenceNum:(int)n caseSensitive:(BOOL)sense;
- replaceRegex:(const char *)regex withString:(id)sender;
- replaceRegex:(const char *)regex withString:(id)sender caseSensitive:(BOOL)sense;
- replaceRegex:(const char *)regex withString:(id)sender occurrenceNum:(int)n;
- replaceRegex:(const char *)regex withString:(id)sender occurrenceNum:(int)n caseSensitive:(BOOL)sense;

- (int)matchesRegex:(const char *)regex;
- (int)matchesRegex:(const char *)regex caseSensitive:(BOOL)sense;

@end