//
//	MiscTaggedImage.h -- NXImage subclass that has an integer tag
//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/NSImage.h>

@interface MiscTaggedImage:NSImage
{
	int tag;
}

// New methods for dealing with tags:
+ findImageWithTag:(int)aTag;
- (void)setTag:(int)newTag;
- (int)tag;

// Overridden methods:
+ (void)initialize;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
