//
// MiscTree.Search.h -- Category of MiscTree that allows a MiscTree to be
// 		searched
//		Written by Stefan Bohringer Copyright (c) 1996 by Stefan Bohringer.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This program is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>
#import <misckit/MiscList.h>
#import <misckit/MiscString.h>
#import <misckit/MiscTree.h>

@interface MiscTree(Search)

typedef enum {
	MiscTreeCmp_strcmp=0,
	MiscTreeCmp_regex,
	MiscTreeCmp_idcmp,
	MiscTreeCmp_casestrcmp
} MiscTreeCmpMode_t;

-(MiscList *)listOfOccurence:(MiscString *)sstr;		//sstr is regex miscstring
-(MiscList *)listOfOccurence:(MiscString *)sstr useLabel:(BOOL)useIt regex:(BOOL)regex;
-(MiscList *)listOfOccurence:sstr useLabel:(BOOL)useIt cmp:(MiscTreeCmpMode_t)cmp;

// Should actually be included in Browser category
- selectNode:(MiscTree *)theNode inBrowser:theBrowser;
- selectString:(const char *)theString inBrowser:theBrowser;
- selectValueId:theId inBrowser:theBrowser;

@end
