/****************************************************************************
  CLASS:			MiscUserGroup
  INHERITS FROM:	Object
  CONFORMS TO:		None
  PROGRAMMER:		Todd Thomas, Copyright 1994, 1995.
  DESIGN HELP:		Don Yacktman
  DATE BEGAN:		December 17, 1994
  LAST CHANGED:		January 23, 1995
  VERSION:			0.2
  CHANGES:			See the end of the implementation for details.
  
  MiscUserGroup allows you to get information about the groups on your
  system. You can ask the class for a list of all the system's groups,
  or ask an instance for a list of it's members. You can initialize an
  instance by group id (gid) or group name ("root" for instance).
  
  If you have multiple domains (say a local and network domain) then
  methods like +allGroups and -members will traverse both (or more) domains
  and return all the information it finds. See the documentation for
  more information.

  This object is included in the MiscKit by permission from the author
  and its use is governed by the MiscKit license, found in the file
  "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
  for a list of all applicable permissions and restrictions.
  
 *****************************************************************************/
 
#include <Foundation/NSObject.h>


@interface MiscUserGroup : NSObject
{
	int  gid;
	char  *groupname;
}

+ (List *)allGroups;

- initWithGroupId: (int)groupId;
- initWithGroupName: (const char *)gname;
- (void)dealloc;

- (const char *)groupName;
- (int)groupId;

- (List *)members;

@end
