//
//	misckit.h -- top level header to include everything
//		Written by Don Yacktman.
//		Copyright (c) 1993, 1994, 1995 by Don Yacktman.
//				Version 1.6.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#ifndef MISCKIT_H
#define MISCKIT_H

#import <misckit/MiscBase.h>	// includes <misckit/FREE.h> and
			// <misckit/SELECT.h> unless you #define MISC_SKIP_FREE
			// and/or MISC_SKIP_SELECT, respectively, before
			// importing this header file.

#import <misckit/MiscKeys.h> // Key codes, etc.

#import <misckit/debug.h>

#import <misckit/MiscProtocols.h>

#import <misckit/MiscObjectRecycler.h>
#import <misckit/MiscRuntimeExtensions.h>
#import <misckit/MiscBundleLoader.h>

#import <misckit/MiscAbstraction.h>

#import <misckit/MiscString.h>	// brings in <misckit/MiscStringPatterns.h>
								// and <misckit/MiscStringRegex.h>
								// and <misckit/MiscString_ExtendedParsing.h>

#import <misckit/MiscTime.h>
#import <misckit/MiscStopwatch.h>
#import <misckit/MiscClassVariable.h>
#import <misckit/MiscNibController.h>
#import <misckit/MiscLockFile.h>
#import <misckit/MiscLogFile.h>
#import <misckit/MiscPriorityQueue.h>
#import <misckit/MiscQueue.h>
#import <misckit/MiscStack.h>
#import <misckit/MiscStorage.h>
#import <misckit/MiscList.h>
#import <misckit/MiscTableSource.h>
#import <misckit/MiscSortedStorage.h>
#import <misckit/MiscSortedList.h>

#import <misckit/MiscTree.h>
#import <misckit/MiscTree.Browser.h>
#import <misckit/MiscTree.Search.h>

#import <misckit/MiscAppExtensions.h>
#import <misckit/MiscAppDefaults.h>
#import <misckit/MiscAppIcon.h>
#import <misckit/MiscAppIconAnimator.h>

#import <misckit/MiscTBMK.h>
#import <misckit/MiscSearchText.h> // brings in <misckit/SearchableText.h>
#import <misckit/MiscSearcher.h>

#import <misckit/MiscColor.h>
#import <misckit/MiscScreenColor.h>
#import <misckit/MiscHalftoneColor.h>
#import <misckit/MiscSerialPort.h>
#import <misckit/MiscLinkedListNode.h>
#import <misckit/MiscLinkedList.h>
#import <misckit/regexpr.h>
#import <misckit/Miscdaemon.h>
#import <misckit/MiscListIteration.h>
#import <misckit/MiscListExtensions.h>
#import <misckit/MiscListSorting.h>
#import <misckit/MiscTextExtensions.h>
#import <misckit/MiscWindowButtons.h>
#import <misckit/MiscStringArray.h>
#import <misckit/MiscUniqueStringArray.h>
#import <misckit/MiscSubprocess.h>
#import <misckit/MiscRemoteSubprocess.h>
#import <misckit/MiscInfoController.h>
#import <misckit/MiscInfo.h>
#import <misckit/MiscOrderForm.h>
#import <misckit/MiscRegistration.h>
#import <misckit/MiscMatrix.h>
#import <misckit/MiscSelectionMatrix.h>
#import <misckit/MiscXmodem.h>
#import <misckit/MiscExplodingMenu.h>
#import <misckit/MiscDictionary.h>
#import <misckit/MiscParseTableFile.h>
#import <misckit/MiscBackWindow.h>
#import <misckit/MiscBackWindowDelegate.h>
#import <misckit/MiscTargetActionView.h>
#import <misckit/MiscFramingView.h>
#import <misckit/MiscMailSpeaker.h>
#import <misckit/MiscMailApp.h>
#import <misckit/MiscFileFinder.h>
#import <misckit/MiscRemoteApplication.h>
#import <misckit/MiscThreadedObject.h>
#import <misckit/MiscTimedEntry.h>
#import <misckit/MiscDirectory.h>
#import <misckit/MiscDependency.h>
#import <misckit/MiscAnnouncer.h>
#import <misckit/MiscSavePanel.h>
#import <misckit/MiscTaggedImage.h>
#import <misckit/MiscRecordParser.h>
#import <misckit/MiscSplitView.h>

#import <misckit/MiscUser.h>
#import <misckit/MiscUserGroup.h>
#import <misckit/MiscGraphNode.h>

// MiscFile.h includes these:  MiscFile+Creation.h, MiscFile+Info.h,
// MiscFile+Modification.h, MiscFile+Searching.h, MiscFile+Unix.h,
// MiscFileDefs.h
#import <misckit/MiscFile.h>

//#import <misckit/MiscAppFile.h> // semi-private; not recommended to use
//#import <misckit/_MiscDirectoryStream.h> // very private; do NOT use


#import <misckit/MiscDocType.h>
#import <misckit/MiscDocument.h>
#import <misckit/MiscDocManager.h>

#import <misckit/Compatability.h>

// Socket/networking classes
#import <misckit/MiscINETAddress.h>
#import <misckit/MiscSocket.h>
#import <misckit/MiscINETSocket.h>

// MiscSwapKit headers
//#import <misckit/MiscSwapView.h>
//#import <misckit/MiscSwapContentsController.h>
//#import <misckit/MiscSwapViewByMatrix.h>
//#import <misckit/MiscSwapViewByPopUp.h>

// MiscInspectorKit headers (depends on the swap kit)
#import <misckit/MiscInspectorManager.h>
#import <misckit/MiscInspector.h>
#import <misckit/MiscInspectorWrapper.h>
#import <misckit/MiscDefaultInspector.h>
#import <misckit/MiscMultiSelInspector.h>
#import <misckit/MiscNoSelInspector.h>

#endif /* MISCKIT_H */
