//
//	IBMole.h -- a way to play with IB via disributed objects
//		Written by Montgomery Zukowski
//		Copyright (c) 1994 by Montgomery Zukowski.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "IBMole.h"

@interface NSObject(Superfy)
-becomeSuperclass;
@end 

@implementation NSObject(Superfy)
-becomeSuperclass
{	//this was helpful in turning SmartFields into TextFields..
	//in general isa hacking is frowned upon...
	//changing yourself to a subclass can really screw things up!
	self->isa = [self superclass];
	return self;
}
@end

@interface NSWindowTemplate:NSObject
{
    struct _NXRect windowRect;
    int windowStyle;
    int windowBacking;
    int windowButtonMask;
    int windowEventMask;
    STR windowTitle;
    STR viewClass;
    STR windowClass;
    id windowView;
    id realObject;
    struct _windowFlags
    {
	unsigned hideOnDeactivate:1;
	unsigned dontFreeWhenClosed:1;
	unsigned defer:1;
	unsigned oneShot:1;
	unsigned visible:1;
	unsigned wantsToBeColor:1;
	unsigned dynamicDepthLimit:1;
	unsigned autoPositionMask:6;
	unsigned savePosition:1;
	unsigned _PADDING:2;
    }  windowFlags;
    id extension;
    struct _NXSize minSize;
}

+ (void)initialize;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;
#error ArchiverConversion: put the contents of your 'awake' method at the end of your 'initWithCoder:' method instead
- awake;
- nibInstantiate;
- (void)dealloc;

@end

@interface NSWindowTemplate(WindowFlags)

- (void)setReleasedWhenClosed:(BOOL)yesNo;
- setHidesOnDeactivate:(BOOL)yesNo;
- setVisibleAtLaunchTime:(BOOL)yesNo;
- setDeferred:(BOOL)yesNo;
- (void)setOneShot:(BOOL)yesNo;
- (void)setDynamicDepthLimit:(BOOL)yesNo;
- setWantsToBeColor:(BOOL)yesNo;

@end

@implementation NSWindowTemplate(WindowFlags)

- (void)setReleasedWhenClosed:(BOOL)yesNo;
{
	windowFlags.dontFreeWhenClosed = (unsigned)(!yesNo);
	return self;
}

- setHidesOnDeactivate:(BOOL)yesNo;
{
	windowFlags.hideOnDeactivate = (unsigned)yesNo;
	return self;
}

- setVisibleAtLaunchTime:(BOOL)yesNo;
{
	windowFlags.visible = (unsigned)yesNo;
	return self;
}

- setDeferred:(BOOL)yesNo;
{
	windowFlags.defer = (unsigned)yesNo;
	return self;
}

- (void)setOneShot:(BOOL)yesNo;
{
	windowFlags.oneShot = (unsigned)yesNo;
	return self;
}

- (void)setDynamicDepthLimit:(BOOL)yesNo;
{
	windowFlags.dynamicDepthLimit = (unsigned)yesNo;
	return self;
}

- setWantsToBeColor:(BOOL)yesNo;
{
	windowFlags.wantsToBeColor = (unsigned)yesNo;
	return self;
}

@end

@implementation  IBMole

-init
{
	tunnel = ({id conn = [[NSConnection alloc] init]; [conn setRootObject:self]; [conn registerName:"IBMole"]; conn;}); 
	;
	return self;
}

- (void)dealloc
{
	if (docList != nil)
	{
		docList = [docList release];
	}
	{ [super dealloc]; return; };
}

-ibApp
{
	return NSApp;
}

-docList
{
	NSArray *windowList;
	id delegate;
	int z;
	
	if (docList == nil)
	{
		docList = [[List alloc] init];
	}
	else
	{
		[docList empty];
	}
	windowList = [NSApp windows];
	z = [windowList count];
	while (z--)
	{
		delegate = [[windowList objectAtIndex:z] delegate];
		if ([delegate respondsToSelector:@selector(document)])
		{
			[docList addObjectIfAbsent:[delegate document]];
		}
	}
	return docList;
}

- getClass:(const char *)aClassName
{
#warning NSNameConversion:  Class names have changed. Check that the class name passed in is real.
	return objc_getClass(aClassName);
}
	

@end
