// Copyright (C) 1995 Jon Kutemeier
// Use is governed by the MiscKit license

#import <AppKit/NSSelectionCell.h>

@class NSFont;

@interface DateSelectionCell : NSSelectionCell
{
    NSColor * 	textColor,
    		highlightTextColor,
    		backgroundColor,
     		highlightColor;
    NSFont	*newCellFont;
    BOOL	drawRightEdge,
		drawEntireBottomEdge;
}

- (void)setTextColor:(NSColor *)aColor;
- (NSColor *)textColor;

- setHighlightTextColor:(NSColor *)aColor;
- (NSColor *)highlightTextColor;

- (void)setBackgroundColor:(NSColor *)aColor;
- (NSColor *)backgroundColor;

- setHighlightColor:(NSColor *)aColor;
- (NSColor *)highlightColor;

- setDrawRightEdge:(BOOL)yn;
- (BOOL)drawRightEdge;

- setDrawEntireBottomEdge:(BOOL)yn;
- (BOOL)drawEntireBottomEdge;

- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;
- (void)highlight:(BOOL)flag withFrame:(NSRect)cellFrame inView:(NSView *)controlView;

- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
