// Copyright (C) 1995 Jon Kutemeier
// Use is governed by the MiscKit license

/******************************************************************************
 *      $Log$
 ******************************************************************************/

#import <AppKit/NSMatrix.h>

@class SimpleDate;

@interface MiscCalendarMatrix : NSMatrix 
{
    SimpleDate	*simpleDate;
    id 		dateDelegate;
    NSColor *	cellTextColor,
		cellHighlightTextColor,
		cellHighlightColor,
		cellBackgroundColor;
    BOOL	overwriteCellColors;
}

- initWithFrame:(NSRect)frameRect;
- initWithFrame:(NSRect)frameRect mode:(int)aMode cellClass:cellId numberOfRows:(int)numRows numberOfColumns:(int)numCols;
- initWithFrame:(NSRect)frameRect mode:(int)aMode prototype:aCell numberOfRows:(int)numRows numberOfColumns:(int)numCols;

- (void)dealloc;

- setDateDelegate:aDateObject;
- dateDelegate;

- overwriteCellColors:(BOOL)yn;
- (BOOL)cellColorsOverwritten;

- (void)setCellBackgroundColor:(NSColor *)aColor;
- (NSColor *)cellBackgroundColor;
- setBackgroundColor:(NSColor *)aColor forCellAt:(int)xPos :(int)yPos;
- (NSColor *)backgroundColorForCellAt:(int)xPos :(int)yPos;

- setCellHighlightColor:(NSColor *)aColor;
- (NSColor *)cellHighlightColor;
- setHighlightColor:(NSColor *)aColor forCellAt:(int)xPos :(int)yPos;
- (NSColor *)highlightColorForCellAt:(int)xPos :(int)yPos;

- setCellTextColor:(NSColor *)aColor;
- (NSColor *)cellTextColor;
- setTextColor:(NSColor *)aColor forCellAt:(int)xPos :(int)yPos;
- (NSColor *)textColorForCellAt:(int)xPos :(int)yPos;

- setCellHighlightTextColor:(NSColor *)aColor;
- (NSColor *)cellHighlightTextColor;
- setHighlightTextColor:(NSColor *)aColor forCellAt:(int)xPos :(int)yPos;
- (NSColor *)highlightTextColorForCellAt:(int)xPos :(int)yPos;

- displayDate:sender;

- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
