//
//	MiscCircularSlider.h -- a cover for the MiscCircularSliderCell class
//		   Written by Vince DeMarco and Don Yacktman
//            Copyright (c) 1994 by Vince DeMarco and Don Yacktman.
//				Version 1.0  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

// This was created by modifying Vince's CircularSlider class and
// merging it with Don's RotationSlider class.  Here's the info
// from the original files.
/*
 *	Filename: CircularSlider.h
 *      Created : Sat Aug 24 21:25:44 1991
 *	Author  : Vince DeMarco <vince@whatnxt.cuc.ab.ca>
 *	LastEditDate Was "Mon Sep  6 16:31:50 1993"
 *    Version 2.0
 */
//	RotationSlider.h -- written by Don Yacktman
//	Copyright 1993 by Don Yacktman.  All rights reserved.

//	Modified by Laurent Daudelin <laurent@planon.qc.ca> to add
//  support for the lower and upper stop values and
//  the boundary flag.

#import <AppKit/NSSlider.h>
#import <misckit/MiscCircularSliderCell.h>

@interface MiscCircularSlider:NSSlider
{



}

+ (void)initialize;
+ (void) setCellClass:(Class)classId;
- initWithFrame:(NSRect)nf;
- (void)setBezeled:(BOOL)value;
- (BOOL)isBezeled;
- (void)setBordered:(BOOL)value;
- (BOOL)isBordered;
- setJumpToMousePoint:(BOOL)aBOOL;
- (BOOL)jumpToMousePoint;
- setHidden:(BOOL)aBOOL;
- (BOOL)hidden;
- setUpperStopValue:(float)aValue;
- (float)upperStopValue;
- setLowerStopValue:(float)aValue;
- (float)lowerStopValue;
- setUseBoundaries:(BOOL)flag;
- (BOOL)useBoundaries;
- setSliderStyle:(MiscCircularSliderStyle)style;
- (MiscCircularSliderStyle)sliderStyle;
- setSliderPathWidth:(float)value;
- (float)sliderPathWidth;
- (void)setBorderType:(int)type;
- (NSBorderType)borderType;
- (void)setBackgroundColor:(NSColor *)aColor;
- (NSColor *)backgroundColor;
- (float)startAngle;
- setStartAngle:(float)ang;
- (BOOL)isClockwise;
- setClockwise:(BOOL)clockwise;
@end


@interface MiscCircularSlider(Compatability)

- setDrawAsPieChart:(BOOL)aBOOL;
- (BOOL)drawAsPieChart;

@end
