//
//	MiscClipTextField.h -- a TextField subclass for displaying long string 
//						   values
//		Written and Copyright (c) 1995 by Balazs Pataki. 
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/NSTextField.h>

@interface MiscClipTextField : NSTextField

{
	int origAlignment;
}

+ (void) setCellClass:(Class)classId;

- initWithFrame:(NSRect)rect;	

- (void)setStringValue:(NSString *)stringValue;
- resetStringValue:sender;

- (void)setAlignment:(int)align;
- setClipEnabled:(BOOL)flag;
- setClipOnRight:(BOOL)flag;
- setClipperString:(const char*)aString;
- setClipDelimiters:(const char*)delimiters;

- (void)setFrameSize:(NSSize)_newSize;
- (void)mouseDown:(NSEvent *)event;

- (const char*)fullStringValue;
- clipper;
- delimiters;
- (BOOL) doesClipOnRight;
- (BOOL) isClipEnabled;

@end


@interface MiscClipTextField(IBStuff)
- (const char *)getInspectorClassName;
@end


@interface MiscClipTextField(Test)
- (void)changeFont:(id)sender;
@end
