//
//	MiscClipTextFieldCell.h -- a cell for displaying long string values
//		Written and Copyright (c) 1995 by Balazs Pataki. 
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/NSTextFieldCell.h>

@interface MiscClipTextFieldCell : NSTextFieldCell

{	
	id		delegate;
	
	id		fullString;
	id		clipper;
	id		delimiters;
	
	BOOL	clipOnRight;
	BOOL	clipEnabled;
}

- init;
- initTextCell:(NSString *)aString;
- copyWithZone:(NSZone *)zone;

- (void)dealloc;

- (void)setDelegate:(id)anObject;

- setClipOnRight:(BOOL)flag;
- setClipperString:(const char*)aString;
- setClipDelimiters:(const char*)delimiters;
- setClipEnabled:(BOOL)flag;

- (void)setStringValue:(NSString *)aString;
- (void)takeStringValueFrom:(id)sender;
- resetStringValue:sender;

- (const char*) fullStringValue;
- clipper;
- delimiters;
- delegate;
- (BOOL) isWrapped;
- (BOOL) isClipEnabled;
- (BOOL) doesClipOnRight;

- (void)encodeWithCoder:(NSCoder *)aCoder;
- (id)initWithCoder:(NSCoder *)aDecoder;
#error ArchiverConversion: put the contents of your 'awake' method at the end of your 'initWithCoder:' method instead
- awake;

@end

@interface NSObject (MiscClipDelegate)
- stringWillBeClipped:theString;
@end

@interface MiscClipTextFieldCell(IBStuff)
- (const char *)getInspectorClassName;
@end
