//
//	MiscClockView.m -- a simple view class for displaying date/time
//		Written by Scott Anguish Copyright (c) 1993 by Scott Anguish.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

@interface MiscClockView:NSView
{
	id             theImage;
	id             clockbase;

	NSImage       *imageA;
	NSImage       *imageP;

	NSImage       *imageColon;
	NSImage       *YearColon;
	NSImage       *imageAM;
	NSImage       *imagePM;

	NSImage       *DigitalNumbers[10];
	NSImage       *DateNumbers[10];
	NSImage       *YearNumbers[10];
	NSImage       *DayNames[7];
	NSImage       *MonthNames[12];
	NSPoint        colonPosition;

	int            seconds;
	int            minutes;
	int            hours;
	int            date;
	int            month;
	int            year;
	int            weekday;
	int            meridian;

	BOOL           militaryTime;
	BOOL           showYear;

	BOOL           keepingTime;
	BOOL           hidden;

	NSTimer *timedEntry;
}

- initWithFrame:(NSRect)frameRect;
- (void)dealloc;

#error ArchiverConversion: put the contents of your 'awake' method at the end of your 'initWithCoder:' method instead
- awake;
- (void)awakeFromNib;
- setTime:(struct tm *) theTime;

- takeMinutesFrom:sender;
- takeHoursFrom:sender;
- takeWeekdayFrom:sender;
- takeDateFrom:sender;
- takeMonthFrom:sender;

- setSeconds:(int)theSeconds;
- setMinutes:(int)theMinutes;
- setHours:(int)theHours;
- setWeekday:(int)theWeekday;
- setDate:(int)theDate;
- setMonth:(int)theMonth;
- setYear:(int)theYear;
- setMeridian:(int)theMeridian;

- (int)year;
- (int)month;
- (int)weekday;
- (int)date;
- (int)hours;
- (int)minutes;
- (int)seconds;

- (BOOL)militaryTime;
- (BOOL)showYear;
- setShowYear:(BOOL)state;
- setMilitaryTime:(BOOL)state;
- (BOOL)keepingTime;
- setKeepingTime:(BOOL)yesno;

- ticktock;
- startClock:sender;
- stopClock:sender;
- setToCurrentTime:sender;

- setHide:(BOOL)hide;
- (BOOL)isHidden;

@end
