//
//	MiscClockView.m -- a simple view class for displaying date/time
//		Written by Scott Anguish Copyright (c) 1993 by Scott Anguish.
//				Version 1.2.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <sys/time.h>	

#import "MiscClockView.h"

@interface MiscClockView(private)
- _setUp;
@end

@implementation MiscClockView


#define Misc_BuildImage(a, b, c, d, e) 	*theRect = NSMakeRect((b), (c), (d), (e)); \
#warning ImageConversion: NSImages 'initFromImage:rect:' is obsolete. Use the copy method instead.
	a = [[NSImage alloc] initFromImage:theImage rect:*theRect];


+ (void)initialize
{
    	[MiscClockView setVersion:3];
	return;
}


- _setUp
{
char           buf[MAXPATHLEN + 1] = "";
NSRect         rectStorage, *theRect = &rectStorage;
NSSize         oneSize, twoSize;

	if (theImage) return self; // don't want to leak!

#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
	buf = [[NSBundle bundleForClass:[self class]] pathForResource:@"MiscClockStuff" ofType:@"tiff"];
	theImage = [[NSImage alloc] initByReferencingFile:[NSString stringWithCString:buf]];


 /* Yes this is ugly, and there is alot of extra junk in here, but to a
  * large degree at this point I didn't know where else to store these
  * co-ordinates where I wouldn't loose them! */

	Misc_BuildImage (imageA, 65.0, 0.0, 9.0, 11.0);
	Misc_BuildImage (imageP, 74.0, 0.0, 9.0, 11.0);
	Misc_BuildImage (DigitalNumbers[1], 89.0, 0.0, 4.0, 11.0);
	Misc_BuildImage (DigitalNumbers[2], 93.0, 0.0, 9.0, 11.0);
	Misc_BuildImage (DigitalNumbers[3], 104.0, 0.0, 8.0, 11.0);
	Misc_BuildImage (DigitalNumbers[4], 112.0, 0.0, 9.0, 11.0);
	Misc_BuildImage (DigitalNumbers[5], 121.0, 0.0, 9.0, 11.0);
	Misc_BuildImage (DigitalNumbers[6], 130.0, 0.0, 9.0, 11.0);
	Misc_BuildImage (DigitalNumbers[7], 140.0, 0.0, 8.0, 11.0);
	Misc_BuildImage (DigitalNumbers[8], 148.0, 0.0, 9.0, 11.0);
	Misc_BuildImage (DigitalNumbers[9], 157.0, 0.0, 9.0, 11.0);
	Misc_BuildImage (DigitalNumbers[0], 166.0, 0.0, 9.0, 11.0);
	Misc_BuildImage (imageColon, 175.0, 0.0, 3.0, 11.0);
	Misc_BuildImage (imageAM, 179.0, 0.0, 12.0, 6.0);
	Misc_BuildImage (imagePM, 192.0, 0.0, 11.0, 6.0);

	Misc_BuildImage (DayNames[1], 0, 65, 19, 5);
	Misc_BuildImage (DayNames[2], 0, 59, 19, 5);
	Misc_BuildImage (DayNames[3], 0, 53, 19, 5);
	Misc_BuildImage (DayNames[4], 0, 47, 19, 5);
	Misc_BuildImage (DayNames[5], 0, 41, 19, 5);
	Misc_BuildImage (DayNames[6], 0, 35, 19, 5);
	Misc_BuildImage (DayNames[0], 0, 29, 19, 5);

	Misc_BuildImage (MonthNames[0], 40, 66, 22, 5);
	Misc_BuildImage (MonthNames[1], 40, 60, 22, 5);
	Misc_BuildImage (MonthNames[2], 40, 54, 22, 5);
	Misc_BuildImage (MonthNames[3], 40, 48, 22, 5);
	Misc_BuildImage (MonthNames[4], 40, 42, 22, 5);
	Misc_BuildImage (MonthNames[5], 40, 36, 22, 5);
	Misc_BuildImage (MonthNames[6], 40, 30, 22, 5);
	Misc_BuildImage (MonthNames[7], 40, 24, 22, 5);
	Misc_BuildImage (MonthNames[8], 40, 18, 22, 5);
	Misc_BuildImage (MonthNames[9], 40, 12, 22, 5);
	Misc_BuildImage (MonthNames[10], 40, 6, 22, 5);
	Misc_BuildImage (MonthNames[11], 40, 0, 22, 5);

	Misc_BuildImage (DateNumbers[0], 172.0, 14.0, 10.0, 17.0);
	Misc_BuildImage (DateNumbers[1], 65.0, 14.0, 8.0, 17.0);
	Misc_BuildImage (DateNumbers[2], 76.0, 14.0, 10.0, 17.0);
	Misc_BuildImage (DateNumbers[3], 88.0, 14.0, 9.0, 17.0);
	Misc_BuildImage (DateNumbers[4], 100.0, 14.0, 10.0, 17.0);
	Misc_BuildImage (DateNumbers[5], 112.0, 14.0, 10.0, 17.0);
	Misc_BuildImage (DateNumbers[6], 124.0, 14.0, 10.0, 17.0);
	Misc_BuildImage (DateNumbers[7], 136.0, 14.0, 10.0, 17.0);
	Misc_BuildImage (DateNumbers[8], 148.0, 14.0, 10.0, 17.0);
	Misc_BuildImage (DateNumbers[9], 160.0, 14.0, 10.0, 17.0);

	Misc_BuildImage (YearNumbers[0], 12.0, 8.0, 6.0, 5.0);
	Misc_BuildImage (YearNumbers[1], 0.0, 20.0, 2.0, 5.0);
	Misc_BuildImage (YearNumbers[2], 2.0, 20.0, 5.0, 5.0);
	Misc_BuildImage (YearNumbers[3], 7.0, 20.0, 5.0, 5.0);
	Misc_BuildImage (YearNumbers[4], 12.0, 20.0, 5.0, 5.0);
	Misc_BuildImage (YearNumbers[5], 0.0, 14.0, 5.0, 5.0);
	Misc_BuildImage (YearNumbers[6], 5.0, 14.0, 6.0, 5.0);
	Misc_BuildImage (YearNumbers[7], 11.0, 14.0, 5.0, 5.0);
	Misc_BuildImage (YearNumbers[8], 0.0, 8.0, 6.0, 5.0);
	Misc_BuildImage (YearNumbers[9], 6.0, 8.0, 6.0, 5.0);
	Misc_BuildImage (YearColon, 18.0, 25.0, 1.0, 5.0);

	Misc_BuildImage (clockbase, 64, 72, 64, 64);

	oneSize = [DigitalNumbers[1] size];
	twoSize = [DigitalNumbers[2] size];
	colonPosition.x = oneSize.width + twoSize.width + 7.0;

	timedEntry = 0;
	if (keepingTime)
	{
		[self startClock:self];
	}

	return self;
}


- initWithFrame:(NSRect)frameRect
{
		
	[super initWithFrame:frameRect];
	hidden=NO;
	keepingTime=NO;
	[self _setUp];
	return self;

}

#error ArchiverConversion: put the contents of your 'awake' method at the end of your 'initWithCoder:' method instead
- awake
{
#error ArchiverConversion: put the contents of your 'awake' method at the end of your 'initWithCoder:' method instead
	id ret = [super awake];
	[self _setUp];
	return ret;
}

- (void)awakeFromNib
{
#error ArchiverConversion: put the contents of your 'awake' method at the end of your 'initWithCoder:' method instead
	id ret = [super awake];
	[self _setUp];
	return ret;
}

#warning RectConversion: drawRect:(NSRect)rects (used to be drawSelf:(const NXRect *)rects :(int)rectCount) no longer takes an array of rects
- (void)drawRect:(NSRect)rects
{
NSPoint        imageOrigin;
NSSize         size, theSize, tensSize = {0.0, 0.0}, onesSize, twoSize;
id             imageAyear, imageByear, imageCyear, imageDyear;
float          width, widthA, widthB, widthC;
float          imageAdjust;
int            currentYear, hrs;

	if (hidden) {
		PSsetgray(NSLightGray);
		NSRectFill([self bounds]);
	}
	
	onesSize = [DigitalNumbers[1] size];
	twoSize = [DigitalNumbers[2] size];

	if (!militaryTime)
		colonPosition.x = onesSize.width + twoSize.width + 7.0;
	else
		colonPosition.x = 30;

	if (showYear)
	{
		imageAdjust = 5;
		colonPosition.y = 51;
	}
	else
	{
		imageAdjust = 0;
		colonPosition.y = 46;
	}


	imageOrigin.x = 0;
	imageOrigin.y = 0 + imageAdjust;	//(0)
	[clockbase compositeToPoint:imageOrigin operation:NSCompositeCopy];


	if (militaryTime)
	{
		hrs = hours;
	}
	else
	{
		hrs = hours % 12;
		if (!hrs)	hrs = 12;
	}
	
	size = [imageAM size];
	imageOrigin.x = 44;
	imageOrigin.y = 48 + imageAdjust;	//(48)
	if (!militaryTime)
	{
		if (meridian)
		{
			imageOrigin.x = 45;
			[imagePM compositeToPoint:imageOrigin operation:NSCompositeCopy];
		}
		else
			[imageAM compositeToPoint:imageOrigin operation:NSCompositeCopy];
	}

	imageOrigin = colonPosition;
	if (hrs / 10 || militaryTime)
		tensSize = [DigitalNumbers[hrs / 10] size];


	onesSize = [DigitalNumbers[hrs % 10] size];
	imageOrigin.x -= tensSize.width + onesSize.width;

	if (hrs / 10 || militaryTime)
	{
		[DigitalNumbers[hrs / 10] compositeToPoint:imageOrigin operation:NSCompositeCopy];
		imageOrigin.x += tensSize.width;
	}

	[DigitalNumbers[hrs % 10] compositeToPoint:imageOrigin operation:NSCompositeCopy];
	imageOrigin.x += onesSize.width;

	[size = [imageColon size] compositeToPoint:imageOrigin operation:NSCompositeCopy];
	imageOrigin.x += size.width;

	[size = [DigitalNumbers[minutes / 10] size] compositeToPoint:imageOrigin operation:NSCompositeCopy];
	imageOrigin.x += size.width;
	[DigitalNumbers[minutes % 10] compositeToPoint:imageOrigin operation:NSCompositeCopy];

	imageOrigin.x = 21;
	imageOrigin.y = 34 + imageAdjust;	//(34)
	[DayNames[weekday] compositeToPoint:imageOrigin operation:NSCompositeCopy];

	imageOrigin.x = 19;
	imageOrigin.y = 9 + imageAdjust;	//(9)
	[MonthNames[month] compositeToPoint:imageOrigin operation:NSCompositeCopy];

	tensSize.width = 0.0;
	tensSize.height = 0.0;


	imageOrigin.x = 30;
	imageOrigin.y = 15 + imageAdjust; //(15)
	if (date / 10)
		tensSize = [DateNumbers[date / 10] size];
	onesSize = [DateNumbers[date % 10] size];
	imageOrigin.x -= (tensSize.width + onesSize.width) / 2;
	if (date / 10)
		[DateNumbers[date / 10] compositeToPoint:imageOrigin operation:NSCompositeCopy];
	imageOrigin.x += tensSize.width + 1;
	[DateNumbers[date % 10] compositeToPoint:imageOrigin operation:NSCompositeCopy];

	//Draw the year
	if (showYear)
	{
		currentYear = [self year] + 1900;
		imageAyear = YearNumbers[currentYear / 1000];
		currentYear = currentYear % 1000;

		imageByear = YearNumbers[currentYear / 100];
		currentYear = currentYear % 100;

		imageCyear = YearNumbers[currentYear / 10];
		currentYear = currentYear % 10;

		imageDyear = YearNumbers[currentYear];

		theSize = [imageAyear size];
		widthA = theSize.width;
		theSize = [imageByear size];
		widthB = theSize.width;
		theSize = [imageCyear size];
		widthC = theSize.width;
		theSize = [imageDyear size];
		width = widthA + widthB + widthC + theSize.width;

		imageOrigin.x = 32 - (width / 2.0);
		imageOrigin.y = 0;
		[imageAyear compositeToPoint:imageOrigin operation:NSCompositeCopy];
		imageOrigin.x = imageOrigin.x + widthA;
		[imageByear compositeToPoint:imageOrigin operation:NSCompositeCopy];
		imageOrigin.x = imageOrigin.x + widthB;
		[imageCyear compositeToPoint:imageOrigin operation:NSCompositeCopy];
		imageOrigin.x = imageOrigin.x + widthC;
		[imageDyear compositeToPoint:imageOrigin operation:NSCompositeCopy];
	}
}

- setSeconds:(int)theSeconds
{
	seconds = theSeconds;
	return self;
}

- setMinutes:(int)theMinutes
{
	minutes = theMinutes;
	return self;
}

- setHours:(int)theHours
{
	hours = theHours;
	return self;
}

- setWeekday:(int)theWeekday
{
	weekday = theWeekday;
	return self;
}

- setDate:(int)theDate
{
	date = theDate;
	return self;
}

- setMonth:(int)theMonth
{
	month = theMonth;
	return self;
}

- setYear:(int)theYear
{
	year = theYear;
	return self;
}

- setMeridian:(int)theMeridian
{
	meridian = theMeridian;
	return self;
}

- takeMinutesFrom:sender
{
	[self setMinutes:[sender intValue]];
	[self display];
	return self;
}

- takeHoursFrom:sender	
{
int            localhours = [sender intValue];

	localhours %= 24;
	if (localhours <= 12)
	{
		[self setMeridian:0];
	}
	else
	{
		[self setMeridian:1];
	}
	[self setHours:localhours];
	[self display];
	return self;
}
	
- takeWeekdayFrom:sender
{
	[self setWeekday:[sender intValue]];
	[self display];
	return self;
}

- takeDateFrom:sender
{
	[self setDate:[sender intValue]];
	[self display];
	return self;
}

- takeMonthFrom:sender
{
	[self setMonth:[sender intValue]];
	[self display];
	return self;
}

- setTime: (struct tm*)theTime
{
	seconds = theTime->tm_sec;
	minutes = theTime->tm_min;
	hours = theTime->tm_hour;
	if (hours <= 12)
	{
		meridian = 0;
	}
	else
	{
		meridian = 1;
	};
	date = theTime->tm_mday;
	month = theTime->tm_mon;
	year = theTime->tm_year;
	weekday = theTime->tm_wday;
	return self;
};



- (const char *)getInspectorClassName
{
	return "MiscClockViewInspector";
}

- (int)year
{
	return year;
}

- (int)month
{
	return month;
}

- (int)weekday
{
	return weekday;
}

- (int)date
{
	return date;
}

- (int)hours
{
	return hours;
}

- (int)minutes
{
	return minutes;
}

- (int)seconds
{
	return seconds;
}


- (BOOL)militaryTime
{
	return militaryTime;
}

- (BOOL)showYear
{
	return showYear;
}

- setShowYear:(BOOL)state
{
	showYear = state;
	return self;
}


- setMilitaryTime:(BOOL)state
{
	militaryTime = state;
	return self;
}


- (BOOL)keepingTime
{
	return keepingTime;
}


- setKeepingTime:(BOOL)yesno
{
	keepingTime = yesno;
	return self;
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
	int myVersion = [aDecoder versionForClassName:[self name]];

	[super initWithCoder:aDecoder];
	if (myVersion < 2)
	{
		[aDecoder decodeValuesOfObjCTypes:"iiiiiiiiii", &seconds, &minutes, &hours,
		&date, &month, &year, &weekday, &meridian, &showYear, &militaryTime];
	}
	else
	{
		[aDecoder decodeValuesOfObjCTypes:"iiiiiiiicc", &seconds, &minutes, &hours,
		&date, &month, &year, &weekday, &meridian, &showYear, &militaryTime];
	}
	if (myVersion < 1)
	{
		keepingTime = NO;
	}
	else if (myVersion == 1)
	{
		[aDecoder decodeValueOfObjCType:"i" at:&keepingTime];
	}
	else
	{
		[aDecoder decodeValueOfObjCType:"c" at:&keepingTime];
	}
	if (myVersion > 2) {
		[aDecoder decodeValueOfObjCType:"c" at:&hidden];
	} else {
		hidden = NO;
	}
	return self;
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{
	[super encodeWithCoder:aCoder];
	[aCoder encodeValuesOfObjCTypes:"iiiiiiiicc", &seconds, &minutes, &hours,
	&date, &month, &year, &weekday, &meridian, &showYear, &militaryTime];
	[aCoder encodeValueOfObjCType:"c" at:&keepingTime];
	[aCoder encodeValueOfObjCType:"c" at:&hidden];
}

- setHide:(BOOL)hide
{
   hidden = hide;

   return self;
}

- (BOOL)isHidden
{
   return hidden;
}


void 
Animate (timedEntry, now, self)
	NSTimer *timedEntry;
	double         now;
	id             self;
{
	[(id)self ticktock];
}

- ticktock
{
struct timeval tp;
struct timezone tzp;
struct tm     *tv;

	gettimeofday (&tp, &tzp);
	tv = localtime (&tp.tv_sec);
	[self setTime:tv];
	[self display];
	return self;
}

- startClock:sender
{
	if (!keepingTime)
	{
		[self ticktock];
#error DPSConversion: timedEntry should be converted from a DPSTimedEntry to an NSTimer object
		
#error DPSConversion: 'timerWithTimeInterval:target:selector:userInfo:repeats:' used to be DPSAddTimedEntry(60, Animate, (void *)self, NSModalResponseThreshold).  Animate should be converted to a method with one argument (the timer), and <target> should be converted to the implementor of that method ([aTarget aSelector:timer]).  The argument to userInfo: needs to be converted to an object and can be retrieved with [timer userInfo].
	{
	timedEntry = [[NSTimer timerWithTimeInterval:60 target:<target> selector:Animate userInfo:(void *)self repeats:YES] retain];
	[[NSRunLoop currentRunLoop] addTimer:timedEntry forMode:NSDefaultRunLoopMode];
	[[NSRunLoop currentRunLoop] addTimer:timedEntry forMode:NSModalPanelRunLoopMode];
	[[NSRunLoop currentRunLoop] addTimer:timedEntry forMode:NSEventTrackingRunLoopMode];
	}
		keepingTime = YES;
		PSWait ();
	}
	return self;
}

- stopClock:sender
{
	if (timedEntry)
	{
		[timedEntry invalidate]; [timedEntry release];;
		[self ticktock];
		keepingTime = NO;
		timedEntry = 0;
	}

	return self;
}

- (void)dealloc
{
   int i;
	
	[imageA release];
	[imageP release];
	for(i=0;i<10;i++)
		[DigitalNumbers[i] release];
	[imageColon release];
	[imageAM release];
	[imagePM release];
	
	for(i=0;i<7;i++)
		[DayNames[i] release];
	for(i=0;i<12;i++)
   	[MonthNames[i] release];
	for(i=0;i<10;i++)
		[DateNumbers[i] release];
	for(i=0;i<10;i++)
		[YearNumbers[i] release];
	[YearColon release];
	[clockbase release];
	[theImage release];

	if (timedEntry != NULL)
		[timedEntry invalidate]; [timedEntry release];;
	{ [super dealloc]; return; };
}

- setToCurrentTime:sender
{
struct timeval		tp;
struct timezone	tzp;
struct tm     		*tv;

	gettimeofday (&tp, &tzp);
	tv = localtime (&tp.tv_sec);
	[self setTime:tv];
	[self display];
	
	return self;
}

@end
