// Copyright (C) 1995 Don Yacktman
// Use is governed by the MiscKit license

#import <AppKit/AppKit.h>

// these are set to avoid conflicting with NeXT's Matrix modes
#define MISC_STATICMODE	100	// trying to unlight the last cell does nothing
#define MISC_TRAVELMODE	101	// unlight last cell and another one lights

@interface ManyOrOneMatrix:NSMatrix
{
	int manyMode;	// static or travel mode
	BOOL direction;	// YES if moving down the matrix (forward) in travel
	BOOL path;		// YES if L-R then U-D, No if U-D, then L-R on travel
}

- initWithFrame:(NSRect)frameRect;
- initWithFrame:(NSRect)frameRect mode:(int)aMode prototype:aCell numberOfRows:(int)rowsHigh numberOfColumns:(int)colsWide;
- initWithFrame:(NSRect)frameRect mode:(int)aMode cellClass:factoryId numberOfRows:(int)rowsHigh numberOfColumns:(int)colsWide;

- (void)dealloc;
- (NSMatrixMode)mode;
- (void)setMode:(NSMatrixMode)aMode;
- (BOOL)allowsEmptySelection;
- (void)deselectAllCells;
- (void)selectCellAtRow:(int)row column:(int)col;
- (void)selectAll:(id)sender;
- (void)setState:(int)value atRow:(int)row column:(int)col;
- (void)mouseDown:(NSEvent *)theEvent;
- (void)encodeWithCoder:(NSCoder *)aCoder;
- (id)initWithCoder:(NSCoder *)aDecoder;

@end
