//
//	MiscDateView.h -- a view for dealing with input and display of dates
//		Written by Hugh Ashton, Copyright (c) 1994 by Hugh Ashton.
//				Version 1.0  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


#import <AppKit/AppKit.h>

@interface MiscDateView:NSView
{
	id	day;
	id	dayDown;
	id	dayUp;
	id	dow;
	id	month;
	id	monthDown;
	id	monthUp;
	id	year;
	id	yearDown;
	id	yearUp;
}

+ (void)initialize;
- (BOOL)isDateValid:sender;
- (BOOL)isItaLeapYear:(int)year;
- (unsigned int)whatDayIs:(int)theDay :(int)theMonth :(int)theYear;
- checkDay:sender;
- (int)getDay:sender;
- (int)getMonth:sender;
- (int)getYear:sender;
- decDay:sender;
- decMonth:sender;
- decYear:sender;
#warning RectConversion: drawRect:(NSRect)rects (used to be drawSelf:(const NXRect *)rects :(int)rectCount) no longer takes an array of rects
- (void)drawRect:(NSRect)rects;
- getTodaysDate:sender;
- incDay:sender;
- incMonth:sender;
- incYear:sender;
- initWithFrame:(NSRect)frameRect;
- outputDOW:(unsigned int)number;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;
- day:sender;
- month:sender;
- year:sender;

@end
