// Copyright (C) 1995
// Use is governed by the MiscKit license

#import "MiscColorViewInspector.h"
#import <misckit/MiscColorView.h>

@implementation MiscColorViewInspector

// Load the Inspector

- init
{
    char		buf[MAXPATHLEN + 1];
    id		bundle;
    
    [super init];
    
    bundle = [NSBundle bundleForClass:[MiscColorView class]];

#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
    if( buf = [bundle pathForResource:@"MiscColorViewInspector" ofType:@"nib"] )
		[NSBundle loadNibFile:[NSString stringWithCString:buf] externalNameTable:[NSDictionary dictionaryWithObjectsAndKeys:self, @"NSOwner", nil] withZone:[self zone]];

    return self;
}

// Query the object for it's attributes

- revert:sender
{
	[backgroundColorWell setColor:[object backgroundColor]];
	[desktopcolorSwitch setState:[object hasSameColorAsDesktop]];

	return [super revert:sender];
}

- colorChanged:sender
{
	[object setBackgroundColor:[sender color]];
    return [super ok:sender];
}

- desktopcolorUseChanged:sender
{
	[object setUseSameColorAsDesktop:[desktopcolorSwitch state]];
	return [super ok:sender];
}

- (BOOL)wantsButtons
{
	return NO;
}

@end
