//		Written by Thomas Engel Copyright (c) 1995 by Thomas Engel.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

@interface MiscColorView:NSView 
{
	NSColor *	backgroundColor;
	BOOL		sameColorAsDesktop;
}

+ (void)initialize;
- initWithFrame:(NSRect)frameRect;

- (void)setBackgroundColor:(NSColor *)color;
- (NSColor *)backgroundColor;
- setUseSameColorAsDesktop:(BOOL)flag;
- (BOOL)hasSameColorAsDesktop;

#warning RectConversion: drawRect:(NSRect)rects (used to be drawSelf:(const NXRect *)rects :(int)rectCount) no longer takes an array of rects
- (void)drawRect:(NSRect)rects;

- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
