//
//	MiscProgressPieInspector.m -- a simple view class for displaying progress
//		Written and Copyright (c) 1993 by James Heiser.  (jheiser@adobe.com)
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


#import "MiscProgressPieInspector.h"
#import "MiscProgressView.subproj/MiscProgressPie.h"

@implementation MiscProgressPieInspector

- init
{
    char buf[MAXPATHLEN + 1];
    id bundle;
    
    [super init];
    
    bundle = [NSBundle bundleForClass:[MiscProgressPie class]];
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
    buf = [bundle pathForResource:@"MiscProgressPieInspector" ofType:@"nib"];
    [NSBundle loadNibFile:[NSString stringWithCString:buf] externalNameTable:[NSDictionary dictionaryWithObjectsAndKeys:self, @"NSOwner", nil] withZone:[self zone]];
    return self;
}

- ok:sender
{
	[object setHidden:[theCheckBox intValue]];
    return [super ok:sender];
}

- revert:sender
{
	[theCheckBox setState:[object isHidden]];
	return [super revert:sender];
}

- (BOOL)wantsButtons
{
    return NO;
}

@end
