//
//	MiscProgressBar.h -- a simple view class for displaying progress bar
//		Written and Copyright (c) 1993 by James Heiser.  (jheiser@adobe.com)
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "MiscProgressView.h"

@interface MiscProgressBar:MiscProgressView
{
	NSColor * tc; // tick color
	BOOL	isTicsVisible;
	BOOL	isTicsOverBar;
	int		numTicks;
	int		emphasis;
}

- initWithFrame:(NSRect)frameRect;
- (NSColor *)tickColor;
- setTickColor:(NSColor *)color;
- renderTicks;
- renderBar;
- setTicsVisible:(BOOL)aBool;
- (BOOL)isTicsVisible;
- setTicsOverBar:(BOOL)aBool;
- (BOOL)isTicsOverBar;
- setNumTicks:(int)anInt;
- (int)numTicks;
- setEmphasis:(int)anInt;
- (int)emphasis;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;
- (const char *)getInspectorClassName;

@end
