//
//	MiscProgressView.h -- a simple view class for displaying progress
//		Written originally by Don Yacktman Copyright (c) 1993 by James Heiser.
//				Modified from an example in the NeXT documentation.
//				This file is maintained by James Heiser, jheiser@adobe.com.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

#define MISC_PROGRESS_DEFAULTSTEPSIZE 5
#define MISC_PROGRESS_MAXSIZE 100

@interface MiscProgressView:NSView
{
	int total, count, stepSize;
	float ratio;
	NSColor * bg, fg, bd; // foreground, background, border colors
}

- initWithFrame:(NSRect)frameRect;
- renderBackground;
- renderBar;
- renderBorder;
#warning RectConversion: drawRect:(NSRect)rects (used to be drawSelf:(const NXRect *)rects :(int)rectCount) no longer takes an array of rects
- (void)drawRect:(NSRect)rects;
- setStepSize:(int)value;
- (int)stepSize;
- (NSColor *)backgroundColor;
- (NSColor *)foregroundColor;
- (NSColor *)borderColor;
- (void)setBackgroundColor:(NSColor *)color;
- setForegroundColor:(NSColor *)color;
- setBorderColor:(NSColor *)color;
- setRatio:(float)newRatio;
- (void)takeIntValueFrom:sender;
- increment:sender;
- (void)takeFloatValueFrom:(id)sender;
- (const char *)getInspectorClassName;
- (void)clear:(id)sender;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
