// Copyright (C) 1995 Steve Hayman
// Use is governed by the MiscKit license

#import "MiscShellPalette.h"
#import "MiscShell.h"
#import "MiscShellInspector.h"
#import "MiscAwakeAction.h"

@implementation  MiscShellPalette
- finishInstantiate
{

    [self associateObject:aMiscShell
			type:IBObjectPboardType with:aButton];
    [self associateObject:anAwakeAction
			type:IBObjectPboardType with:anotherButton];

    return self;
}
@end


/*
 * Add some IB support stuff for MiscShell here rather than cluttering
 * up the MiscShell source itself.
 */
@implementation MiscShell(IBSupport)

- (const char *)getInspectorClassName
{
    return "MiscShellInspector";
}

-(NSImage *) getIBImage
{
    id  idBundle;
	id idImage = nil;
    char buf[MAXPATHLEN + 1];
    
	idBundle = [NSBundle bundleForClass:[MiscShellInspector class]];
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
	buf = [idBundle pathForResource:@"MiscShell" ofType:@"tiff"];
	idImage = [[NSImage alloc] initByReferencingFile:[NSString stringWithCString:buf]];
	return idImage;
}

@end


@implementation MiscAwakeAction(IBSupport)

-(NSImage *) getIBImage
{
    id  idBundle;
	id idImage = nil;
    char buf[MAXPATHLEN + 1];
    
	idBundle = [NSBundle bundleForClass:[MiscShellInspector class]];
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
	buf = [idBundle pathForResource:@"MiscAwakeAction" ofType:@"tiff"];
	idImage = [[NSImage alloc] initByReferencingFile:[NSString stringWithCString:buf]];
	return idImage;
}

@end
