/*

Version 1.2
Copyright (c) 1995 by Sean Luke
Donated to the MiscKit

Permission to use, copy, modify, and distribute this material 
for any purpose and without fee, under the restrictions as noted 
in the MiscKit copyright notice, is hereby granted, provided that
the MiscKit copyright notice and this permission notice 
appear in all source copies, and that the author's name shall not
be used in advertising or publicity pertaining to this 
material without the specific, prior written permission 
of the author.  SEAN O. LUKE  MAKES NO REPRESENTATIONS ABOUT THE
ACCURACY OR SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  
IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.

*/

#import "MiscVolumeLightInspector.h"
#import "MiscSoundUtil.subproj/MiscVolumeLight.h"

@implementation MiscVolumeLightInspector

- init
	{
	char buf[MAXPATHLEN+1];
	id bundle;
	
	[super init];
	bundle=[NSBundle bundleForClass:[MiscVolumeLight class]];
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
	buf = [bundle pathForResource:@"MiscVolumeLightInspector" ofType:@"nib"];
	[NSBundle loadNibFile:[NSString stringWithCString:buf] externalNameTable:[NSDictionary dictionaryWithObjectsAndKeys:self, @"NSOwner", nil] withZone:[self zone]];
	return self;
	}
	

- ok:sender
	{
	float r=[refresh floatValue];
	if (r<=0){r=VOLUMEMETER_TIMED_ENTRY_SPEED;[refresh setFloatValue:r];}
	
	if ([track selectedRow]) [object setToInput:self];
	else [object setToOutput:self];
	
	[object setRefresh:r];	
	return [super ok:sender];
	}
	
- revert:sender
	{
	[refresh setFloatValue:[object refresh:self]];
	[track selectCellAtRow:![object isInput:self] column:0];
	
	return [super revert:sender];
	}
	
- (BOOL) wantsButtons
	{
	return NO;
	}
	
@end

