// Copyright (C) 1995 Don Yacktman
// Use is governed by the MiscKit license

#import "MiscStringInspector.h"
#import <AppKit/AppKit.h>
#import <misckit/MiscString.h>

@implementation MiscStringInspector

- init
{
    char buf[MAXPATHLEN + 1];
    id bundle;
    
    [super init];
    bundle = [NSBundle bundleForClass:[self class]];
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
    buf = [bundle pathForResource:@"MiscStringInspector" ofType:@"nib"];
    [NSBundle loadNibFile:[NSString stringWithCString:buf] externalNameTable:[NSDictionary dictionaryWithObjectsAndKeys:self, @"NSOwner", nil] withZone:[self zone]];
    return self;
}

- (BOOL)wantsButtons { return YES; }

- revert:sender
{
	// Put string in text object
	[stringText setStringValue:[object stringValue]];
	return [super revert:sender];
}

- ok:sender
{
	[object setStringValue:[stringText stringValue]];
	return [super ok:sender];
}

@end
