// Copyright (C) 1995
// Use is governed by the MiscKit license

#import "MiscSwapKit.subproj/MiscSwapView.h"
#import "MiscSVInspector.h"

@implementation MiscSVInspector

// Load the Inspector

- init
{
    char buf[MAXPATHLEN + 1];
    id bundle;
    
    [super init];
    
    bundle = [NSBundle bundleForClass:[MiscSwapView class]];

#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
    if (buf = [bundle pathForResource:@"MiscSVInspector" ofType:@"nib"])
		[NSBundle loadNibFile:[NSString stringWithCString:buf] externalNameTable:[NSDictionary dictionaryWithObjectsAndKeys:self, @"NSOwner", nil] withZone:[self zone]];

	bundle = [NSBundle bundleForClass: [self class] ];
	
	// Load up the images for the backGround gray matrix of buttons.
	
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
	if (buf = [bundle pathForResource:@"boxBlack" ofType:@"tiff"])
		[[bGrayMatrix cellAtRow:0 column:3] setImage:[[NSImage alloc] initByReferencingFile:[NSString stringWithCString:buf]]];
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
	if (buf = [bundle pathForResource:@"boxDkgray" ofType:@"tiff"])
		[[bGrayMatrix cellAtRow:0 column:2] setImage:[[NSImage alloc] initByReferencingFile:[NSString stringWithCString:buf]]];
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
	if (buf = [bundle pathForResource:@"boxLtgray" ofType:@"tiff"])
		[[bGrayMatrix cellAtRow:0 column:1] setImage:[[NSImage alloc] initByReferencingFile:[NSString stringWithCString:buf]]];
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
	if (buf = [bundle pathForResource:@"boxWhite" ofType:@"tiff"])	
		[[bGrayMatrix cellAtRow:0 column:0] setImage:[[NSImage alloc] initByReferencingFile:[NSString stringWithCString:buf]]];
	[bGrayMatrix display];
	
    return self;
}



// Query the object for it's attributes

- revert: sender
{
  int  tag = 0;
  float  gray = 0.0;
  
	[[optionMatrix cellAtRow:0 column:0] setState:[object doesTagComparison]];
	[[optionMatrix cellAtRow:1 column:0] setState:[object doesUseBuffering]];
	[optionMatrix display];	

#warning ColorConversion: Do you really want gray?
	gray = [[[object backgroundColor] colorUsingColorSpaceName:NSCalibratedWhiteColorSpace] whiteComponent];
	
	// Anyone have a better way to do this? I tried just comparing gray
	// to NX_BLACK, etc and it did not work.
	
	if (gray >= 0.75) tag = 0;
	if (gray < 0.75 && gray >= 0.51) tag = 1;
	if (gray < 0.51 && gray >= 0.25) tag = 2;
	if (gray < 0.25) tag = 3;
	
	[[bGrayMatrix selectCellWithTag:tag] display];

	return [super revert: sender];
}



- grayChanged:sender
{
  float  gray = NSLightGray;
  
	switch ([ [bGrayMatrix selectedCell] tag])
	{
		case 0: gray = NSWhite; break;
		case 1: gray = NSLightGray; break;
		case 2: gray = NSDarkGray; break;
		case 3: gray = NSBlack; break;
	 }
	[object setBackgroundColor:[NSColor colorWithCalibratedWhite:gray alpha:1.0]]; 
	[object display];

    return [super ok: sender];
}



- optionChanged:sender
{
	switch ([ [optionMatrix selectedCell] tag])
	{
		case 0:		
			[object setTagComparison: [ [optionMatrix cellAtRow:0 column:0] state] ];
			break;
			
		case 1:		
			[object setUseBuffering: [ [optionMatrix cellAtRow:1 column:0] state ] ];
			break;
	 }
	 
    return [super ok: sender];
}



- (BOOL)wantsButtons
{
	return NO;
}

@end


@implementation MiscSwapView (IBInspector)

- (const char *)getInspectorClassName
{
	return "MiscSVInspector";
}

@end
