/* MiscSwapViewByMatrix.m				 
 *
 * This is a SwapView that can handle swapping triggered by objects inside
 * a matrix. Sorry no multiple buttons inside a matrix. (Actually, you can
 * do multiple buttons.. see test.nib)
 *
 * For more interface-info see the header file. More in depth information
 * can be found here in the source-code.
 *
 * Written by: 		Thomas Engel
 * Created:    		24.01.1994 (Copyleft)
 * Last modified: 	25.09.1994
 * Copyright (C) 1995 Thomas Engel
 */

#import <misckit/MiscSwapViewByMatrix.h>

@implementation MiscSwapViewByMatrix

- swapContentView:sender
{
	// The trigger (sender) can either be the matrix (on behalf of one 
	// of it's cells) or you one of the cells itself. Therefore we have 
	// to check.
	
	if ([sender isKindOfClass:[NSCell class]])
		return [super swapContentView: sender];
	else
		return [super swapContentView:[sender selectedCell]];
}

@end

/*
 * History: 25.09.94 Adjusted swapContentView: to work with either the
 *					 matrix or cell as the trigger.
 *
 *			24.02.94 Made it conform to the new swapView methods.
 *
 *			24.01.94 Made it MiscSwap conform.
 *
 *			08.01.94 Derived from the basic swapController to serve the need
 *					 to handle different buttons inside a scrollable matrix.
 *
 *
 * Bugs: Not here!
 */