// Copyright (C) 1995
// Use is governed by the MiscKit license

#import "MiscSwapKitPalette.h"

@implementation MiscSwapKitPalette


- finishInstantiate 
{	
    id	idBundle;
	char buf[MAXPATHLEN + 1];

	// Put the image on the button that will represent the controller
	// on the palette, then associate it with the object that is the
	// real controller.
	
	[super finishInstantiate];
	
	idBundle = [NSBundle bundleForClass:[self class]];

#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
	if (buf = [idBundle pathForResource:@"MiscSCC" ofType:@"tiff"])
		[swapImageView setImage:[[NSImage alloc] initByReferencingFile:[NSString stringWithCString:buf]]];
	 
    [self associateObject:realSwapObject 
        type:IBObjectPboardType with:swapImageView];
		
    return self;
}

@end


@implementation MiscSwapView (IBDisplaying)

// Displays a bezel around the view and writes their class name
// in the center to identify subclasses, since otherwise you cannot
// even see where the view is (on the palette and after being dragged).

#warning RectConversion: drawRect:(NSRect)rects (used to be drawSelf:(const NXRect *)rects :(int)rectCount) no longer takes an array of rects
- (void)drawRect:(NSRect)rects
{
  	if ([NSApp conformsToProtocol:@protocol(IB)])
		if ([NSApp isTestingInterface] == NO)
		{
		  id  font = [NSFont boldSystemFontOfSize:12.0];			
		  float  x;
#warning ColorConversion: Do you really want gray?
  		  float  gray = [[[self backgroundColor] colorUsingColorSpaceName:NSCalibratedWhiteColorSpace] whiteComponent];
  		  float  grays[4] = {NSBlack, NSDarkGray, NSLightGray, NSWhite};
		  int  i = 0;
		  char  *className = (char *)[[[self class] name] cString];
		  NSRect  indent;
		  
		  	while (i<4 && gray != grays[i])
				i++;

			// fill background with same color as will be used at runtime
			PSsetgray (gray);
			NSRectFill([self bounds]);
			
			// choose an offset gray for border and text
			PSsetgray (grays[(i+2)%3]);
			(&indent)->origin.x = NSMinX([self bounds]) + 2.0;
			(&indent)->origin.y = NSMinY([self bounds]) + 2.0;
			(&indent)->size.width = NSWidth([self bounds]) - 4.0;
			(&indent)->size.height = NSHeight([self bounds]) - 4.0;
			NSFrameRect(indent);

			[font set];
			if ([font widthOfString:[NSString stringWithCString:className]] > indent.size.width)
				x = 10.0;
			else
				x = (indent.size.width - [font widthOfString:[NSString stringWithCString:className]])/2; 
			PSmoveto (x, (indent.size.height-[font pointSize])/2);
			PSshow (className);
		 }
	else
		[self swapContentView: [self trigger] ];
}

@end
