/* MiscTabActionCell.m 
 *
 * By Bill Edney, Sean Hill, Mark Onyschuk, and Art Isbell
 * Copyright (C) 1995.  Use governed by the MiscKit license.
 */

#import <AppKit/NSActionCell.h>

@class NSImage;

@interface MiscTabActionCell:NSActionCell
{
@private
    float ascender, descender, tabHeight, tabBezierImageWidth;

}

// Methods Overridden From the Superclass
- initTextCell:(NSString *)aString;
#error ArchiverConversion: put the contents of your 'awake' method at the end of your 'initWithCoder:' method instead
- awake;
- (void)setFont:(NSFont *)fontObj;

- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;
- (void)highlight:(BOOL)flag withFrame:(NSRect)cellFrame inView:(NSView *)aView;
- (NSSize)cellSizeForBounds:(NSRect)aRect;
#warning RectConversion: 'trackMouse:inRect:ofView:untilMouseUp:' used to be 'trackMouse:inRect:ofView:'.  untilMouseUp == YES when inRect used to be NULL
- (BOOL)trackMouse:(NSEvent *)theEvent inRect:(NSRect)cellFrame ofView:(NSView *)controlView untilMouseUp:(BOOL)_untilMouseUp;
- (BOOL)startTrackingAt:(NSPoint)startPoint inView:(NSView *)aView;

// Other Instance Methods
- finishInitializing;

// Accessor Methods
- (BOOL)isSelected;
@end