#ifndef __MiscBorderView_h
#define __MiscBorderView_h
//=============================================================================
//
//		Copyright (C) 1995 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscBorderView.h
//
//		View class for the row/column borders on a MiscTableView.
//		Supports resizing, dragging.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscBorderView.h,v 1.1 95/09/27 12:21:21 zarnuk Exp $
// $Log:		MiscBorderView.h,v $
//	Revision 1.1  95/09/27	12:21:21  zarnuk
//	Initial revision
//	
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <AppKit/NSView.h>
}
#import <misckit/MiscTableTypes.h>

enum MiscBorderViewType { MISC_COL_BORDER_VIEW, MISC_ROW_BORDER_VIEW };

class MiscSparseSet;
class MiscTableBorder;

@class MiscBorderCell, MiscMouseTracker, MiscTableScroll, MiscTableView;
@class NSCursor;

@interface MiscBorderView : NSView
	{
	MiscTableScroll*	scroll;
	MiscTableBorder*	info;
	MiscBorderCell*		theCell;
	MiscMouseTracker*	tracker;
	MiscSparseSet*		oldSel;
	BOOL isHorz;
	}

- initFrame: (NSRect const*) frameRect
	 scroll: (MiscTableScroll*) scroll
	   info: (MiscTableBorder*) info
	   type: (MiscBorderViewType) type;
- (void)dealloc;

- (float) frameHeight;
- (void) refresh;
- (void) adjustSize;
- (void) setSelectionMode: (MiscSelectionMode) mode;
- (void) reflectSelection;
- (void) drawSlot:(MiscCoord_V)x;

@end

#endif // __MiscBorderView_h
