#ifndef __MiscMouseTracker_h
#define __MiscMouseTracker_h
//=============================================================================
//
//		Copyright (C) 1995 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscMouseTracker.h
//
//		Abstract class defining selection behavior based upon mouse tracking.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscMouseTracker.h,v 1.1 95/09/27 12:21:21 zarnuk Exp $
// $Log:		MiscMouseTracker.h,v $
//	Revision 1.1  95/09/27	12:21:21  zarnuk
//	Initial revision
//	
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <Foundation/NSObject.h>
}
#import <misckit/MiscTableTypes.h>
extern "C" {
#import <AppKit/dpsOpenStep.h>
#import <AppKit/NSDPSContext.h>
}

class MiscSparseSet;
class MiscTableBorder;

@interface MiscMouseTracker : NSObject
	{
	MiscTableBorder* border;
	MiscSparseSet* set;
	}

- initBorder: (MiscTableBorder*) border;
- (void) mouseDown:(NSEvent *)event atPos: (MiscCoord_V) pos;
- (void) mouseDragged:(NSEvent *)event atPos: (MiscCoord_V) pos;
- (void) mouseUp:(NSEvent *)event atPos: (MiscCoord_V) pos;
- (void) keyDown:(NSEvent *)event atPos: (MiscCoord_V) pos;

@end

#endif // __MiscMouseTracker_h
