//=============================================================================
//
//		Copyright (C) 1995, 1996 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscNullView.M
//
//		View class that covers the gap in the upper left corner when a 
//		MiscTableScroll has both row and column titles turned on.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscNullView.M,v 1.2 96/01/13 23:38:37 zarnuk Exp $
// $Log:		MiscNullView.M,v $
//	Revision 1.2  96/01/13	23:38:37  zarnuk
//	Now allocates the cell from [self zone].
//	
//	Revision 1.1  95/09/27	12:21:21  zarnuk
//	Initial revision
//	
//-----------------------------------------------------------------------------
#import "MiscNullView.h"
#import "MiscBorderCell.h"

extern "Objective-C" {
#import <AppKit/NSGraphics.h>
}

@implementation MiscNullView

//-----------------------------------------------------------------------------
// - free
//-----------------------------------------------------------------------------
- (void)dealloc
	{
	[theCell release];
	{ [super dealloc]; return; };
	}



//-----------------------------------------------------------------------------
// - initFrame:
//-----------------------------------------------------------------------------
- initWithFrame:(NSRect)frameRect
	{
	[super initWithFrame:frameRect];
#error ViewConversion: '[NSView setFlipped:]' is obsolete; you must override 'isFlipped' instead of setting externally. However, [NSImage setFlipped:] is not obsolete. If that is what you are using here, no change is needed.
	[self setFlipped:YES];
#error ViewConversion: View's 'setOpaque:' is obsolete; you must override 'isOpaque' instead of setting externally (if sent to text, 'setDrawsBackground:' can be used to eliminate background gray; if sent to NSImageRep, it's OK)
	[self setOpaque:YES];
#error ViewConversion: 'setClipping:' is obsolete. Views always clip to their bounds. Use PSinitclip instead.
	[self setClipping:NO];
	theCell = [[MiscBorderCell allocWithZone:[self zone]] initTextCell:@""];
	return self;
	}



//-----------------------------------------------------------------------------
// - drawSelf::
//-----------------------------------------------------------------------------
#warning RectConversion: drawRect:(NSRect)rects (used to be drawSelf:(NXRect const*)rects :(int)nrects) no longer takes an array of rects
- (void)drawRect:(NSRect)rects
	{
	[theCell drawWithFrame:[self bounds] inView:self];
}

@end
