#ifndef __MiscTableFocus_h
#define __MiscTableFocus_h
//=============================================================================
//
//		Copyright (C) 1995 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscTableFocus.h
//
//		Blinking "cursor" for showing keyboard focus in TableView.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscTableFocus.h,v 1.1 95/09/27 12:21:21 zarnuk Exp $
// $Log:		MiscTableFocus.h,v $
//	Revision 1.1  95/09/27	12:21:21  zarnuk
//	Initial revision
//	
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <Foundation/NSObject.h>
#import <AppKit/NSGraphics.h>
#import <AppKit/dpsOpenStep.h>
#import <AppKit/NSDPSContext.h>
}

@class NSView;

@interface MiscTableFocus : NSObject
	{
	NSView*				owner;
	NSRect				frame;
	BOOL				state;
	NSTimer *timer;
	}

- initOwner: (NSView*) owner;
- (void)dealloc;
- (void)setFrame:(NSRect)frame;
- (BOOL) isShowingFocus;
- (void) startFocus;
- (void) stopFocus;

@end

#endif // __MiscTableFocus_h
