#ifndef __MiscTableScrollInspector_h
#define __MiscTableScrollInspector_h
//=============================================================================
//
//		Copyright (C) 1995 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscTableScrollInspector.h
//
//		Interface Builder inspector for MiscTableScroll.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscTableScrollInspector.h,v 1.3 95/10/03 23:20:07 zarnuk Exp $
// $Log:		MiscTableScrollInspector.h,v $
//	Revision 1.3  95/10/03	23:20:07  zarnuk
//	Now keeps internal "dirty" flag and only does work in
//	"-textDidEnd:endChar:" if the text is "dirty".	This
//	should suppress most of the -border:slotAtPosition:
//	sent to freed object errors from IB.
//	
//	Revision 1.2  95/10/01	15:09:21  sunshine
//	Can now set text, background, textH, and backgroundH colors via inspector.
//	
//	Revision 1.1  95/09/27	12:21:21  zarnuk
//	Initial revision
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <apps/InterfaceBuilder.h>
}
#import <misckit/MiscTableTypes.h>

@class NSButton, NSMatrix, NSColorWell, NSScrollView, NSTextField;
class MiscTableBorder;

@interface MiscTableScrollInspector : IBInspector
	{
	NSButton*				autosizeSwitch;
	NSButton*				autoSortSwitch;
	NSButton*				borderPopUp;
	NSButton*				cellClassPopUp;
	NSButton*				constrainMaxSwitch;
	NSButton*				constrainMinSwitch;
	NSButton*				deleteButton;
	NSButton*				downButton;
	NSButton*				draggableSwitch;
	NSButton*				enabledSwitch;
	NSButton*				expandToDataSwitch;
	NSButton*				lazySwitch;
	NSButton*				modePopUp;
	NSButton*				sizableSwitch;
	NSButton*				sortTypePopUp;
	NSButton*				sortDirectionPopUp;
	NSButton*				titleModePopUp;
	NSButton*				titlesSwitch;
	NSButton*				upButton;
	NSButton*				userSizeableSwitch;
	NSMatrix*				slotScroll;
	NSTextField*			sizeField;
	NSTextField*			sizeMaxField;
	NSTextField*			sizeMinField;
	NSTextField*			titleField;
	NSTextField*			uniformSizeField;
	NSColorWell*		colorText;
	NSColorWell*		colorTextH;
	NSColorWell*		colorBack;
	NSColorWell*		colorBackH;
	int					slot;			// Currently selected slot, or -1.
	int					num_slots;		// Total number of columns.
	MiscBorderType		border_type;
	MiscTableBorder*	border;
	BOOL				dirty;
	}

- init;
- ok: sender;
- revert: sender;

@end

#endif	// __MiscTableScrollInspector_h
