//
//	MiscDistInspector.h -- Inspector object for MiscDistributor.
//
//		Written by Don Yacktman.  Copyright 1994 by Don Yacktman.
//				Version 1.0  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>
#import <apps/InterfaceBuilder.h>
#import "MiscDistributor.subproj/MiscDistributor.h"

@interface MiscDistributor(IBSupport)

- (const char *)getInspectorClassName;
- (NSImage *)getIBImage;

@end

@interface MiscDistributorInspector:IBInspector
{
	List *connections;
	id selObject;

	id connectionMatrix;
	id connectionNameText;
	id connectionDirMatrix;
}

- init;
- revert:sender;
- ok:sender;
- (BOOL)wantsButtons;

- setUpMatrix;
- editName;
- selectRow:(int)i notify:(BOOL)flag;
- selectionChanged:sender;
- addConnection:sender;
- changeConnection:sender;

@end
