//
//	MiscDistributor.h -- An object which will pass a message on to any of
//			the objects connected to it, even across .nib file boundaries.
//
//		Written by Don Yacktman.  Copyright 1994 by Don Yacktman.
//				Version 1.0  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <misckit/MiscTee.h>

typedef enum _MiscDCDirection {
	MiscIn = 1,
	MiscOut,
	MiscInout
} MiscDCDirection;

@interface MiscDistributor : MiscTee
{
	// used for IB and .nib unarchiving only
	id connections;
}

+ (void)initialize;
+ findDistributorNamed:(const char *)aString;
- connectToDistributorNamed:(const char *)aString
		direction:(MiscDCDirection)direction;
- (void)awakeFromNib;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
