//
//	MiscTee.h -- An object which will pass a message on to any of the objects
//				 connected to it.  This is useful for splitting an action
//				 message to multiple recipients or for allowing multiple
//				 delegates to be connected to provide different services.
//
//		Written by David Fedchenko.  Copyright 1994 by David Fedchenko.
//				Version 1.1  All rights reserved.
//		Additions by Don Yacktman to remove warnings and avoid infinite loops.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

@interface MiscTee:NSObject
{
	id (idConnections);
	BOOL inTee;
}

- init;
- (void)dealloc;

- addConnection:anObject with:(SEL)anAction;
- removeConnection:anObject;
- ping:sender;
- forward:(SEL)aSelector :(marg_list)argFrame;
- (BOOL)respondsToSelector:(SEL)aSelector;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
