//
//	MiscTeeConnector.m -- an IBConnector that allows a multitude of connections
//						  to spread out from it.
//
//		Written by David Fedchenko.  Copyright 1994 by David Fedchenko.
//				Version 1.0  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <Foundation/NSObject.h>
#import <apps/InterfaceBuilder.h>

// An IB-Connector conforming object to hold our connections
@interface MiscTeeConnector:NSObject <IBConnectors>
    {
    id  idSource;
    id  idDest;
	SEL	selAction;
    }

- setSource:anObject;
- setDestination:anObject;
- (void)setAction:(SEL)anAction;
- source;
- destination;
-(SEL) action;
- establishConnection;
- nibInstantiate;
- renewObject:old to:new;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;
- (void)dealloc;

@end
