//
//	MiscTeePalette.m -- Sets up the palette connections between the visual
//						and the actual objects.
//
//		Written by David Fedchenko.  Copyright 1994 by David Fedchenko.
//		Additions for MiscDistributor by Don Yacktman.
//				Version 1.1  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "MiscTeePalette.h"
#import "MiscDistributor.subproj/MiscDistributor.h"

@implementation  MiscTeePalette

- finishInstantiate
{
    id	idBundle;
    id	idImage;
	char buf[MAXPATHLEN + 1];
	
	[super finishInstantiate];
	
	[self associateObject:idTee type:IBObjectPboardType to:idTeeView];
	[self associateObject:idDist type:IBObjectPboardType to:idDistView];
	
	idBundle = [NSBundle bundleForClass:[self class]];
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
    buf = [idBundle pathForResource:@"MiscTee" ofType:@"tiff"];
    idImage = [[NSImage alloc] initByReferencingFile:[NSString stringWithCString:buf]];
	[idTeeView setImage:idImage];
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called buf will be changed into an (NSString *).  You must change the type of the variable called buf by hand.
    buf = [idBundle pathForResource:@"MiscDistributor" ofType:@"tiff"];
    idImage = [[NSImage alloc] initByReferencingFile:[NSString stringWithCString:buf]];
	[idDistView setImage:idImage];
	
	return self;
}

@end
