//
//	MiscThreeStateButton.h -- three state button class
//		Written by Don Yacktman Copyright (c) 1993 by Don Yacktman.
//				Version 1.1.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//		This is a free object!  Contact the author for the latest version.
//		Don Yacktman, 4279 N. Ivy Lane, Provo, UT, 84604
//		e-mail:  Don_Yacktman@byu.edu
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

@interface MiscThreeStateButton:NSButton
{
	BOOL doSuper;
}


+ (void)initialize;
+ (void) setCellClass:(Class)classId;
- initWithFrame:(NSRect)frameRect;

- (const char *)thirdTitle;
- setThirdTitle:(const char *)aString;
- (const char *)thirdIcon;
- setThirdIcon:(const char *)iconName;
- thirdImage;
- setThirdImage:image;
- setButtonType:(NSButtonType)aType;
- (int)state;
- (void)setState:(int)value;
- performAltClick:sender;
- (void)performClick:(id)sender;

@end
