//
//	MiscThreeStateButton.m -- three state button class
//		Written by Don Yacktman Copyright (c) 1993 by Don Yacktman.
//				Version 1.1.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//		This is a free object!  Contact the author for the latest version.
//		Don Yacktman, 4279 N. Ivy Lane, Provo, UT, 84604
//		e-mail:  Don_Yacktman@byu.edu
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "MiscThreeStateButton.h"
#import "MiscThreeStateButtonCell.h"
#import <apps/InterfaceBuilder.h>

static id threeStateCellClass = nil;

@implementation MiscThreeStateButton

+ (void)initialize
{ // need to set up to use our new cell subclass
	if (self == [MiscThreeStateButton class]) {
		threeStateCellClass = [MiscThreeStateButtonCell class];
	}
	[super initialize];
	return;
}

+ (void) setCellClass:(Class)classId
{
	threeStateCellClass = classId;
	return;
}

- initWithFrame:(NSRect)frameRect
{
	id oldCell;
	[super initWithFrame:frameRect];
	oldCell = [self cell];
	[self setCell:[[threeStateCellClass alloc] init]];
	[oldCell release];
	doSuper = NO;
	return self;
}

// These all just forward to the cell for it to deal with...
- (const char *)thirdTitle { return [[self cell] thirdTitle]; } 
- setThirdTitle:(const char *)aString { return [[self cell] setThirdTitle:aString]; }
- (const char *)thirdIcon { return [[self cell] thirdIcon]; }
- setThirdIcon:(const char *)iconName { return [[self cell] setThirdIcon:iconName]; }
- thirdImage { return [[self cell] thirdImage]; }
- setThirdImage:image { return [[self cell] setThirdImage:image]; }
- setButtonType:(NSButtonType)aType { [[self cell] setType:aType]; return [self cell]; }
- (int)state { return [[self cell] intValue]; }
- (void)setState:(int)value { [[self cell] setIntValue:value]; return [self cell]; }
- performAltClick:sender { return [[self cell] performAltClick:sender]; }
- (void)performClick:(id)sender {[[self cell] performClick:sender];return [self cell]; }

@end
