//
//	MiscTriStateButton.m -- palette class for the three state button
//		Written by Don Yacktman Copyright (c) 1993 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//		This is a free object!  Contact the author for the latest version.
//		Don Yacktman, 4279 N. Ivy Lane, Provo, UT, 84604
//		e-mail:  Don_Yacktman@byu.edu
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "MiscTriStateButton.h"
#import "MiscThreeStateButton.subproj/MiscThreeStateButton.h"
#import "MiscThreeStateButton.subproj/MiscThreeStateButtonCell.h"

@implementation MiscTriStateButton

- finishInstantiate
{	// programmatically set up the example/prototype buttons
	// to look the way we want them to look.
	[button1 setTitle:@"Neutral"];
	[button1 setAlternateTitle:@"Positive"];
	[button1 setThirdTitle:"Negative"];
	[button1 setType:MISC_CYCLIC_THREE_STATE];
	[button1 setButtonType:NSToggleButton];
	[button1 setImage:[NSImage imageNamed:@"NSSwitch"]];
	[button1 setAlternateImage:[NSImage imageNamed:@"Plus"]];
	[button1 setThirdIcon:"DontCare"];
	[button1 setImagePosition:NSImageRight];
	[button1 setBordered:NO];
	[button2 setTitle:@"Off"];
	[button2 setAlternateTitle:@"On"];
	[button2 setType:MISC_PLAIN_THREE_STATE];
	[button2 setButtonType:NSToggleButton];
	[button2 setImage:[NSImage imageNamed:@"NSSwitch"]];
	[button2 setAlternateImage:[NSImage imageNamed:@"NSHighlightedSwitch"]];
	[button2 setThirdIcon:"DontCare"];
	[button2 setImagePosition:NSImageRight];
	[button2 setBordered:NO];
	[button2 setThirdTitle:"In Between"];
	return self;
}

@end
