//
//	MiscSliderCellInspector.h -- an IBInspector that edits a MiscSliderCell
//                                  or its MiscSliderField.
//	   Written by David Fedchenko. Copyright 1994 by David Fedchenko.
//	       		 Version 1.0  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>
#import <apps/InterfaceBuilder.h>
#import "MiscSliderField.subproj/MiscSliderCell.h"
#import "MiscSliderField.subproj/MiscSliderField.h"

@interface MiscSliderCellInspector:IBInspector <IBInspectors>
    {
    id	idContinuous;
    id	idExpandLower;
    id	idExpandUpper;
    id	idHardLower;
    id	idHardUpper;
    id	idSoftLower;
    id	idSoftLowerLabel;
    id	idSoftUpper;
    id	idSoftUpperLabel;
    id  idPosition;
    id  idSplit;
    id  idIntOnly;
    }

- init;

@end

@interface MiscSliderCell (AttributesInspector)

- (const char *)getInspectorClassName;

@end

@interface MiscSliderField (AttributesInspector)

- (const char *)getInspectorClassName;
- placeView:(NSRect *)rect;

@end

@interface NSTextField (IBCategoryOverride)

- placeView:(NSRect *)rect;

@end


