//
//	MiscSliderField.h -- a TextField subclass that specializes in using
//                           the MiscSliderCell.
//	   Written by David Fedchenko. Copyright 1994 by David Fedchenko.
//	       		 Version 1.0  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

@interface MiscSliderField:NSTextField
    {
    id stringList;
    }

+ (void)initialize;
+ (void) setCellClass:(Class)classId;
- initWithFrame:(NSRect)frameRect;

// the methods to communicate with the cell
- (void)setMinValue:(double)value;
- (void)setMaxValue:(double)value;
- setMinBoundary:(double)value;
- setMaxBoundary:(double)value;
-(double) minValue;
-(double) maxValue;
-(double) minBoundary;
-(double) maxBoundary;
- setExpandMin:(BOOL)flag;
- setExpandMax:(BOOL)flag;
-(BOOL) expandMin;
-(BOOL) expandMax;
- setPosition:(int)where;
- setSplit:(int)percent;
- setIntegerOnly:(BOOL)flag;
-(int) position;
-(int) split;
-(BOOL) integerOnly;

- setStringList:anObject;
- stringList;

@end
