//
//	MiscValueCellInspector.h -- an IBInspector that edits a MiscValueCell
//                                  or its MiscValueField.
//	   Written by David Fedchenko. Copyright 1994 by David Fedchenko.
//	       		 Version 1.0  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>
#import <apps/InterfaceBuilder.h>
#import "MiscValueField.subproj/MiscValueCell.h"
#import "MiscValueField.subproj/MiscValueField.h"

@interface MiscValueCellInspector:IBInspector <IBInspectors>
    {
    id  idNormal;
    id  idAlternate;
    id  idHardLower;
    id  idHardUpper;
    id  idSoftLower;
    id  idSoftUpper;
    id  idSoftLowerLabel;
    id  idSoftUpperLabel;
    id  idExpandLower;
    id  idExpandUpper;
    id  idContinuous;
    }

- init;

@end

@interface MiscValueCell (AttributesInspector)

- (const char *)getInspectorClassName;

@end

@interface MiscValueField (AttributesInspector)

- (const char *)getInspectorClassName;

@end
