/*

MiscAppIcon.m 1.0
Sean Luke
August 14, 1995
Donated to the MiscKit

Permission to use, copy, modify, and distribute this material 
for any purpose and without fee, under the restrictions as noted 
in the MiscKit copyright notice, is hereby granted, provided that
the MiscKit copyright notice and this permission notice 
appear in all source copies, and that the author's name shall not
be used in advertising or publicity pertaining to this 
material without the specific, prior written permission 
of the author.  SEAN O. LUKE  MAKES NO REPRESENTATIONS ABOUT THE
ACCURACY OR SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  
IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.

*/


#import <misckit/MiscAppIcon.h>

@implementation NSApplication (MiscAppIcon)

- appIconToWindow:(NSWindow*)thisWindow
	{
	int appIcongstate;
	NSRect theFrame;
	
	// Straight from a SwapView example--sorry, but I don't have
	// the example any more, so I can't give credit.  :-(

	appIcongstate=[[NSApp applicationIconImage] gState];
	theFrame = [[[NSApp applicationIconImage] contentView] frame];
	[[thisWindow contentView] lockFocus];
	PScomposite((float)theFrame.origin.x,
		(float)theFrame.origin.y,
		(float)theFrame.size.width,
		(float)theFrame.size.height,
		(int)appIcongstate,
		(float)0.0,
		(float)0.0,
		(int)NSCompositeCopy);
	[[thisWindow contentView] unlockFocus];
	[thisWindow flushWindow];
	PSWait();
	return self;
	}

- cleanTileToWindow:(NSWindow*)thisWindow
	{
	NSPoint	contentViewOrigin = { 0.0, 0.0 };
	
	[[thisWindow contentView] lockFocus];
#error IconConversion: The image - NXAppTile - is no longer available in the API. Try using [NSApp setApplicationIconImage:].
	[[NSImage imageNamed:@"NXAppTile"] compositeToPoint:contentViewOrigin operation:NSCompositeSourceOver];
	[[thisWindow contentView] unlockFocus];
	return self;
	}
	
	
- cleanTileToAppIcon
	{
	NSPoint	contentViewOrigin = { 0.0, 0.0 };
	
	[[[NSApp applicationIconImage] contentView] lockFocus];
#error IconConversion: The image - NXAppTile - is no longer available in the API. Try using [NSApp setApplicationIconImage:].
	[[NSImage imageNamed:@"NXAppTile"] compositeToPoint:contentViewOrigin operation:NSCompositeSourceOver];
	[[[NSApp applicationIconImage] contentView] unlockFocus];
	[[NSApp applicationIconImage] flushWindow];
	PSWait();
	return self;
	}

- windowToAppIcon:(NSWindow*)thisWindow
	{
	int thisWindowgstate;
	NSRect theFrame;
	
	// Straight from a SwapView example--sorry, but I don't have
	// the example any more, so I can't give credit.  :-(

	thisWindowgstate=[thisWindow gState];
	theFrame = [[thisWindow contentView] frame];
	[[[NSApp applicationIconImage] contentView] lockFocus];
	PScomposite((float)theFrame.origin.x,
		(float)theFrame.origin.y,
		(float)theFrame.size.width,
		(float)theFrame.size.height,
		(int)thisWindowgstate,
		(float)0.0,
		(float)0.0,
		(int)NSCompositeCopy);
	[[[NSApp applicationIconImage] contentView] unlockFocus];
	[[NSApp applicationIconImage] flushWindow];
	PSWait();
	return self;
	}

@end

