//
//	MiscLinkedListNode.m -- internal class used by MiscLinkedList
//		Written by Sean Luke Copyright (c) 1993, 1994 by Sean Luke.
//		Additional methods and editing by Don Yacktman.
//				Version 0.9.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <misckit/misckit.h>

@implementation MiscLinkedListNode

- initObject:this_object
	{
	id returnval=[super init];
	the_object=this_object;
	return returnval;
	}


- freeObject
	{
	[the_object release];
	the_object = nil;
	return self;
	}
	
	
- getObject
	{
	return the_object;
	}



- setObject: this_object;
	{
	id old_object = the_object;
	the_object=this_object; 
	return old_object;	
	}



- getNext;
	{
	return the_next_node;
	}



- setNext: this_node;
	{
	the_next_node=this_node;
	return the_next_node;	
	}



- getPrevious;
	{
	return the_previous_node;
	}



- setPrevious: this_node;
	{
	the_previous_node=this_node;
	return the_previous_node;	
	}
	
- (id)initWithCoder:(NSCoder *)aDecoder
	{
	[super initWithCoder:aDecoder];
	the_object=[[aDecoder decodeObject] retain];
			// reads in object and sets it to the_object;
// The linked list object will handle setting these up if the whole list
// was archived, so we won't do it here:
//	the_next_node=NXReadObject(stream); // nil unless whole list was archived
//	the_previous_node=NXReadObject(stream);
	return self;
	}
	
- (void)encodeWithCoder:(NSCoder *)aCoder	
	{
	[super encodeWithCoder:aCoder];
	[aCoder encodeObject:the_object];
}

// NXTransport protocol implementation:
- (void)encodeWithCoder:(NSPortCoder *)aPortCoder
{ // we don't encode pointers; they're handled by the list itself.
	[aPortCoder encodeObject:the_object isBycopy:YES];
}

- (id)initWithCoder:(NSPortCoder *)aPortCoder
{
	the_object = [aPortCoder decodeObject];
	return self;
}

#warning DO Conversion: if freeAfterEncoding was true use autorelease instead.
- replacementObjectForPortCoder:(NSPortCoder *)aPortCoder
{
	if ([aPortCoder isBycopy]) {
		*flagp = NO; // object will copy.
		return self; //encode object (copy it)
	}
	*flagp = NO; // object will copy.
	// super will encode the proxy otherwise
#warning DO Conversion: if freeAfterEncoding was true use autorelease instead.
	return [super replacementObjectForPortCoder:[aPortCoder connection]];
}

@end
