/*--------------------------------------------------------------------------
 * 	ListSorting
 *
 * 	Category Of:	List
 *
 * 	Declared In:	ListSorting.h
 *
 *
 *
 * 	$Log$
 *
 * Copyright (C) 1995 Vince Demarco <vdemarco@bou.shl.com>
 * Use is governed by the MiscKit license
 *--------------------------------------------------------------------------*/

#import <misckit/MiscListSorting.h>
/*#import <AppKit/nextstd.h>*/
#import <AppKit/NSText.h>




@implementation List (MiscListSorting)

- swap:(unsigned int)pos1 with:(unsigned int)pos2
{
    if ([self objectAt:pos1] && [self objectAt:pos2]){
	id temp	      = [self objectAt:pos1];
	dataPtr[pos1] = [self objectAt:pos2];
	dataPtr[pos2] = temp;
    }
    return self;
}

#define COMPARE_RESULT(A,B)	( ((A) < (B)) ? -1 : ( ((A) == (B)) ? 0 : 1) )
- (int)compareUsing:(SEL)aSelector objectAt:(unsigned int)pos1 :(unsigned int)pos2
{
    Method methodStruct;

    if ([self objectAt:pos1] && [self objectAt:pos2]){
	methodStruct = class_getInstanceMethod([[self objectAt:pos1] class],(SEL)aSelector);

	if (!aSelector || !methodStruct){
#warning StringConversion: NSStringFromSelector return value is an NSString; use [ cString] if needed, otherwise change the target type to an NSString.
	    NSLog(@"[%s:%s]: no get selector for object at %d", [[[self class] name] cString],NSStringFromSelector(_cmd),pos1);
	    return 0;
	}

	    /* Here i am checking the return type of the the method (Well I hope that I am checking)
	     *                                                      (the Return type of the method)
	     */
	switch(methodStruct->method_types[0]){
	case _C_ID:
	    {
		id val1 = ((id(*)(id,SEL))[[self objectAt:pos1] methodForSelector:aSelector])
		    ([self objectAt:pos1],aSelector);
		id val2 = ((id(*)(id,SEL))[[self objectAt:pos2] methodForSelector:aSelector])
		    ([self objectAt:pos2],aSelector);

		if ([val1 respondsToSelector:@selector(compare:)]){
		    return (int)[val1 perform:@selector(compare:) withObject:val2];
		}else{
#warning StringConversion: NSStringFromSelector return value is an NSString; use [ cString] if needed, otherwise change the target type to an NSString.
		    NSLog(@"[%s:%s]: can't compare object values of \"%s\":%u and \"%s\":%u", [[[self class] name] cString],NSStringFromSelector(_cmd),[[[val1 class] name] cString],pos1,[[[val2 class] name] cString],pos2);
		}
	    }
	    break;
	case _C_SHT:
	    {
		short int val1 = ((short int(*)(id,SEL))[[self objectAt:pos1] methodForSelector:aSelector])
		    ([self objectAt:pos1],aSelector);
		short int val2 = ((short int(*)(id,SEL))[[self objectAt:pos2] methodForSelector:aSelector])
		    ([self objectAt:pos2],aSelector);
		return COMPARE_RESULT(val1,val2);
		break;
	    }
	case _C_USHT:
	    {
		unsigned short int val1 = ((unsigned short int(*)(id,SEL))[[self objectAt:pos1] methodForSelector:aSelector])
		    ([self objectAt:pos1],aSelector);
		unsigned short int val2 = ((unsigned short int(*)(id,SEL))[[self objectAt:pos2] methodForSelector:aSelector])
		    ([self objectAt:pos2],aSelector);
		return COMPARE_RESULT(val1,val2);
		break;
	    }
	case _C_INT:
	    {
		int val1 = ((int(*)(id,SEL))[[self objectAt:pos1] methodForSelector:aSelector])
		    ([self objectAt:pos1],aSelector);
		int val2 = ((int(*)(id,SEL))[[self objectAt:pos2] methodForSelector:aSelector])
		    ([self objectAt:pos2],aSelector);
		return COMPARE_RESULT(val1,val2);
		break;
	    }
	case _C_UINT:
	    {
		unsigned int val1 = ((unsigned int(*)(id,SEL))[[self objectAt:pos1] methodForSelector:aSelector])
		    ([self objectAt:pos1],aSelector);
		unsigned int val2 = ((unsigned int(*)(id,SEL))[[self objectAt:pos2] methodForSelector:aSelector])
		    ([self objectAt:pos2],aSelector);
		return COMPARE_RESULT(val1,val2);
		break;
	    }
	case _C_LNG:
	    {
		long int val1 = ((long int(*)(id,SEL))[[self objectAt:pos1] methodForSelector:aSelector])
		    ([self objectAt:pos1],aSelector);
		long int val2 = ((long int(*)(id,SEL))[[self objectAt:pos2] methodForSelector:aSelector])
		    ([self objectAt:pos2],aSelector);
		return COMPARE_RESULT(val1,val2);
		break;
	    }
	case _C_ULNG:
	    {
		unsigned long int val1 = ((unsigned long int(*)(id,SEL))[[self objectAt:pos1] methodForSelector:aSelector])
		    ([self objectAt:pos1],aSelector);
		unsigned long int val2 = ((unsigned long int(*)(id,SEL))[[self objectAt:pos2] methodForSelector:aSelector])
		    ([self objectAt:pos2],aSelector);
		return COMPARE_RESULT(val1,val2);
		break;
	    }
	case _C_FLT:
	    {
		float val1 = ((float(*)(id,SEL))[[self objectAt:pos1] methodForSelector:aSelector])
		    ([self objectAt:pos1],aSelector);
		float val2 = ((float(*)(id,SEL))[[self objectAt:pos2] methodForSelector:aSelector])
		    ([self objectAt:pos2],aSelector);
		return COMPARE_RESULT(val1,val2);
		break;
	    }
	case _C_DBL:
	    {
		double val1 = ((double(*)(id,SEL))[[self objectAt:pos1] methodForSelector:aSelector])
		    ([self objectAt:pos1],aSelector);
		double val2 = ((double(*)(id,SEL))[[self objectAt:pos2] methodForSelector:aSelector])
		    ([self objectAt:pos2],aSelector);
		return COMPARE_RESULT(val1,val2);
		break;
	    }
	case _C_CHARPTR:
	    {
		const char *val1 = ((const char *(*)(id,SEL))[[self objectAt:pos1] methodForSelector:aSelector])
		    ([self objectAt:pos1],aSelector);
		const char *val2 = ((const char *(*)(id,SEL))[[self objectAt:pos2] methodForSelector:aSelector])
		    ([self objectAt:pos2],aSelector);
		if (val1 && val2){
		    return NSOrderStrings(val1,val2,YES,-1,NULL);
		}else{
		    if (val1){
			return 1;
		    }else{
			return -1;
		    }
		}
		break;

	    }
	default:
	    break;
	}
    }else{
#ifdef DEBUG
#warning StringConversion: NSStringFromSelector return value is an NSString; use [ cString] if needed, otherwise change the target type to an NSString.
	NSLog(@"[%s:%s]: no object at %d or %d", [[[self class] name] cString],NSStringFromSelector(_cmd),pos1,pos2);
#endif
    }
    return 0;
}

/*
 * This is O((n)(n)) which isn't great but it was easy to code.
 * it would be better to use a quicker sort routine instead
 * which is O(nlog(n))
 */
- sortUsing:(SEL)aSelector ascending:(BOOL)aBool
{
    unsigned int c,d;
    BOOL     found;
    int      compareValue;

    compareValue = (aBool ? -1 : 1);

    for (c = 1; c < [self count]; c++){
        found = NO;
        d = c-1;
        while (!found) {    /* move to left until find right place */
            if ([self compareUsing:aSelector objectAt:d+1 :d] == compareValue) {
                [self swap:d+1 with:d];
                d--;
            }else{
                found = YES;
	    }
        }
    }
    return self;
}

@end
