//
//	MiscMailSpeaker.m -- an API to NeXT's Mail.app
//		Created by msgwrap from MiscMail.msg, based on an article
//			posted to USENET by Andrew Stone.
//		Modified by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>
#import <misckit/MiscMailSpeaker.h>
#import <mach/mach.h>
#import <mach/message.h>
#import <servers/netname.h>

extern port_t name_server_port;
extern id NXResponsibleDelegate();

@implementation  MiscMailSpeaker:Speaker

-(int)openSend
{
	return [self selectorRPC:@"openSend" paramTypes:""];
}

-(int)setTo:(const char *)toField
{
	return [self selectorRPC:"setTo:" paramTypes:"c", toField];
}

-(int)setSubject:(const char *)subjectField
{
	return [self selectorRPC:"setSubject:" paramTypes:"c", subjectField];
}

-(int)setCc:(const char *)ccField
{
	return [self selectorRPC:"setCc:" paramTypes:"c", ccField];
}

-(int)setBody:(const char *)bodyField
{
	return [self selectorRPC:"setBody:" paramTypes:"c", bodyField];
}

-(int)deliver
{
	return [self selectorRPC:@"deliver" paramTypes:""];
}

-(int)openSend:(int *)sender
{
	return [self selectorRPC:"openSend:" paramTypes:"I", sender];
}

-(int)setTo:(const char *)toField inWindow:(int)sender
{
	return [self selectorRPC:"setTo:inWindow:" paramTypes:"ci", toField, sender];
}

-(int)setSubject:(const char *)subjectField inWindow:(int)sender
{
	return [self selectorRPC:"setSubject:inWindow:" paramTypes:"ci", subjectField, sender];
}

-(int)setCc:(const char *)ccField inWindow:(int)sender
{
	return [self selectorRPC:"setCc:inWindow:" paramTypes:"ci", ccField, sender];
}

-(int)setBody:(const char *)bodyField inWindow:(int)sender
{
	return [self selectorRPC:"setBody:inWindow:" paramTypes:"ci", bodyField, sender];
}

-(int)deliver:(int)sender
{
	return [self selectorRPC:"deliver:" paramTypes:"i", sender];
}

@end
