//
//	debug.m -- Stuff for having kit-wide debug flags.
//		Written by Don Yacktman Copyright 1995 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This code is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


// This sets up a system useable throughout the MiscKit to allow the
// programmer to turn diagnostics on and off.  It is up to individual
// MiscKit classes and functions to either take advantage of this
// facility or create its own (for finer granularity of debug info
// or to enable a more verbose diagnostic).

#import <objc/objc.h>

static int debug = NO;

int Misc_DebugState()				{ return debug; }	// what is it?
void Misc_SetDebugState(int flag)	{ debug = flag; }	// either way...
void Misc_DebugOn()					{ debug = 1; }		// YES
void Misc_DebugOff()				{ debug = 0; }		// NO
