//
//	_MiscIfPlaceHolder.h -- if status container used by MiscIfStack
//		Written by Don Yacktman Copyright (c) 1995 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


// A simple data container used to keep track of the status of nested ifs
// This is a private class used by the MiscIfStack class.
// This class is merely a container.  It doesn't have any functional logic.

#import <AppKit/AppKit.h>

typedef enum _Misc_IF_Type {
		MISC_IF_START = 0,
		MISC_IF_ELSE
} Misc_IF_Type;

// This is three state since if a nested if begins inside of an if
// that evaluated false, it _and_ it's else should not be executed.
// Thus we call them "dead".  So, any if or else blocks inside of
// an inactive if or else block are considered dead.
typedef enum _Misc_IF_Activity {
		MISC_IF_INACTIVE = 0,
		MISC_IF_ACTIVE,
		MISC_IF_DEAD
} Misc_IF_Activity;

@interface _MiscIfPlaceHolder : NSObject
{
	Misc_IF_Activity activity;
	Misc_IF_Type ifType;
}

- (Misc_IF_Activity)activity;
- setActivity:(Misc_IF_Activity)flag;

- (Misc_IF_Type)ifType;
- setIfType:(Misc_IF_Type)theType;

@end