//
//	_MiscMergeQuery.h -- GUI controller for obtaining user feedback
//		Written by Don Yacktman Copyright (c) 1995 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

// Not yet documented and the .nib file isn't yet available, so it doesn't
// really do you a lot of good yet.  It is easy enough to figure out,
// however, so...use it if you want to!

#import <misckit/misckit.h>

typedef enum _MiscMergeQueryStatus {
		MISC_QueryNone = 0,
		MISC_QueryInProgress,
		MISC_QueryAccepted,
		MISC_QueryCancelled
} MiscMergeQueryStatus;

@interface _MiscMergeQuery : MiscNibController
{
	MiscMergeQueryStatus status;
	id dataField;
	id button1;
	id button2;
	id titleField;
	id questionField;
}

+ new;
+ alloc;
- init;
- showWindow:sender;
- acceptQuery:sender;
- cancelQuery:sender;
- setQuestion:(const char *)aString;
- (void)setTitle:(NSString *)aString;
- setButtonTitles:(const char *)aString and:(const char *)bString;
- (NSString *)stringValue;
- (MiscMergeQueryStatus)status;
- (const char *)getLocalStringFor:(const char *)aString;

@end
