//
//	MiscPriorityQueue.h -- a Priority Queue
//		Written by Doug McClure Copyright (c) 1994 by Doug McClure.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>
#import <misckit/MiscSortedStorage.h>

@interface MiscPriorityQueue : MiscSortedStorage
{



}

- dequeue;
- enqueue:anObject withPriority:(int)priority;
- init;
- initCount:(unsigned int)numSlots;
- (BOOL)isEqual:anObject;
- (unsigned)highestPriority;
- (unsigned)lowestPriority;
- objectAt:(unsigned)index;
- (unsigned)priorityAt:(unsigned)index;
- makeObjectsPerform:(SEL)aSelector;
- makeObjectsPerform:(SEL)aSelector with:anObject;
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

@end
