//
//	MiscStaticPickList.h -- Unchangeable Pick List
//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 0.1.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


// This is almost the same as a PickList, but the .nib has no controls
// to change the list.  By using a different class name we can load a
// different .nib for free via the MiscNibController machinery.  We do
// duplicate the class methods to grab the picklist so that you can
// have a mutable and non-mutable version...

// Do NOT allocate these yourself; use the +findPickListNamed: method!

#import "MiscPickList.h"

@interface MiscStaticPickList : MiscPickList
{



}

+ findPickListNamed:(MiscString *)aName;
#error PopUpConversion: 'popUp:' is obsolete because it is no longer necessary.
#error PopUpConversion: 'popUp:' is obsolete because it is no longer necessary.
- (void)popUp:sender;
- addItemToList:(MiscString *)anItem value:(MiscString *)aValue;
- removeItemFromList:(MiscString *)anItem;

@end
