// Copyright (C) 1995
// Use is governed by the MiscKit license

#import <Foundation/NSObject.h>
#import <sys/time.h>

@interface Time : NSObject
{
	char*		timeString;
	time_t		myTime;
	struct tm	*timesPtr;
	BOOL		theAbrMode;
	char*		mNames[12];
	char*		mAbrNames[12];
	char*		dNames[7];
	char*		dAbrNames[7];
}

- (void)dealloc;
- init;
- initWithCurrentTime;
- initNames;

- (BOOL) abrMode;
- (BOOL) setAbrMode: (BOOL)mode;
- (long) indexOfDayName: (const char *)dayName;
- (const char *) nameOfDay: (long)dayIndex;
- (const char *) nameOfDay;
- (long) indexOfMonthName: (const char *)monthName;
- (const char *) nameOfMonth: (long)monthIndex;
- (const char *) nameOfMonth;
- (const char *) timeString;
- (const char *) timeZone;

- (const time_t *)getTime_t;
- (BOOL) leapYear: (long)year;
- (BOOL) leapYear;
- (long) daysInYear: (long)year;
- (long) daysInYear;
- (long) daysInMonth: (long)monthIndex forYear: (long)year;
- (long) daysInMonth: (long)monthIndex;
- (long) daysInMonth;
- (long) dayOfMonth;
- (long) dayOfWeek;
- (long) dayOfYear;
- (long) weekOfMonth;
- (long) year;
- (long) month;
- (long) week;
- (long) day;
- (long) hour;
- (long) minute;
- (long) second;
- (long) microSecond;

- _syncTimesStruct;
- resetTimeFromTM;
- setToCurrentTime;
- setTime: (Time *)aTimeObj;
- setTime_t:(time_t)num;
- setYears: (long)num;
- setMonths: (long)num;
- setWeeks: (long)num;
- setDays: (long)num;
- setHours: (long)num;
- setMinutes: (long)num;
- setSeconds: (long)numSeconds microSeconds: (long)numMicroSeconds;
- setSeconds: (long)numSeconds;
- setMicroSeconds : (long)num;

- addTime: (Time *)aTimeObj;
- addTime_t:(time_t)num;
- addYears: (unsigned)num;
- addMonths: (unsigned)num;
- addWeeks: (unsigned)num;
- addDays: (unsigned)num;
- addHours: (unsigned)num;
- addMinutes: (unsigned)num;
- addSeconds: (unsigned)num;
- addMicroSeconds: (unsigned)num;

- subtractTime: (Time *)aTimeObj;
- subtractTime_t:(time_t)num;
- subtractYears: (unsigned)num;
- subtractMonths: (unsigned)num;
- subtractWeeks: (unsigned)num;
- subtractDays: (unsigned)num;
- subtractHours: (unsigned)num;
- subtractMinutes: (unsigned)num;
- subtractSeconds: (unsigned)num;
- subtractMicroSeconds: (unsigned)num;

@end