/*
	* 	Net Image Filter -- a netpbm based image filtering service
	* 					by Marco Scheurer, Sen:te
	*
	* 	Version 1.0
	* 
	* 	Copyright 1995, Sente Sarl. All rights reserved.
	*
	*		This notice may not be removed from this source code.
	*
	*	This object is included in the MiscKit by permission from the author
	*	and its use is governed by the MiscKit license, found in the file
	*	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
	*	for a list of all applicable permissions and restrictions.
	*
*/	

#import <Foundation/NSObject.h>

@interface NetImageConverter:NSObject
{
	id binaryHash;
	id binPaths;

	char *dataBuf;
}

+ sharedInstance;

- (const char *) validateConverterPath:(const char *) aPotentialPath;
- (const char *) validateConverter:(const char *) aConverter
                       inDirectory:(const char *) aDirPath;
- (const char *) validateConverter:(const char *) aConverter
                          inBundle:aBundle;

- (const char *) filterPathFromData: (const char *) userData;

- anyToTIFF:pasteboard
   userData:(const char *)userData
	  error:(char **)errorMessage;

@end
