// Copyright (C) 1995 Steve Hayman
// Use is governed by the MiscKit license

#import "Controller.h"
#import <misckit/misckit.h>
#import "MiscViews.subproj/MiscIconWell.h"
#import <stdio.h>

@implementation Controller

#warning NotificationConversion: applicationDidFinishLaunching:(NSNotification *)notification (used to be appDidInit:) is an NSApplication notification method (used to be a delegate method); delegates of NSApplication are automatically set to observe this notification; subclasses of NSApplication do not automatically receive this notification
#warning NotificationConversion: applicationDidFinishLaunching:(NSNotification *)notification (used to be appDidInit:) is an NSApplication notification method (used to be a delegate method); delegates of NSApplication are automatically set to observe this notification; subclasses of NSApplication do not automatically receive this notification
- (void)applicationDidFinishLaunching:(NSNotification *)notification
{
    NSApplication *theApplication = [notification object];
    char bundleTemplates[MAXPATHLEN+1];
    FILE *p;
    MiscString *cmdline = [[MiscString alloc] init];
    MiscString *aFile = [[MiscString alloc] init];
        
    /*
     * Set up some defaults
     */
#error DefaultsConversion: the NXDefaultsVector type is obsolete. Construct a dictionary of default registrations and use the NSUserDefaults 'registerDefaults:' method
#error DefaultsConversion: the NXDefaultsVector type is obsolete. Construct a dictionary of default registrations and use the NSUserDefaults 'registerDefaults:' method
    static NXDefaultsVector myDefaults = {
	{"OpenInProjectBuilder", "YES"},
	{NULL}
    };
    
    [NSApp registerDefaults:myDefaults];
    
    templateList = [[MiscStringArray alloc] init];
    [templates setDelegate:templateList];
    templatePathnames = [[MiscStringArray alloc] init];
	    
#error StringConversion: This call to -[NXBundle getPath:forResource:ofType:] has been converted to the similar NSBundle method.  The conversion has been made assuming that the variable called bundleTemplates will be changed into an (NSString *).  You must change the type of the variable called bundleTemplates by hand.
    bundleTemplates = [[NSBundle mainBundle] pathForResource:@"QuickProjectTemplates" ofType:@""];
    
    /*
     * Run a simple command to retrieve a list of all the possible
     * project templates.
     * TODO - use a MiscSubprocess here (maybe - might be overkill)
     */
    /*
     * Use ls rather than echo just so we get output files one per line.
     */
    [cmdline catFromFormat:"/bin/ls -d ~/Library/QuickProjectTemplates/* /LocalLibrary/QuickProjectTemplates/* %s/*", bundleTemplates];
    
	
    p = popen([[cmdline stringValue] cString], "r");
    
    if ( p ) {
	// read filenames, add to the lists.
	[aFile setStringValue:@""];
	while ( [aFile fgets:p keepNewline:NO] != EOF ) {
	    
	    // Keep a list of full pathnames in templatePathnames;
	    // keep a parallel list of filenames in templateList, which
	    // is what's displayed in the browser.
	    [templatePathnames addString:[[aFile stringValue] cString]];
	    [templateList addString: 
		[[aFile fileName] stringValueAndFree]];
	    
	    [aFile setStringValue:@""];
	}
	[templates loadColumnZero];
	[self showSelectedPath:templates];

	pclose(p);
    } else {
	NSRunAlertPanel([[NSProcessInfo processInfo] processName], @"Couldn't make list of project templates", @"", nil, nil);
    }
    
    /*
     * And finally, select the Name text as a convenience.
     */
    [name selectText:self];
    
    /*
     * Register to receive TIFF services.   So you can use Grab to get
     * an icon, which we'll make into an image and paste into the
     * icon well.
     */
    {
	const char *returnTypes[2];
	returnTypes[0] = [NSTIFFPboardType cString];
	returnTypes[1] = NULL;
#error StringConversion: Services types are now stored in an NSArray of NSStrings (used to use NULL-terminated char**).  Change your variable declaration.
	[NSApp registerServicesMenuSendTypes:NULL returnTypes:returnTypes];
    }
}


/*
 * Save the icon, if there is one, to a temporary file and return
 * a MiscString containing its pathname.
 */
 
- saveIconToTempFile
{
    MiscString *filename;
    NXStream *str;
    if ( ! [iconWell image] )
	return nil;
	
    filename = [[MiscString alloc] init];
    [filename catFromFormat:"/tmp/icon%d.tiff", getpid()];
    
    str = NXOpenMemory(NULL, 0L, NX_READWRITE);
    str = [[iconWell image] TIFFRepresentation];
    NXSaveToFile( str, [[filename stringValue] cString] );
    NXCloseMemory(str, NX_FREEBUFFER);
    
    return filename;
}
- saveAs:sender
{
#warning FactoryMethods: [SavePanel savePanel] used to be [SavePanel new].  Save panels are no longer shared.  'savePanel' returns a new, autoreleased save panel in the default configuration.  To maintain state, retain and reuse one save panel (or manually re-set the state each time.)
    id sp = [NSSavePanel savePanel];
    MiscString *cmd = [[MiscString alloc] init];
    const char *filename;
    const char *templatePath;
    int pos;
    MiscSubprocess *proc;
    NSBundle *mainBundle = [NSBundle mainBundle];
    id selectionList = [[List alloc] init];
    MiscString *iconFileName;
    
    if ( ![name stringValue] || ([[[name stringValue] cString] isEqualToString:@""]) ) {
	NSRunAlertPanel([[NSProcessInfo processInfo] processName], @"Please supply a name for your project.", @"", nil, nil);
	return nil;
    }
    
    
    if ( [sp runModalForDirectory:@"" file:@""] ) {
	filename = [[sp filename] cString];
	destinationFile = [MiscString newWithString:filename];
	
	// Save the icon image - if there is one - in a file so that
	// we can pass its pathname to copy_project.
	
	iconFileName = [self saveIconToTempFile];

	// Now copy the chosen project.  Figure out the index of
	// the selected cell, and ask the templateList for the full
	// string value at that position -not just the basename 
	// displayed in the browser	
	pos = [[templates matrixInColumn:0] selectedRow];
	templatePath = [templatePathnames stringAt:pos];
	
	// copy_project  template_dir dest_dir template_name appname
	
	[cmd sprintf:"%s/copy_project %s %s %s %s %s", 
	    [[mainBundle directory] cString],
	    templatePath,
	    [[sp filename] cString],
	    [[templates stringValue] cString],
	    [[name stringValue] cString],
	    iconFileName ? [[iconFileName stringValue] cString] : ""];

	

	[iconFileName release];
		
	/*
	 * Fire up a MiscSubprocess object to execute the copy command.
	 */

	proc = [[MiscSubprocess alloc]
	    init:[[cmd stringValue] cString]
	    withDelegate:self];
    }
    [cmd release];
    [selectionList release];
    return self;

}
/*
 * This is the target of the browser.   The browser shows only the
 * basename of the project template you've chosen; display its full
 * path as well.  (Except we replace the home directory with "~" since it
 * takes up less space on the screen.)
 */

- showSelectedPath:sender
{
    int selection = [[sender matrixInColumn:0] selectedRow];
    id templatePath = [MiscString newWithString: [templatePathnames stringAt:selection]];
    
    [templatePath replaceHomeWithTilde];	// looks nicer. less room too.
    [selectedTemplatePath setStringValue:[NSString stringWithCString:[templatePath stringValueAndFree]]];
    return self;
}


/*
 * Subprocess delegate methods
 */
- subprocess:sender done:(int)status :(MiscSubprocessEndCode)code
{
    MiscString *projectFile;
    [sender terminate:self];
    [sender release];
    
    if ( code == Misc_Exited && status == 0 ) {
	/*
	 * message Workspace here to open the PB.project
	 */
	
	
	
	if ( [NSApp defaultBoolValue:"OpenInProjectBuilder"] ) {
	
	    /*
	    * Figure out the path to the PB.project file
	    */
	    projectFile = [destinationFile copy];
	    [projectFile cat:"/PB.project"];

	    [[[self log:"Opening project file "]
		log:[[projectFile stringValue] cString]]
		log:"\n"];

	    [[NSWorkspace sharedWorkspace] openFile:[projectFile stringValue]];
	    [projectFile release];
	}
	NSRunAlertPanel([[NSProcessInfo processInfo] processName], @"Project created succesfully.", @"OK", nil, nil);
    }
    return self;
}
- subprocess:sender output:(const char *) buffer
{
    [self log:buffer];

    return self;
}
- subprocess:sender stderrOutput:(const char *)buffer
{
    [self log:buffer];
    return self;
}
- subprocess:sender error:(const char *)errorString
{
    [self log:"Error: "];
    [self log:errorString];

    return self;
}

- log:(const char *)str
{
    int len;
    if ( ! processLog ) 
	[NSBundle loadNibNamed:@"SubprocessLog.nib" owner:self];
    len = [[processLog text] length];
    [processLog setSelectedRange:NSMakeRange(len, len - (len))];
    [processLog replaceSel:[NSString stringWithCString:str]];
    [processLog scrollSelToVisible];
    [[processLog window] makeKeyAndOrderFront:self];
    return self;
}

/*
 * Preferences handling
 */

- showPreferences:sender
{
    if ( ! prefsPanel ) {
	[NSBundle loadNibNamed:@"Preferences.nib" owner:self];
	[openInPBSwitch setState:[NSApp defaultBoolValue:"OpenInProjectBuilder"]];
    }
	
    [self revert:self];
    [prefsPanel makeKeyAndOrderFront:self];
    return self;
}

- ok:sender
{
    [NSApp setBoolDefault:"OpenInProjectBuilder" to: [openInPBSwitch state]];
    
    return self;
}

- revert:sender
{
    [openInPBSwitch setState:[NSApp defaultBoolValue:"OpenInProjectBuilder"]];
    
    return self;
}


/*
 * A couple of methods that support doing Services -> Grab
 * so we can pick up a tiff and use it as our icon
 */

- validRequestorForSendType:(NSString *)typeSent returnType:(NSString *)typeReturned
{
    if ( typeSent == NULL && [typeReturned isEqualToString:NSTIFFPboardType] )
	return self;
    return nil;
}

- (BOOL)readSelectionFromPasteboard:(NSPasteboard *)pb
{
    id image = [[NSImage alloc] initWithPasteboard:pb];
    /*
     * what we should do here is save the image to a temp file,
     * and tell the icon well that that's the filename.
     * but this is quicker for now even though not what we want.
     */
    [iconWell setImage:image];
    return YES;
}

/*
 * Some more methods that allow pasting a TIFF selection.
 */

- (void)paste:(id)sender
{
    id pb = [NSPasteboard generalPasteboard];
    BOOL tiffFound = NO;
    const NXAtom *types;
    NSImage *pasteImage;
    
#error StringCoversion: return type of types is now an NSArray of NSStrings (used to be NXAtom *).  Change your variable declaration.
#error StringCoversion: return type of types is now an NSArray of NSStrings (used to be NXAtom *).  Change your variable declaration.
    types = [pb types];
    /*
     * is there TIFF on the pasteboard?
     */
    if ( types ) {
	while ( *types ) {
	    if ([[NSString stringWithCString:*types++] isEqualToString:NSTIFFPboardType] ) {
		tiffFound = YES;
		break;
	    }
	}
    }

    if ( ! tiffFound )
	return nil;
	
    pasteImage = [[NSImage alloc] initWithPasteboard:pb];
    [iconWell setImage:pasteImage];
}

@end
