/* Text_more.m				 
 *
 * This category makes dealing with the Text object easier. 
 * See the docu for details.
 *
 * For interface-info see the header file. The comments in this file mostly
 * cover only the real implementation details.
 *
 * Written by: 		Thomas Engel
 * Created:    		30.01.1995 (Copyleft)
 * Last modified: 	30.01.1995
 * Copyright (C) 1995 Thomas Engel
 */

// The following define is a fake. Looks like NeXT...but it is a cheatmode
// action.
// We don't have a RTFD paste type. But I really need one !

#define NXRTFDPboardType NXUniqueString("NeXT RTFD pasteboard type")


#import "Text_more.h"

@implementation NSText(More)

- copyTo:aPasteboard
{
	NXAtom textTypes[5];

	if( (![self isRichText]) )
	{
		textTypes[0] = [NSStringPboardType cString];
		textTypes[1] = NULL;
	}
	// In the other case we will cheat. The RTFD type was NEVER defined by
	// NeXT. But we will use it...it works. (see the define)

	else
	{
		textTypes[0] = NXRTFDPboardType;
		textTypes[1] = [NSTIFFPboardType cString];
		textTypes[2] = [NSRTFPboardType cString];
		textTypes[3] = [NSStringPboardType cString];
		textTypes[4] = NULL;
	}
#warning StringConversion: 'types' in 'writeSelectionToPasteboaed:types' is now an NSArray (used to be NXAtom *). Change your variable declaration.
#warning StringConversion: 'types' in 'writeSelectionToPasteboaed:types' is now an NSArray (used to be NXAtom *). Change your variable declaration.
	[self writeSelectionToPasteboard:aPasteboard types:textTypes];
	return self;
}

- cutTo:aPasteboard
{
	[self copyTo:aPasteboard];
	[self delete:self];
	return self;
}

- pasteFrom:aPasteboard
{
	[self readSelectionFromPasteboard:aPasteboard];
	return self;
}

@end

/*
 * History: 30.01.95 Buh
 *			
 *
 * Bugs: - ...
 */