/*	TDNodeWell.h

	Copyright 1996 Uwe Hoffmann.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

	Version 2 (August 1996)
*/

#import <AppKit/AppKit.h>
#import <Foundation/Foundation.h>

@class MiscDiagramTree, MiscHitPath;

@interface TDNodeWell:NSView
{
@private
    	NSImage *dragImage;
	MiscDiagramTree *dragNode;
	NSRect dragRect;
	NSPoint dragOffset, nodePos;
	NSSize nodeSize;
	MiscHitPath *hitPath;
	id numberControl;
}

- (void)draggedImage:(NSImage *)image beganAt:(NSPoint)screenPoint;
- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)flag;
- (void)draggedImage:(NSImage *)image endedAt:(NSPoint)screenPoint deposited:(BOOL)flag;

- (unsigned int)draggingEntered:sender;
- (unsigned int)draggingUpdated:sender;
- (BOOL)performDragOperation:sender;

@end
